
#define small_number 1.0e-10

/* possible graphics modes:
 G320x200x16
 G640x200x16
 G640x350x16
 G640x480x16
 G320x200x256
 G320x240x256
 G320x400x256
 G360x480x256
 G640x480x2
 G640x480x256
 G800x600x256 
 G1024x768x256 */


/* rgb values for primary colors in 256 color mode:
white:   r=g=b=63
blue:    r=g=0,b=63
green:   r=0,g=63,b=0
red:     r=63,g=b=0
yellow:  r=g=63,b=0
magenta: r=63,g=0,b=63
cyan:    r=0,g=b=63
*/


int impedance_mode;
float Rs,ln_10;
int tic_offset;
/* plot_mode: 1=time plot, 2=amp vs. freq, 3=phase vs. freq plot */
int plot_mode,THD;
float THD_v1,THD_v2;
/* set of plotting variables for time plots: */
int ndivht,ndivvt,n_ht,n_vt,extend_ticst,minxt,minyt,maxxt,maxyt;
long int i_mint,i_maxt;
int interpolatet,int_divt;
long int nptst;
float deltaht,deltavt,deltah_nt,deltav_nt,xmint,xmaxt,ymint,ymaxt,xmin_axist;
float xmax_axist,ymin_axist,ymax_axist,deltat,strt_valt;

long int i_truncatet1,i_truncatet2;
int iavg_wfms;

const int TEXTHEIGHT_PIX = 8; /* number of pixels in a single screen character */
const int TEXTWIDTH_PIX = 8; /* number of pixels in a single screen character */



/* set of plotting variables for amplitude vs. frequency plots: */
int ndivha,ndivva,n_ha,n_va,extend_ticsa,minxa,minya,maxxa,maxya;
long int i_mina,i_maxa;
long int i_truncatea;
int interpolatea,int_diva;
long int nptsa;
float deltaha,deltava,deltah_na,deltav_na,xmina,xmaxa,ymina,ymaxa,xmin_axisa;
float xmax_axisa,ymin_axisa,ymax_axisa,strt_vala;

/* set of plotting variables for phase vs. frequency plots: */
int ndivhp,ndivvp,n_hp,n_vp,extend_ticsp,minxp,minyp,maxxp,maxyp;
long int i_minp,i_maxp;
long int i_truncatep;
int interpolatep,int_divp;
long int nptsp;
float deltahp,deltavp,deltah_np,deltav_np,xminp,xmaxp,yminp,ymaxp,xmin_axisp;
float xmax_axisp,ymin_axisp,ymax_axisp,strt_valp;
float Tg;

/* some variables needed for the X windows routines */
#define NUM_PRIMARY_COLORS 7
Display *display;  /* Server or display to which a connection will be made */
int screen;        /* Screen number to use on that display */
Screen *screen_pointer;
Window win;
XImage *save_image_1,*save_image_2;  /* used to save & restore parts of image */
XEvent event;      /* The event data structure */
GC gc1;       /* Graphics context data structure */
GC *gc_id;
XGCValues gs1; /* Graphics context settings */
KeySym keysym_value; /* Stores symbol corresponding to key pressed */
Colormap colormap_screen;
XRectangle clip_rectangle[1];
char *color_name[NUM_PRIMARY_COLORS];
Colormap colormap_val;
XColor *exact_ret,*screen_ret;
Window *root_ret,*child_ret;
unsigned int *mask_ret;
unsigned long pixel_values[NUM_PRIMARY_COLORS];
int maxx,maxy,maxcolor,i,color;
int graphics_window_created=0;
Window *geom_root_ret;
int *geom_x_ret,*geom_y_ret;
unsigned int *geom_width_ret,*geom_height_ret,*geom_border_width_ret,*geom_depth_ret;
XEvent event; /* The event data structure for capturing keypresses, etc. */



void plot_results(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,
long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,float *THD_v,
long double plot_array[],int color);

void setup_horiz_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,long int *i_truncate,
int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,float *xmax,
float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,float *ymin_axis,
float *ymax_axis,float *delta,float *strt_val,long double plot_array[]);


void setup_vert_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,
int *extend_tics,int *minx,int *miny,int *maxx,int *maxy,
long int *i_min,long int *i_max,long int *i_truncate,int *interpolate,
int *int_div,int *plot_mode,int *THD,long int *npts,float *deltah,
float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,
float *xmax_axis,float *ymin_axis,float *ymax_axis,float *delta,
float *strt_val,long double plot_array[]);


void draw_horiz_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,
int *extend_tics,int *minx,int *miny,int *maxx,int *maxy,long int *i_min,
long int *i_max,long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,
int *THD,long int *npts,float *deltah,float *deltav,float *deltah_n,
float *deltav_n,float *xmin,float *xmax,float *ymin,float *ymax,
float *xmin_axis,float *xmax_axis,float *ymin_axis,float *ymax_axis,
float *delta,float *strt_val,long double plot_array[],int color);


void draw_vert_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,
int *extend_tics,int *minx,int *miny,int *maxx,int *maxy,long int *i_min,
long int *i_max,long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,
int *THD,long int *npts,float *deltah,float *deltav,float *deltah_n,
float *deltav_n,float *xmin,float *xmax,float *ymin,float *ymax,
float *xmin_axis,float *xmax_axis,float *ymin_axis,float *ymax_axis,
float *delta,float *strt_val,long double plot_array[],int color);


void draw_cursor_vert(long int ix,int dotted,int id,int *minx,int *miny,
int *maxx,int *maxy,float *delta,float *strt_val,float *xmin_axis,
float *xmax_axis,int color);

void erase_cursor_vert(long int ix,int id,int *minx,int *miny,int *maxx,
int *maxy,float *delta,float *strt_val,float *xmin_axis,float *xmax_axis);

void find_pixel(long int i_func,int *i_pix,int *minx,int *maxx,
float *delta,float *strt_val,float *xmin_axis,float *xmax_axis);

void plot(int *init_graph,int *ndivh,int *ndivv,
int *n_h,int *n_v,int *extend_tics,int *minx,int *miny,int *maxx,
int *maxy,long int *i_min,long int *i_max,long int *i_truncate,int *interpolate,
int *int_div,int *plot_mode,int *THD,long int *npts,float *deltah,
float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,
float *THD_v,long double plot_array[],int color);

void setup_plot(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,
long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,
int *THD,long int *npts,float * deltah,float *deltav,float *deltah_n,
float *deltav_n,float * xmin,float *xmax,float *ymin,float *ymax,
float *xmin_axis,float * xmax_axis,float *ymin_axis,float *ymax_axis,
float *delta,float *strt_val);


void display_value_c1(int loc,int minx,int maxx,int maxy,int i_min,
float value,float delta,float strt_val);

void display_value_c2(int loc,int minx,int maxx,int maxy,
int i_min,float single,float delta,float strt_val);

void display_THD(int *minx,int *maxx,int *maxy,float *THD_value);

void display_iavg(int iavg_cnt,int minx,int maxx,int maxy);

void tg_adjust(int plot_mode,long int i,float plot_in,float *plot_value);

void resample(float * t,long int * npts,float *delt,long double h[],
float *result,double pi);

void itoa(int n, char s[]);
void reverse(char s[]);

int textwidth(int max_length,char *text);

float frac(float float_number);
int truncfi(float float_number);

void Rectangle(int x1,int y1r,int x2,int y2r,int color);

long int Round(double real_n); 

void dotted_line(int x1, int y1d, int x2, int y2d, int color);

void graphics_window_init(void);

void graphics_window_end(void);

void setupGC(GC *gc_id,XGCValues *gs_val,int color);






void setupGC(GC *gc_id,XGCValues *gs_val,int color)
/* Set up graphics context resources in the display server */
{

  *gc_id = XCreateGC(display, win, 0, gs_val); /* 0 -> use defaults */
  /* Now override some of the defaults */
  XSetForeground(display, *gc_id,pixel_values[color-1]); 
  XSetBackground(display, *gc_id, BlackPixel(display, screen));
  XSetLineAttributes(display, *gc_id, 1, LineSolid, CapRound, JoinRound);
  XSetFillStyle(display,*gc_id,FillSolid);
}






void graphics_window_init(void)
{

if(!graphics_window_created)
{ /* !graphics_window_created */
  color_name[0] = "white";
  color_name[1] = "blue";
  color_name[2] = "green";
  color_name[3] = "red";
  color_name[4] = "yellow";
  color_name[5] = "magenta";
  color_name[6] = "cyan";

/* Even though XQueryPointer returns values in the root_ret and child_ret
   structures, have to allocate memory for them externally: */
  root_ret = malloc(sizeof(Window));
  child_ret = malloc(sizeof(Window));
  mask_ret = malloc(sizeof(unsigned int));

/* Even though X functions return values in the exact_ret and screen_ret
   structures, have to allocate memory for them externally: */
  exact_ret = malloc(sizeof(XColor));
  screen_ret = malloc(sizeof(XColor));
  geom_x_ret = malloc(sizeof(int));
  geom_y_ret = malloc(sizeof(int));
  geom_width_ret = malloc(sizeof(unsigned int));
  geom_height_ret = malloc(sizeof(unsigned int));
  geom_border_width_ret = malloc(sizeof(unsigned int));
  geom_depth_ret = malloc(sizeof(unsigned int));
  geom_root_ret = malloc(sizeof(Window));

  /* Attempt to connect to the X server and use the default screen */
  if ((display = XOpenDisplay(NULL)) == NULL)
  {
    perror("Can't connect to server");
    exit(1);
  }
  screen = DefaultScreen(display);
  screen_pointer = XDefaultScreenOfDisplay(display);

/* Define maximum extents for the window */
// (these are now read in vc.in):
//  maxx = 638;
//  maxy = 450;
  maxcolor = NUM_PRIMARY_COLORS; /* maximum number of defined primary colors */

  /* Create a window */

  win = XCreateSimpleWindow(display, RootWindow(display, screen),
          0, 0, maxx, maxy, 1, BlackPixel(display, screen),
          BlackPixel(display, screen));

  /* Set up which event types the window will handle */
  XSelectInput(display, win,KeyPressMask | ExposureMask);

  colormap_val = XDefaultColormapOfScreen(screen_pointer);
  for(i=0;i<NUM_PRIMARY_COLORS;i++)
  {
    XAllocNamedColor(display,colormap_val,color_name[i],screen_ret,exact_ret);
    pixel_values[i] = screen_ret->pixel;
  };

/* Set up graphics context: */
  color = 1;
  setupGC(&gc1,&gs1,color);

  XMapWindow(display, win);

  graphics_window_created = 1;

} /* !graphics_window_created */

}; /* end graphics_window_init */





void graphics_window_end(void)
{
if(graphics_window_created)
{
/* clean up */
//
//  for(i=0;i<NUM_PRIMARY_COLORS;i++)
//  {
//    XFreeColors(display,colormap_val,&pixel_values[i],1,AllPlanes);
//  };
//  free(root_ret);
//  free(child_ret);
//  free(mask_ret);
//  free(exact_ret);
//  free(screen_ret);
//  free(geom_x_ret);
//  free(geom_y_ret);
//  free(geom_width_ret);
//  free(geom_height_ret);
//  free(geom_border_width_ret);
//  free(geom_depth_ret);
//  free(geom_root_ret);
//
/* Apparently only need to call XCloseDisplay to clean up: */
  XCloseDisplay(display);
//
//  XFreeGC(display,gc1);
//  XDestroyWindow(display,win);
//
  graphics_window_created=0;
}; /* graphics_window_created */
};





void dotted_line(int x1, int y1, int x2, int y2, int color)
{

float dot_length;
float length,x_step,y_step,ratio;
float xl1,xl2,yl1,yl2;
int i_alt;

dot_length = 2.0;
XSetForeground(display,gc1,pixel_values[color-1]); 

length = sqrt( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) );
if(length>0.0)
{
  ratio = dot_length / length;
  if(ratio>1.0) ratio = 1.0;
  x_step = (x2-x1)*ratio;
  y_step = (y2-y1)*ratio;
  xl1 = x1;
  yl1 = y1;
  i_alt = 1;
  while( ((xl2 = xl1+x_step) <= x2) && ((yl2 = yl1+y_step) <= y2) )
  {
    if(i_alt>0)
    {
      XDrawLine(display,win,gc1,xl1,yl1,xl2,yl2);
    };
    if(i_alt==1)
    {
      i_alt = -1;
    }
    else
    {
      i_alt = i_alt + 1;
    };
    xl1 = xl2;
    yl1 = yl2;
  };
  XDrawLine(display,win,gc1,xl1,yl1,x2,y2);
} /* length>0.0 */


} /* end dotted_line */





/* -------------------------------------------------------------------- */
/*
  The following routine draws a rectangle.
*/

void Rectangle(int x1,int y1r,int x2,int y2r, int color)
{

  XSetForeground(display,gc1,pixel_values[color-1]); 
  XDrawLine(display,win,gc1,x1,y1r,x2,y1r);
  XDrawLine(display,win,gc1,x2,y1r,x2,y2r);
  XDrawLine(display,win,gc1,x2,y2r,x1,y2r);
  XDrawLine(display,win,gc1,x1,y2r,x1,y1r);

};
/* --------------------------------------------------------------------- */






/* ----------------------------------------------------------------------- */
/*
This routine returns the fractional part of float_number. Note that if
float_number is negative the fractional part will also be negative.
*/

float frac(float float_number)
{

long int integral_part;
float float_whole_number,float_return;


  integral_part = float_number; 
  float_whole_number = integral_part;
  float_return = float_number - float_whole_number;
  return float_return;

};
/* ------------------------------------------------------------------------ */





/* ------------------------------------------------------------------------ */
/*
The following routine truncates float_number toward zero.
*/

int truncfi(float float_number)
{

int integral_part;

  integral_part = float_number;
  return integral_part;

};
/* ------------------------------------------------------------------------- */





/* ------------------------------------------------------------------------ */
int textwidth(int max_length,char *text)
{

int i_text,textwidth_return;

  i_text = -1;
  do
  {
    i_text = i_text + 1;
  }
  while( (text[i_text] != '\0') && (i_text < max_length) );

  textwidth_return = i_text * TEXTWIDTH_PIX;
  return textwidth_return;

};
/* ------------------------------------------------------------------------ */
  






/*------------------------------------------------------------------------ */
void itoa(int n, char s[])
{
  int i,sign;

  if((sign=n)<0)
  n = -n; /* record sign and make n positive */
  i = 0;
  do  /* generate digits in reverse order  */
  {
    s[i++] = n % 10 + '0'; /* get next digit */
  }
  while((n /= 10) > 0); /* delete it */
  if(sign < 0) s[i++] = '-';
  s[i] = '\0';
  reverse(s);
};
/* ------------------------------------------------------------------------ */







/* ------------------------------------------------------------------------ */
void reverse(char s[])
{
  int c,i,j;

  for(i=0, j=strlen(s)-1; i < j; i++, j--)
  {
    c = s[i];
    s[i] = s[j];
    s[j] = c;
  }
};
/* ----------------------------------------------------------------------- */








/* ---------------------------------------------------------------------- */
void plot_results(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,
long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,float *THD_v,
long double plot_array[],int color)
{


char ascii_plot,ascii_trnc;
int quit_pr,quit_trnc;
int init_graph;
int trnc_flag;
int i_curs;
int quit_curs;
char ascii_curs;
long int loc_curs[2];
int selct_curs;
int curs_app[2];
long int accel_mode;
float plot_value;



  quit_pr = 0;
  init_graph = 0;

do
{  /* main do loop */

  plot(&init_graph,ndivh,ndivv,n_h,n_v,extend_tics,
  minx,miny,maxx,maxy,i_min,i_max,i_truncate,interpolate,int_div,
  plot_mode,THD,npts,deltah,deltav,deltah_n,deltav_n,xmin,xmax,
  ymin,ymax,xmin_axis,xmax_axis,ymin_axis,ymax_axis,delta,strt_val,
  THD_v,&plot_array[0],color);

  XNextEvent(display, &event);
  if(event.type==KeyPress)
  {
//    ascii_plot=XKeycodeToKeysym(display,event.xkey.keycode,0);
    {
      int keysyms_per_keycode_return;
      ascii_plot = *XGetKeyboardMapping(display,event.xkey.keycode,1,&keysyms_per_keycode_return);
    }

  };

  if( toupper(ascii_plot) == 'Q' )
  {
    quit_pr = 1;
  };

  if(toupper(ascii_plot)=='C')
  {  /* section for vertical cursors */
/*
 To enable cursors, C must first be typed. The arrow keys are then
 used to move the cursors, while T toggles between cursors. D resets
 cursors to the default positions. Q exits the cursor section. Upon
 exiting, the plot will be re-defined between the cursor values, if
 non-default settings have been setup.
 'A' accelerates the cursor movement, 'B' decelerates cursor movement,
 when using the arrow keys.
*/
    quit_curs = 0;
    accel_mode = 0; /* used to speed up the effect of the arrow keys */

/* initialize cursor positions: */
    loc_curs[0] = *i_min;
    loc_curs[1] = *i_max;

    draw_cursor_vert(loc_curs[0],0,1,minx,miny,maxx,maxy,delta,strt_val,
    xmin_axis,xmax_axis,color); /* draw c1 (solid line) */

    draw_cursor_vert(loc_curs[1],1,2,minx,miny,maxx,maxy,delta,strt_val,
    xmin_axis,xmax_axis,color); /* draw c2 (dotted line) */

    tg_adjust(*plot_mode,loc_curs[0]-1,plot_array[loc_curs[0]-1],
      &plot_value);

    display_value_c1(loc_curs[0],*minx,*maxx,*maxy,*i_min,
    plot_value,*delta,*strt_val);

    tg_adjust(*plot_mode,loc_curs[1]-1,plot_array[loc_curs[1]-1],
      &plot_value);

    display_value_c2(loc_curs[1],*minx,*maxx,*maxy,*i_min,
    plot_value,*delta,*strt_val);

    selct_curs = 1; /* start with c1 selected */
    curs_app[0] = 0; /* solid line for c1 */
    curs_app[1] = 1; /* dotted line for c2 */
    do  /* section to move cursors */
    {

      XNextEvent(display, &event);
      if(event.type==KeyPress)
      {
//        ascii_curs=XKeycodeToKeysym(display,event.xkey.keycode,0);
        {
          int keysyms_per_keycode_return;
          ascii_curs = *XGetKeyboardMapping(display,event.xkey.keycode,1,&keysyms_per_keycode_return);
        }

      };

      if(toupper(ascii_curs)=='A')
      {
        if(accel_mode==0)
        {
          accel_mode=10;
        }
        else
        {
          if(accel_mode<1000)
          {
            accel_mode = accel_mode * 10;
          }
        }
      };

      if(toupper(ascii_curs)=='B')
      {
        accel_mode = accel_mode/10;
      } 

      if(toupper(ascii_curs) == 'D')
      {  /* go back to default cursor positions */

        erase_cursor_vert(loc_curs[0],1,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis);

        erase_cursor_vert(loc_curs[1],2,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis);

        *i_min = 1;
        if(*plot_mode>1)
        {
          *i_max = (*npts/2) + 1;
        }
        else
        {
          *i_max = *npts;
        };

        *xmin = *strt_val;
        *xmax = (*i_max-1) * *delta + *strt_val;

        setup_horiz_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
        maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
        deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
        xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);

        setup_vert_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
        maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
        deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
        xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);

        plot(&init_graph,ndivh,ndivv,n_h,n_v,extend_tics,
          minx,miny,maxx,maxy,i_min,i_max,i_truncate,interpolate,int_div,
          plot_mode,THD,npts,deltah,deltav,deltah_n,deltav_n,xmin,xmax,
          ymin,ymax,xmin_axis,xmax_axis,ymin_axis,ymax_axis,delta,strt_val,
          THD_v,&plot_array[0],color);
        loc_curs[0] = *i_min;
        loc_curs[1] = *i_max;

        draw_cursor_vert(loc_curs[0],curs_app[0],1,minx,miny,maxx,maxy,delta,
        strt_val,xmin_axis,xmax_axis,color);

        draw_cursor_vert(loc_curs[1],curs_app[1],2,minx,miny,maxx,maxy,delta,
        strt_val,xmin_axis,xmax_axis,color);

        tg_adjust(*plot_mode,loc_curs[0]-1,plot_array[loc_curs[0]-1],
          &plot_value);

        display_value_c1(loc_curs[0],*minx,*maxx,*maxy,*i_min,
        plot_value,*delta,*strt_val);

        tg_adjust(*plot_mode,loc_curs[1]-1,plot_array[loc_curs[1]-1],
          &plot_value);

        display_value_c2(loc_curs[1],*minx,*maxx,*maxy,*i_min,
        plot_value,*delta,*strt_val);
      };

      if(toupper(ascii_curs) == 'T')
      {  /* toggle cursor selection */
        if(selct_curs==1)
        {  /* select c2 */
          selct_curs = 2;
          erase_cursor_vert(loc_curs[0],1,minx,miny,maxx,maxy,delta,strt_val,
          xmin_axis,xmax_axis);

          draw_cursor_vert(loc_curs[0],1,1,minx,miny,maxx,maxy,
          delta,strt_val,xmin_axis,xmax_axis,color);

          erase_cursor_vert(loc_curs[1],2,minx,miny,maxx,maxy,delta,strt_val,
          xmin_axis,xmax_axis);

          draw_cursor_vert(loc_curs[1],0,2,minx,miny,maxx,maxy,
          delta,strt_val,xmin_axis,xmax_axis,color);

          curs_app[1] = 0;
          curs_app[0] = 1;
        }
        else
        {  /* select c1 */
          selct_curs = 1;
          erase_cursor_vert(loc_curs[0],1,minx,miny,maxx,maxy,delta,strt_val,
          xmin_axis,xmax_axis);

          draw_cursor_vert(loc_curs[0],0,1,minx,miny,maxx,maxy,
          delta,strt_val,xmin_axis,xmax_axis,color);

          erase_cursor_vert(loc_curs[1],2,minx,miny,maxx,maxy,delta,strt_val,
          xmin_axis,xmax_axis);

          draw_cursor_vert(loc_curs[1],1,2,minx,miny,maxx,maxy,
          delta,strt_val,xmin_axis,xmax_axis,color);

          curs_app[0] = 0;
          curs_app[1] = 1;
        };
      };  /* end toggle cursor section */

        if(ascii_curs==-106)
        {  /* left arrow */

          erase_cursor_vert(loc_curs[selct_curs-1],selct_curs,minx,miny,maxx,
          maxy,delta,strt_val,xmin_axis,xmax_axis);

          if(accel_mode>0)
          {
            loc_curs[selct_curs-1] = loc_curs[selct_curs-1] - accel_mode;
          }
          else
          {
            loc_curs[selct_curs-1] = loc_curs[selct_curs-1] - 1;
          };

          if(loc_curs[selct_curs-1]<*i_min)
          {
            loc_curs[selct_curs-1] = *i_min;
          };

          /* draw cursor in new location: */
          draw_cursor_vert(loc_curs[selct_curs-1],curs_app[selct_curs-1],
          selct_curs,minx,miny,maxx,maxy,delta,strt_val,xmin_axis,xmax_axis,
          color);


          if(selct_curs==1)
          {
            tg_adjust(*plot_mode,loc_curs[selct_curs-1]-1,
              plot_array[loc_curs[selct_curs-1]-1],&plot_value);
            display_value_c1(loc_curs[selct_curs-1],*minx,*maxx,*maxy,*i_min,
              plot_value,*delta,*strt_val);
          }
          else
          {
            tg_adjust(*plot_mode,loc_curs[selct_curs-1]-1,
              plot_array[loc_curs[selct_curs-1]-1],&plot_value);
            display_value_c2(loc_curs[selct_curs-1],*minx,*maxx,*maxy,*i_min,
              plot_value,*delta,*strt_val);
          };

        };  /* end left arrow */

        if(ascii_curs==-104)
        {  /* right arrow */

          erase_cursor_vert(loc_curs[selct_curs-1],selct_curs,minx,miny,maxx,
          maxy,delta,strt_val,xmin_axis,xmax_axis);

          if(accel_mode>0)
          {
            loc_curs[selct_curs-1] = loc_curs[selct_curs-1] + accel_mode;
          }
          else
          {
            loc_curs[selct_curs-1] = loc_curs[selct_curs-1] + 1;
          };

          if(loc_curs[selct_curs-1]>*i_max)
          {
            loc_curs[selct_curs-1] = *i_max;
          };

          /* draw cursor in new location: */
          draw_cursor_vert(loc_curs[selct_curs-1],curs_app[selct_curs-1],
          selct_curs,minx,miny,maxx,maxy,delta,strt_val,xmin_axis,xmax_axis,
          color);


          if(selct_curs==1)
          {
            tg_adjust(*plot_mode,loc_curs[selct_curs-1]-1,
              plot_array[loc_curs[selct_curs-1]-1],&plot_value);
            display_value_c1(loc_curs[selct_curs-1],*minx,*maxx,*maxy,*i_min,
              plot_value,*delta,*strt_val);
          }
          else
          {
            tg_adjust(*plot_mode,loc_curs[selct_curs-1]-1,
              plot_array[loc_curs[selct_curs-1]-1],&plot_value);
            display_value_c2(loc_curs[selct_curs-1],*minx,*maxx,*maxy,*i_min,
              plot_value,*delta,*strt_val);
          };

        }; /* end right arrow */

      if(toupper(ascii_curs)=='Q')
      {
        quit_curs = 1;
      };
    }
    while(!quit_curs); /* end section to move cursors */

    if(loc_curs[0]<=loc_curs[1])
    {  /* re-define horizontal plot boundaries */
      *i_min = loc_curs[0];
      *i_max = loc_curs[1];
    }
    else
    {
      *i_min = loc_curs[1];
      *i_max = loc_curs[0];
    };
    *xmin = (*i_min-1) * *delta + *strt_val;
    *xmax = (*i_max-1) * *delta + *strt_val;

    setup_horiz_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);

    setup_vert_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);

  /* remove final cursors from memory */
  erase_cursor_vert(loc_curs[0],1,minx,miny,maxx,maxy,delta,strt_val,
  xmin_axis,xmax_axis);

  erase_cursor_vert(loc_curs[1],2,minx,miny,maxx,maxy,delta,strt_val,
  xmin_axis,xmax_axis);

  plot(&init_graph,ndivh,ndivv,n_h,n_v,extend_tics,
    minx,miny,maxx,maxy,i_min,i_max,i_truncate,interpolate,int_div,
    plot_mode,THD,npts,deltah,deltav,deltah_n,deltav_n,xmin,xmax,
    ymin,ymax,xmin_axis,xmax_axis,ymin_axis,ymax_axis,delta,strt_val,
    THD_v,&plot_array[0],color);

  }; /* end section for vertical cursors */



  if(toupper(ascii_plot) == 'T')
  {  /* section to truncate waveform */

    if(*i_truncate > *i_max)
    {
      *i_truncate = *i_max;
    };

    quit_trnc = 0;
    accel_mode = 0; /* used to speed up the effect of the arrow keys */
    plot(&init_graph,ndivh,ndivv,n_h,n_v,extend_tics,
      minx,miny,maxx,maxy,i_min,i_max,i_truncate,interpolate,int_div,
      plot_mode,THD,npts,deltah,deltav,deltah_n,deltav_n,xmin,xmax,
      ymin,ymax,xmin_axis,xmax_axis,ymin_axis,ymax_axis,delta,strt_val,
      THD_v,&plot_array[0],color);
    draw_cursor_vert(*i_truncate,0,1,minx,miny,maxx,maxy,delta,strt_val,
    xmin_axis,xmax_axis,color); /* draw initial cursor */


    tg_adjust(*plot_mode,*i_truncate-1,
      plot_array[*i_truncate-1],&plot_value);
    display_value_c1(*i_truncate,*minx,*maxx,*maxy,*i_min,
      plot_value,*delta,*strt_val);

  do
  {


    XNextEvent(display, &event);
    if(event.type==KeyPress)
    {
//      ascii_trnc=XKeycodeToKeysym(display,event.xkey.keycode,0);
      {
        int keysyms_per_keycode_return;
        ascii_trnc = *XGetKeyboardMapping(display,event.xkey.keycode,1,&keysyms_per_keycode_return);
      }

    };

    if(toupper(ascii_trnc)=='A')
    {
      if(accel_mode==0)
      {
        accel_mode=10;
      }
      else
      {
        if(accel_mode<1000)
        {
          accel_mode = accel_mode * 10;
        }
      }
    };

    if(toupper(ascii_trnc)=='B')
    {
      accel_mode = accel_mode/10;
    } 

    if(toupper(ascii_trnc)=='Q')
    {
      quit_trnc = true;
    };

    if(toupper(ascii_trnc)=='D')
    {  /* reset to default case of no truncation */

      erase_cursor_vert(*i_truncate,1,minx,miny,maxx,maxy,delta,strt_val,
      xmin_axis,xmax_axis);

      *i_truncate = *i_max;
      draw_cursor_vert(*i_truncate,0,1,minx,miny,maxx,maxy,delta,strt_val,
      xmin_axis,xmax_axis,color);


      tg_adjust(*plot_mode,*i_truncate-1,
        plot_array[*i_truncate-1],&plot_value);
      display_value_c1(*i_truncate,*minx,*maxx,*maxy,*i_min,
        plot_value,*delta,*strt_val);
    };  /* end default case */

      if(ascii_trnc==-106)
      {  /* left arrow */

        erase_cursor_vert(*i_truncate,1,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis);

        if(accel_mode>0)
        {
          *i_truncate = *i_truncate - accel_mode;
        }
        else
        {
          *i_truncate = *i_truncate - 1;
        };

        if(*i_truncate<*i_min)
        {
          *i_truncate = *i_max; /* wrap around */
        };
        draw_cursor_vert(*i_truncate,0,1,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis,color);

        tg_adjust(*plot_mode,*i_truncate-1,
          plot_array[*i_truncate-1],&plot_value);

        display_value_c1(*i_truncate,*minx,*maxx,*maxy,*i_min,
          plot_value,*delta,*strt_val);
      }; /* end left arrow */

      if(ascii_trnc==-104)
      {  /* right arrow */

        erase_cursor_vert(*i_truncate,1,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis);

        if(accel_mode>0)
        {
          *i_truncate = *i_truncate + accel_mode;
        }
        else
        {
          *i_truncate = *i_truncate + 1;
        };

        if(*i_truncate>*i_max)
        {
          *i_truncate = *i_min; /* wrap around */
        };
        draw_cursor_vert(*i_truncate,0,1,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis,color);
        tg_adjust(*plot_mode,*i_truncate-1,
          plot_array[*i_truncate-1],&plot_value);
        display_value_c1(*i_truncate,*minx,*maxx,*maxy,*i_min,
          plot_value,*delta,*strt_val);
      };  /* end right arrow */

  }
  while(!quit_trnc);

  /* free final cursor memory */
  erase_cursor_vert(*i_truncate,1,minx,miny,maxx,maxy,delta,strt_val,
  xmin_axis,xmax_axis);

  };  /* end section to truncate waveform */
}  /* end main do loop */
while(!quit_pr);

};
/* ---------------------------------------------------------------------- */



/* ------------------------------------------------------------------------ */
void display_value_c1(int loc,int minx,int maxx,int maxy,int i_min,
float value,float delta,float strt_val)
{


char disp1_str[200];
char disp2_str[50];
int ilocx,ilocy;
float x;



  x = (loc-1)*delta + strt_val;

  sprintf(&disp1_str[0],"%d",loc); /* convert int loc to a string */
  disp2_str[0] = ':';
  disp2_str[1] = '\0';
  strcat(disp1_str,disp2_str);

  sprintf(&disp2_str[0],"%12e",x); /* convert x-value to a string */
  strcat(disp1_str,disp2_str);
  disp2_str[0] = ':';
  disp2_str[1] = '\0';
  strcat(disp1_str,disp2_str);

  sprintf(&disp2_str[0],"%12e",value); /* convert y-value to a string */
  strcat(disp1_str,disp2_str);

  ilocx = minx / 2;
// change here:
//  ilocy = maxy-3*TEXTHEIGHT_PIX-2*tic_offset-1;
  ilocy = maxy-3*TEXTHEIGHT_PIX-tic_offset;

/* erase the area where the string will be placed: */
/* Text appears to be centered in x and at the bottom in y */
  XClearArea(display,win,ilocx-textwidth(100,disp1_str)*TEXTWIDTH_PIX/2,
  ilocy-TEXTHEIGHT_PIX-1,textwidth(100,disp1_str)*TEXTWIDTH_PIX,TEXTHEIGHT_PIX+2,0);

/* put disp1_str on the screen */
  XDrawString(display,win,gc1,ilocx,ilocy,&disp1_str[0],strlen(&disp1_str[0]));

};
/* ------------------------------------------------------------------------ */





/* ------------------------------------------------------------------------ */
void display_THD(int *minx,int *maxx,int *maxy,float *THD_value)
{


char disp1_str[200];
char disp2_str[50];
int ilocx,ilocy;



  disp1_str[0] = 'T';
  disp1_str[1] = 'H';
  disp1_str[2] = 'D';
  disp1_str[3] = ' ';
  disp1_str[4] = '=';
  disp1_str[5] = ' ';
  disp1_str[6] = '\0';

  sprintf(&disp2_str[0],"%12e",*THD_value); /* convert THD_value to a string */
  strcat(disp1_str,disp2_str);

  ilocx = *minx;
  ilocy = *maxy-3*TEXTHEIGHT_PIX-2*tic_offset-1;

/* erase the area where the string will be placed: */
/* Text appears to be centered in x and at the bottom in y */
  XClearArea(display,win,ilocx-textwidth(100,disp1_str)*TEXTWIDTH_PIX/2,
  ilocy-TEXTHEIGHT_PIX-1,textwidth(100,disp1_str)*TEXTWIDTH_PIX,TEXTHEIGHT_PIX+2,0);

/* put disp1_str on the screen */
  XDrawString(display,win,gc1,ilocx,ilocy,&disp1_str[0],strlen(&disp1_str[0]));

};
/* ------------------------------------------------------------------------ */







/* ------------------------------------------------------------------------ */
void display_value_c2(int loc,int minx,int maxx,int maxy,int i_min,
float value,float delta,float strt_val)
{


char disp1_str[200];
char disp2_str[50];
int ilocx,ilocy;
float x;



  x = (loc-1)*delta + strt_val;

  sprintf(&disp1_str[0],"%d",loc); /* convert int loc to a string */
  disp2_str[0] = ':';
  disp2_str[1] = '\0';
  strcat(disp1_str,disp2_str);

  sprintf(&disp2_str[0],"%12e",x); /* convert x-value to a string */
  strcat(disp1_str,disp2_str);
  disp2_str[0] = ':';
  disp2_str[1] = '\0';
  strcat(disp1_str,disp2_str);

  sprintf(&disp2_str[0],"%12e",value); /* convert y-value to a string */
  strcat(disp1_str,disp2_str);

  ilocx = maxx - textwidth(200,&disp1_str[0]) + (minx / 2);
// change here:
//  ilocy = maxy-3*TEXTHEIGHT_PIX-2*tic_offset-1;
  ilocy = maxy-3*TEXTHEIGHT_PIX-tic_offset;

/* erase the area where the string will be placed: */
/* Text appears to be centered in x and at the bottom in y */
  XClearArea(display,win,ilocx-textwidth(100,disp1_str)*TEXTWIDTH_PIX/2,
  ilocy-TEXTHEIGHT_PIX-1,textwidth(100,disp1_str)*TEXTWIDTH_PIX,TEXTHEIGHT_PIX+2,0);

/* put disp1_str on the screen */
  XDrawString(display,win,gc1,ilocx,ilocy,&disp1_str[0],strlen(&disp1_str[0]));

};
/* ------------------------------------------------------------------------ */








/* ------------------------------------------------------------------------- */
/*
 This procedure determines the number of increments and the numerical
 increment value for the horizontal axis.
*/
void setup_horiz_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,
long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,
long double plot_array[])
{

const dim_table_h = 5;



float log_10_max,rnmax;
int ih;
float table_h[dim_table_h];
float delta_h[dim_table_h];



/*
 Set up possible normalized horizontal axis ranges. Note: although 0.1
 is included, it should never be selected; 1.0 should be used instead.
*/
  table_h[0] = 10.0;
  table_h[1] = 5.0;
  table_h[2] = 2.5;
  table_h[3] = 2.0;
  table_h[4] = 1.0;

/* set up normalized axis increments for the above cases: */
  delta_h[0] = 1.0;
  delta_h[1] = 0.5;
  delta_h[2] = 0.25;
  delta_h[3] = 0.2;
  delta_h[4] = 0.1;

  log_10_max = log(*xmax-*xmin) / ln_10;

  if(frac(log_10_max)>=0.0)
  {
    *n_h = truncfi(log_10_max);
  }
  else 
  {
    *n_h = truncfi(log_10_max)-1;
  };

/* normalize in range 1.0<=rnmax<=10.0 */
  rnmax = (*xmax-*xmin) / exp(*n_h * ln_10);

  ih = 0;
  do
  {
    ih = ih + 1;
  }
  while(!(  ((rnmax>table_h[ih]) && (rnmax<=table_h[ih-1]) ) || (ih==
    dim_table_h-1)  )  );

/* use table_h[ih-1] as max horizontal axis range, n_h as normalizing exponent */
/* set up axis according to selected i_h entry: */

/* un-normalized axis increment: */
  *deltah = delta_h[ih-1] * exp(*n_h * ln_10);
/* normalized axis increment: */
  *deltah_n = delta_h[ih-1];

  *ndivh = truncfi( ( *xmax- *xmin)/ *deltah );
/* extend axis if necessary to display all data: */
  if( (*ndivh * *deltah)!=(xmax-xmin) )
  {
    *ndivh = *ndivh + 1;
  };

  *xmin_axis = *xmin;
  *xmax_axis = *xmin + *ndivh * *deltah;

};  /* end setup_horiz_axis */
/* ---------------------------------------------------------------------- */



/* ------------------------------------------------------------------------- */
/*
 This procedure determines the number of increments and the numerical
 increment value for the vertical axis.
*/
void setup_vert_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx, int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,long int *i_truncate,
int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,
long double plot_array[])
{

const dim_table_v = 5;



float log_10_max,rnmax;
int iv;
float table_v[dim_table_v];
float delta_v[dim_table_v];



/*
 Set up possible normalized vertical axis ranges. Note: although 0.1
 is included, it should never be selected; 1.0 should be used instead.
*/
  table_v[0] = 10.0;
  table_v[1] = 5.0;
  table_v[2] = 2.5;
  table_v[3] = 2.0;
  table_v[4] = 1.0;

/* set up normalized axis increments for the above cases: */
  delta_v[0] = 1.0;
  delta_v[1] = 0.5;
  delta_v[2] = 0.25;
  delta_v[3] = 0.2;
  delta_v[4] = 0.1;

  log_10_max = log(*ymax-*ymin) / ln_10;

  if(frac(log_10_max)>=0.0)
  {
    *n_v = truncfi(log_10_max);
  }
  else 
  {
    *n_v = truncfi(log_10_max)-1;
  };

/* normalize in range 1.0<=rnmax<=10.0 */
  rnmax = (*ymax-*ymin) / exp(*n_v * ln_10);

  iv = 0;
  do
  {
    iv = iv + 1;
  }
  while(!(   ((rnmax>table_v[iv]) && (rnmax<=table_v[iv-1]) ) || (iv=
    dim_table_v-1)  ) );

/* use table_v[iv-1] as max vertical axis range, n_v as normalizing exponent */
/* set up axis according to selected i_v entry: */

/* un-normalized axis increment: */
  *deltav = delta_v[iv-1] * exp(*n_v * ln_10);
/* normalized axis increment: */
  *deltav_n = delta_v[iv-1];

  *ndivv = truncfi( ( *ymax - *ymin) / *deltav );
/* extend axis if necessary to display all data: */
  if( (*ndivv *  *deltav)!=(*ymax-*ymin) )
  {
    *ndivv = *ndivv + 1;
  };

  *ymin_axis = *ymin;
  *ymax_axis = *ymin + *ndivv * *deltav;

}; /* end setup_vert_axis */
/* ---------------------------------------------------------------------- */




/* ---------------------------------------------------------------------- */
void draw_horiz_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,long int *i_truncate,
int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,
long double plot_array[],int color)
{


int i_h,hloc_pix;
float rminx,rmaxx,rloc,rdelx;
long int h_long;
char xmin_str[50];
char xmax_str[50];
char horiz1_str[50];
char horiz2_str[50];
int ilocx,ilocy;



  rminx = *minx;
  rmaxx = *maxx;
  rdelx = (rmaxx-rminx)/ *ndivh;


/* draw rectangle defining the plot boundaries */
  color = 1;
  Rectangle(*minx,*miny,*maxx,*maxy,color);

  if(*extend_tics==0)
  {  /* only draw short tic marks on axes */


  for(i_h=2; i_h <= *ndivh; i_h++)
  {
    rloc = rminx + (i_h-1) * rdelx;
    h_long = Round(rloc); /* Round returns longint value */
    hloc_pix = h_long; /* convert to integer for Line procedure */
    /* set foreground color and draw tic mark: */
    XSetForeground(display,gc1,pixel_values[color-1]); 
    XDrawLine(display,win,gc1,hloc_pix,*miny+tic_offset,hloc_pix,*miny-tic_offset);
  };

  }
  else
  {  /* draw interior dotted lines */

  for(i_h=1; i_h < *ndivh; i_h++)
  {
    rloc = rminx + i_h * rdelx;
    h_long = Round(rloc); /* Round returns longint value */
    hloc_pix = h_long; /* convert to integer for Line procedure */
    dotted_line(hloc_pix,*miny,hloc_pix,*maxy,color);
  };

  };

/* convert axis endpoint values to strings for labelling: */
  sprintf(&xmin_str[0],"%14e",*xmin_axis); /* convert xmin_axis to a string */
  sprintf(&xmax_str[0],"%14e",*xmax_axis); /* convert xmax_axis to a string */

  ilocx = *minx- (textwidth(50,&xmin_str[0]) / 2);
  ilocy = *miny+2*TEXTHEIGHT_PIX+2*tic_offset+5;
  XSetForeground(display,gc1,pixel_values[color-1]); 
  XDrawString(display,win,gc1,ilocx,ilocy,&xmin_str[0],strlen(&xmin_str[0]));

  ilocx = *maxx- (textwidth(50,&xmax_str[0]) / 2);
  ilocy = *miny+2*TEXTHEIGHT_PIX+2*tic_offset+5;
  XSetForeground(display,gc1,pixel_values[color-1]); 
  XDrawString(display,win,gc1,ilocx,ilocy,&xmax_str[0],strlen(&xmax_str[0]));

/* next label horizontal axis division increment: */

  horiz1_str[0] = 'H';
  horiz1_str[1] = ':';
  horiz1_str[2] = ' ';
  horiz1_str[3] = '\0';
  sprintf(&horiz2_str[0],"%5.3e",*deltah_n); /* convert deltah_n to a string */
  strcat(horiz1_str,horiz2_str);
  horiz2_str[0] = ' ';
  horiz2_str[1] = 'x';
  horiz2_str[2] = ' ';
  horiz2_str[3] = '1';
  horiz2_str[4] = '0';
  horiz2_str[5] = '^';
  horiz2_str[6] = '\0';
  strcat(horiz1_str,horiz2_str);
  sprintf(&horiz2_str[0],"%d",*n_h); /* convert n_h to a string */
  strcat(horiz1_str,horiz2_str);

  if(*plot_mode==1)
  {
    horiz2_str[0] = ' ';
    horiz2_str[1] = 's';
    horiz2_str[2] = 'e';
    horiz2_str[3] = 'c';
    horiz2_str[4] = '\0';
  }
  else
  {
    horiz2_str[0] = ' ';
    horiz2_str[1] = 'H';
    horiz2_str[2] = 'z';
    horiz2_str[3] = '\0';
  };
  strcat(horiz1_str,horiz2_str);

  ilocx = *minx+(*maxx-*minx) / 2 - textwidth(100,&horiz1_str[0]) / 2;
  ilocy = *miny+2*TEXTHEIGHT_PIX+2*tic_offset+5;
  XSetForeground(display,gc1,pixel_values[color-1]); 
  XDrawString(display,win,gc1,ilocx,ilocy,&horiz1_str[0],strlen(&horiz1_str[0]));

}; /* end procedure draw_horiz_axis */
/* ------------------------------------------------------------------ */




/* ---------------------------------------------------------------------- */
void draw_vert_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,long int *i_truncate,
int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,
long double plot_array[],int color)
{


int i_v,vloc_pix;
float rminy,rmaxy,rloc,rdely;
long int v_long;
char ymin_str[50],ymax_str[50],vert1_str[50],vert2_str[50];
int ilocx,ilocy;



  rminy = *miny;
  rmaxy = *maxy;
  rdely = (rminy-rmaxy)/ *ndivv;

  if( *extend_tics == 0 )
  {  /* only draw short tic marks on axes */

  for(i_v=2; i_v <= *ndivv; i_v++)
  {
    rloc = rmaxy + (i_v-1) * rdely;
    v_long = Round(rloc); /* Round returns longint value */
    vloc_pix = v_long; /* convert to integer for Line procedure */
    /* draw tic mark: */
    XSetForeground(display,gc1,pixel_values[color-1]); 
    XDrawLine(display,win,gc1,*minx-tic_offset,vloc_pix,*minx+tic_offset,vloc_pix);
  };
  }
  else /* draw interior dotted lines */
  {

  for(i_v=1; i_v < *ndivv; i_v++)
  {
    rloc = rmaxy + i_v * rdely;
    v_long = Round(rloc); /* Round returns longint value */
    vloc_pix = v_long; /* convert to integer for Line procedure */
    dotted_line(*minx,vloc_pix,*maxx,vloc_pix,color);
  };

  };

/* convert axis endpoint values to strings for labelling: */
  sprintf(&ymin_str[0],"%6.4f",*ymin_axis); /* convert ymin_axis to a string */
  sprintf(&ymax_str[0],"%6.4f",*ymax_axis); /* convert ymax_axis to a string */

  ilocx = *minx-textwidth(50,&ymin_str[0])-2* tic_offset-1;
  ilocy = *miny+(TEXTHEIGHT_PIX / 2);
  XSetForeground(display,gc1,pixel_values[color-1]); 
  XDrawString(display,win,gc1,ilocx,ilocy,&ymin_str[0],strlen(&ymin_str[0]));

  ilocx = *minx-textwidth(50,&ymax_str[0])-2* tic_offset-1;
  ilocy = *maxy+(TEXTHEIGHT_PIX / 2);
  XSetForeground(display,gc1,pixel_values[color-1]); 
  XDrawString(display,win,gc1,ilocx,ilocy,&ymax_str[0],strlen(&ymax_str[0]));

/* next label vertical axis division increment: */

  vert1_str[0] = 'V';
  vert1_str[1] = ':';
  vert1_str[2] = ' ';
  vert1_str[3] = '\0';
  sprintf(&vert2_str[0],"%5.3e",*deltav_n); /* convert deltav_n to a string */
  strcat(vert1_str,vert2_str);
  vert2_str[0] = ' ';
  vert2_str[1] = 'x';
  vert2_str[2] = ' ';
  vert2_str[3] = '1';
  vert2_str[4] = '0';
  vert2_str[5] = '^';
  vert2_str[6] = '\0';
  strcat(vert1_str,vert2_str);
  sprintf(&vert2_str[0],"%d",*n_v); /* convert normalization exponent to a string */
  strcat(vert1_str,vert2_str);

  if(*plot_mode==2)
  {
    if(impedance_mode==0)
    {
      vert2_str[0] = ' ';
      vert2_str[1] = 'd';
      vert2_str[2] = 'B';
      vert2_str[3] = '\0';
    }
    else
    {
      vert2_str[0] = ' ';
      vert2_str[1] = 'O';
      vert2_str[2] = 'h';
      vert2_str[3] = 'm';
      vert2_str[4] = 's';
      vert2_str[5] = '\0';
    };
    strcat(vert1_str,vert2_str);
  }
  else if(*plot_mode==3)
  {
    vert2_str[0] = ' ';
    vert2_str[1] = 'd';
    vert2_str[2] = 'e';
    vert2_str[3] = 'g';
    vert2_str[4] = '\0';
    strcat(vert1_str,vert2_str);
  };

  ilocx = *minx+(*maxx-*minx) / 2 - textwidth(50,&vert1_str[0]) / 2;
  ilocy = *maxy-TEXTHEIGHT_PIX - 2* tic_offset-1;
  XSetForeground(display,gc1,pixel_values[color-1]); 
  XDrawString(display,win,gc1,ilocx,ilocy,&vert1_str[0],strlen(&vert1_str[0]));

}; /* end procedure draw_vert_axis */
/* ------------------------------------------------------------------ */



/* ------------------------------------------------------------------ */
/*
 find_pixel returns the horizontal pixel value in i_pix closest to
 the function index specified in i_func. It is assumed that i_func=0
 corresponds to t=0, and each increment of i_func increases the
 time according to delt.
*/
void find_pixel(long int i_func,int *i_pix,int *minx,int *maxx,float *delta,
float *strt_val,float *xmin_axis,float *xmax_axis)
{


long int i_longint;
float x_pix;
float rminx,rmaxx,r_ix;



  rminx = *minx; /* pixel value at axis lhs */
  rmaxx = *maxx; /* pixel value at axis rhs */
  r_ix = i_func;
/* xmin_axis,xmax_axis specify time values at ends of current horizontal axis */
  x_pix = rminx + ((r_ix-1.0)* *delta+ *strt_val- *xmin_axis)/
    (*xmax_axis - *xmin_axis)*(rmaxx-rminx);
  *i_pix = Round(x_pix); /* find pixel location closest to function value */


}; /* end find_pixel */
/* ---------------------------------------------------------------------- */



/* ------------------------------------------------------------------- */
/*
 The following procedure draws a vertical cursor at function value ix.
 If dotted=false it draws a solid cursor, dotted=true draws a dotted
 cursor. id identifies the cursor (1 or 2).
*/

void draw_cursor_vert(long int ix,int dotted,int id,int *minx,int *miny,
int *maxx,int *maxy,float *delta,float *strt_val,float *xmin_axis,
float *xmax_axis,int color)
{



int ix_pix;



  find_pixel(ix,&ix_pix,minx,maxx,delta,strt_val,xmin_axis,xmax_axis);

/* first save the image under the cursor */

  if(id==1)
  {
    save_image_1 = XGetImage(display,win,ix_pix,*maxy,1,*miny-*maxy+1,AllPlanes,XYPixmap);
  }
  else if(id==2)
  {
    save_image_2 = XGetImage(display,win,ix_pix,*maxy,1,*miny-*maxy+1,AllPlanes,XYPixmap);
  };

/* now draw the cursor */
  if(dotted==0)
  {
    XSetForeground(display,gc1,pixel_values[color-1]); 
    XDrawLine(display,win,gc1,ix_pix,*maxy,ix_pix,*miny);
  }
  else
  {
    dotted_line(ix_pix,*maxy,ix_pix,*miny,color);
  };

}; /* end procedure draw_cursor_vert */
/* -------------------------------------------------- */




/* ------------------------------------------------------------------- */
/* 
 The following procedure removes a vertical cursor at pixel location ix.
 A previous call to draw_cursor_vert with the same id must have been
 made, so that the image under the cursor has been saved in either
 p1^ (id=1) or p2^ (id=2).
*/
void erase_cursor_vert(long int ix,int id,int *minx,int *miny,int *maxx,
int *maxy,float *delta,float *strt_val,float *xmin_axis,float *xmax_axis)
{


int ix_pix;


  find_pixel(ix,&ix_pix,minx,maxx,delta,strt_val,xmin_axis,xmax_axis);

  if(id==1)
  {
    XPutImage(display,win,gc1,save_image_1,save_image_1->xoffset,0,ix_pix,*maxy,
      save_image_1->width,save_image_1->height);
    XDestroyImage(save_image_1);
  }
  else if (id==2)
  {
    XPutImage(display,win,gc1,save_image_2,save_image_2->xoffset,0,ix_pix,*maxy,
      save_image_2->width,save_image_2->height);
    XDestroyImage(save_image_2);
  };

}; /* end procedure erase_cursor_vert */
/* -------------------------------------------------- */





/* ----------------------------------------------------------------------- */
/* 
 The following procedure generates a plot of the values in plot_array
 vs. time. init_graph tells whether the graphics mode for the plot has
 already been initialized. xmin,xmax gives the range of horizontal
 axis data, and ymin,ymax gives the vertical axis data range.
 i_min and i_max give the index range of values in plot_array to be plotted
 (starting at 1).
*/
void plot(int *init_graph,int *ndivh,int *ndivv,int *n_h,
int *n_v,int *extend_tics,int *minx,int *miny,int *maxx,int *maxy,
long int *i_min,long int *i_max,long int *i_truncate,int *interpolate,int *int_div,
int *plot_mode,int *THD,long int *npts,float *deltah,float *deltav,
float *deltah_n,float *deltav_n,float *xmin,float *xmax,float *ymin,
float *ymax,float *xmin_axis,float *xmax_axis,float *ymin_axis,
float *ymax_axis,float *delta,float *strt_val,float *THD_v,
long double plot_array[],int color)
{


char ascii_graph,c_in;
long int i_graph;
float x_conv,y_conv;
float x,y;
long int x_longint, y_longint;
int y_pixel,x_pixel;
int x_pixel_old,y_pixel_old;
float t,time,result,deltt;
int i_int;
float plot_value;
float pi;


  pi = 4.0 * atan(1.0);

  if(!graphics_window_created)
  {
    graphics_window_init();
    XGetGeometry(display,win,geom_root_ret,geom_x_ret,geom_y_ret,
      geom_width_ret,geom_height_ret,geom_border_width_ret,
      geom_depth_ret);

    *maxx = ( *geom_width_ret / 8) * 7;
/* note: miny is at bottom of screen, it is actually larger than maxy: */
    *miny = ( *geom_height_ret / 8) * 7;
    *minx = *geom_width_ret / 8;
    *maxy = *geom_height_ret / 8;
  }

  if(*init_graph==0)
  { /* *init_graph==0 */
    *init_graph = 1;

    setup_horiz_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);

    setup_vert_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);
  }; /* *init_graph==0 */


/* Set up clipping in window: */
    clip_rectangle[0].x = 0;
    clip_rectangle[0].y = 0;
    clip_rectangle[0].width = *geom_width_ret;
    clip_rectangle[0].height = *geom_height_ret;
    XSetClipRectangles(display,gc1,0,0,clip_rectangle,1,Unsorted);
    XClearWindow(display,win);

    draw_horiz_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0],color);

    draw_vert_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0],color);

/* Set up clipping in window: */
    clip_rectangle[0].x = *minx;
    clip_rectangle[0].y = *maxy;
    clip_rectangle[0].width = *maxx-*minx;
    clip_rectangle[0].height = *miny-*maxy;
    XSetClipRectangles(display,gc1,0,0,clip_rectangle,1,Unsorted);
    x_conv = *maxx - *minx;
    x_conv = x_conv / (*xmax_axis- *xmin_axis); /* converts real number to pixels */
    y_conv = *miny - *maxy;
    y_conv = y_conv / (*ymax_axis- *ymin_axis);

/* location of first point in pixels: */
    x = ((*i_min-1)* *delta + *strt_val - *xmin_axis) * x_conv;
    x = x + *minx;
    x_longint = Round(x); /* to nearest pixel */
    x_pixel_old = x_longint;
    tg_adjust(*plot_mode,*i_min-1,plot_array[*i_min-1],&plot_value);
    y = (*ymax_axis - plot_value) * y_conv;
    y = y + *maxy;
    y_longint = Round(y); /* to nearest pixel */
    y_pixel_old = y_longint;
/* draw in first vertical line if it is a frequency plot: */
    if(*plot_mode>1)
    {
      XSetForeground(display,gc1,pixel_values[color-1]); 
      XDrawLine(display,win,gc1,x_pixel_old,*miny,x_pixel_old,y_pixel_old);
    };

    if((*interpolate==0) || (*int_div==1))
    {  /* plot with no interpolation */
    for(i_graph=*i_min+1; i_graph <= *i_max; i_graph++)
    {  /* begin plot */

      x = ((i_graph-1)* *delta + *strt_val - *xmin_axis) * x_conv;
      x = x + *minx;
      x_longint = Round(x);
      x_pixel = x_longint;

      tg_adjust(*plot_mode,i_graph-1,plot_array[i_graph-1],&plot_value);
      if(i_graph <= *i_truncate)
      {
        y = (*ymax_axis-plot_value) * y_conv;
      }
      else if(*plot_mode==1)
      {
        y = *ymax_axis * y_conv;
      }
      else
      {
        y = (*ymax_axis-*ymin_axis) * y_conv;
      };

      y = y + *maxy;

      y_longint = Round(y); /* to nearest pixel */
      y_pixel = y_longint;
/*
 Connect points with line segments if vs. time, otherwise plot vertical
 line segments if vs. frequency:
*/
      if(*plot_mode==1)
      {
        XSetForeground(display,gc1,pixel_values[color-1]); 
        XDrawLine(display,win,gc1,x_pixel_old,y_pixel_old,x_pixel,y_pixel);
      }
      else
      {
        XSetForeground(display,gc1,pixel_values[color-1]); 
        XDrawLine(display,win,gc1,x_pixel,*miny,x_pixel,y_pixel);
      };

      x_pixel_old = x_pixel;
      y_pixel_old = y_pixel;

    };  /* end plot */
    }  /* end plot with no interpolation */
    else
    {  /* plot with interpolation (resampling) */
    for(i_graph=*i_min+1;i_graph <= *i_max;i_graph++)
    {  /* begin plot */

      time = (i_graph-2) * *delta + *strt_val; /* time at start of interval */
      deltt = *delta / *int_div;
      for(i_int=1;i_int <= *int_div; i_int++)
      {  /* begin interpolation */
        t = time + i_int * deltt;
        x = ((i_graph-2)* *delta+ *strt_val+i_int*deltt- *xmin_axis) * x_conv;
        x = x + *minx;
        x_longint = Round(x);
        x_pixel = x_longint;

        if(i_graph <= *i_truncate)
        {
/* Find value at t from sin(x)/x interpolation: */
          resample(&t,npts,delta,&plot_array[0],&result,pi);
          y = ( *ymax_axis-result ) * y_conv;
        }
        else if( *plot_mode==1)
        {
          y = *ymax_axis * y_conv;
        }
        else
        {
          y = (*ymax_axis-*ymin_axis) * y_conv;
        };

        y = y + *maxy;

        y_longint = Round(y); /* to nearest pixel */
        y_pixel = y_longint;

        if(*plot_mode==1)
        {
          XSetForeground(display,gc1,pixel_values[color-1]); 
          XDrawLine(display,win,gc1,x_pixel_old,y_pixel_old,x_pixel,y_pixel);
        }
        else
        {
          XSetForeground(display,gc1,pixel_values[color-1]); 
          XDrawLine(display,win,gc1,x_pixel,*miny,x_pixel,y_pixel);
        };

        x_pixel_old = x_pixel;
        y_pixel_old = y_pixel;

      }; /* end interpolation */

    };  /* end plot */

    };  /* end plot with interpolation (resampling) */

//    if(*THD>0)
//    {
//      display_THD(minx,maxx,maxy,THD_v);
//    };


/* Set up clipping in window: */
  clip_rectangle[0].x = 0;
  clip_rectangle[0].y = 0;
  clip_rectangle[0].width = *geom_width_ret;
  clip_rectangle[0].height = *geom_height_ret;
  XSetClipRectangles(display,gc1,0,0,clip_rectangle,1,Unsorted);

  if(*THD>0)
  {
    display_THD(minx,maxx,maxy,THD_v);
  };

  XMapWindow(display, win);
  XFlush(display);
//  XFlushGC(display,gc1);

};  /* end procedure plot */
/* ------------------------------------------------------------------------- */



/* ------------------------------------------------------------------------- */
void setup_plot(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,
long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,int *THD,
long int *npts,float *deltah,float *deltav,float *deltah_n,float *deltav_n,
float *xmin,float *xmax,float *ymin,float *ymax,float *xmin_axis,
float *xmax_axis,float *ymin_axis,float *ymax_axis,float *delta,float *strt_val)
{


int quit_sp;
char sp_ascii;


  quit_sp = 0;

do
{
  clear();

  printw("T to toggle tic mark options ");
  if( *extend_tics>0)
  {
    printw("(extended dotted lines)\n");
  }
  else
  {
    printw("(axis tic marks only)\n");
  };

  printw("R to toggle interpolation option");
  if( *interpolate>0)
  {
    printw("%s%d%s"," (enabled, division of ",*int_div,")\n");
  }
  else
  {
    printw(" (disabled)\n");
  };

  printw("V to select vertical axis settings for time plot\n");
  printw("Q to return from menu\n");

  printw("Enter Command :\n");
  refresh();

  cbreak(); /* so don't wait for eol */
  noecho(); /* typed characters not echoed on screen */
  nodelay(stdscr,0); /* so getch waits for characters */

  sp_ascii = getch();

  if(toupper(sp_ascii) == 'Q')
  {
    quit_sp = 1;
  };

  if(toupper(sp_ascii) != 'Q')
  {

    if( toupper(sp_ascii) == 'T')
    {
      if( *extend_tics>0)
      {
        *extend_tics = 0;
      }
      else
      {
        *extend_tics = 1;
      };
    };

    if(toupper(sp_ascii) == 'R')
    {  /* setup interpolation */
      if( *interpolate==1)
      {
        *interpolate = 0;
      }
      else
      {
        *interpolate = 1;
        printw("Enter time step division (integer):\n");
        refresh();

        nocbreak(); /* so we wait for eol */
        echo(); /* typed characters echoed on screen */
        nodelay(stdscr,0); /* so we wait for characters */

        scanw("%d",int_div);  /* note: int_div is a pointer */

        if( *int_div<1)
        {
          *int_div = 1;
        };
      };
    };  /* end setup interpolation */

    if(toupper(sp_ascii) == 'V')
    {
      printw("Enter minimum vertical axis value:\n");
      refresh();
      nocbreak(); /* so we wait for eol */
      echo(); /* typed characters echoed on screen */
      nodelay(stdscr,0); /* so we wait for characters */

      scanw("%e",ymin);  /* note: ymin is a pointer */
      printw("Enter maximum vertical axis value:\n");
      refresh();
      scanw("%e",ymax);  /* note: ymax is a pointer */
// I think this is an error:
//      *strt_val = *ymin;
    };

  };  /* end of ascii_code <> 'Q' */
}
while(!quit_sp);

};  /* end of procedure setup_plot */
/* ---------------------------------------------------------------------- */



/* ---------------------------------------------------------------------- */
void display_iavg(int iavg_cnt,int minx,int maxx,int maxy)
{


char disp1_str[50];
int ilocx,ilocy;



  sprintf(&disp1_str[0],"%3d",iavg_cnt); /* convert int iavg_cnt to a string */

  ilocx = minx / 2;
  ilocy = maxy-3*TEXTHEIGHT_PIX-2*tic_offset-1;
/* erase the area where the string will be placed: */
  XClearArea(display,win,ilocx-textwidth(100,disp1_str)/2,ilocy-TEXTHEIGHT_PIX-2,
    textwidth(100,disp1_str) +2*TEXTWIDTH_PIX,TEXTHEIGHT_PIX+2,0);
  XDrawString(display,win,gc1,ilocx,ilocy,&disp1_str[0],strlen(&disp1_str[0]));
/* put disp1_str on the screen */
  XDrawString(display,win,gc1,ilocx,ilocy,&disp1_str[0],strlen(&disp1_str[0]));
  XMapWindow(display, win);
  XFlush(display);
//  XFlushGC(display,gc1);

};
/* ------------------------------------------------------------------------ */


/* ------------------------------------------------------------------------ */
void tg_adjust(int plot_mode,long int i,float plot_in,float *plot_value)
{


long int n_two_pi;



  *plot_value = plot_in;
  if(plot_mode==3)
  {
    *plot_value = *plot_value + 360.0*i*deltaf*Tg;
    n_two_pi = Round(*plot_value / 360.0 );
    *plot_value = *plot_value - n_two_pi * 360.0;
    do
    {
      if(*plot_value<-180.0)
      {
        *plot_value=*plot_value + 360.0;
      };
    }
    while(*plot_value<-180.0);
    do
    {
      if(*plot_value>180.0)
      {
        *plot_value=*plot_value - 360.0;
      };
    }
    while(*plot_value>180.0);
  };

};
/* -------------------------------------------------------------------- */




/* ------------------------------------------------------------------------ */
/*
 The following procedure resamples the discrete waveform in h[ix], with
 discretization delt, at arbitrary time t. Sin(x)/x reconstruction is
 used.
*/
void resample(float *t,long int *npts,float *delt,
long double h[],float *result,double pi)
{


int ix;
float arg,time;



  *result = 0.0; /* initialize sum */

  if( (*t>=0.0) && (*t<=(*npts-1)* *delt) )
  {  /* time within range of waveform */

  for(ix=0;ix < *npts; ix++)
  { /* sum over discrete time values */

      time = ix * *delt; /* time associated with discrete point */
      arg = pi*( *t-time)/ *delt;
      if(fabs(arg)<small_number)
      {
        *result = *result + h[ix];
      }
      else
      {
        *result = *result + h[ix]*sin(arg)/arg;
      };

  }; /* sum over discrete time values */

  }; /* time within range of waveform */

};
/* ---------------------------------------------------------------------- */
