
#define small_number 1.0e-10
#define MAX_NUM_PRIMARY_COLORS 7

#define KeyPressEvent 1
#define ButtonPressEvent 2
#define ButtonReleaseEvent 3

HWND window_handle;
// window_device_context is for the actual monitor display.
// memory_device_context_untouched is without any extra labelling.
// memory_device_context is with extra labelling, and it is
// continually being transferred to window_device_context in the
// WM_PAINT interrupt.
HDC  window_device_context,memory_device_context;
HDC  memory_device_context_untouched,memory_device_context_blank;
HPEN window_pen;
ATOM window_class = 0;
WNDCLASS window_class_struct;
// WNDPROC window_callback_function;
LRESULT CALLBACK window_callback_function(HWND hwnd,
UINT uMsg,WPARAM wParam,LPARAM lParam);
HINSTANCE window_hinstance;
RECT Old_Rect,New_Rect,Client_Rect;
HBITMAP memory_bitmap,memory_bitmap_untouched,memory_bitmap_blank;
int width_dc,height_dc;
int text_height;
TEXTMETRIC text_info;
RECT desktop_window_rect;
HGDIOBJ obj_ret;
COLORREF color_ret;
// COLORREF color_value[MAX_NUM_PRIMARY_COLORS];
int foreground_color_components[3],background_color_components[3];
COLORREF foreground_color,background_color;
HBRUSH foreground_brush,background_brush;
RECT Client_Rect;
HRGN clip_rectangle;
HRGN save_clip_rect_main,temp_clip_rect_main;
POINT pt;
BOOL bool_ret_value;
int mouse_x,mouse_y,old_mouse_x,old_mouse_y;
int shrink_x;
int shrink_y;
int view_xmin;
int view_xmax;
int view_ymin;
int view_ymax;
float vxmin;
float vxmax;
float vymin;
float vymax;
float dxmin;
float dxmax;
float dymin;
float dymax;
float mxmin, mxmax;
float mymin, mymax;

int event_type=0;
int text_char_width;


int impedance_mode;
float Rs,ln_10;
int tic_offset;
/* plot_mode: 1=time plot, 2=amp vs. freq, 3=phase vs. freq plot */
int plot_mode,THD;
float THD_v1,THD_v2;
/* set of plotting variables for time plots: */
int ndivht,ndivvt,n_ht,n_vt,extend_ticst,minxt,minyt,maxxt,maxyt;
long int i_mint,i_maxt;
int interpolatet,int_divt;
long int nptst;
float deltaht,deltavt,deltah_nt,deltav_nt,xmint,xmaxt,ymint,ymaxt,xmin_axist;
float xmax_axist,ymin_axist,ymax_axist,deltat,strt_valt;

long int i_truncatet1,i_truncatet2;
int iavg_wfms;


/* set of plotting variables for amplitude vs. frequency plots: */
int ndivha,ndivva,n_ha,n_va,extend_ticsa,minxa,minya,maxxa,maxya;
long int i_mina,i_maxa;
long int i_truncatea;
int interpolatea,int_diva;
long int nptsa;
float deltaha,deltava,deltah_na,deltav_na,xmina,xmaxa,ymina,ymaxa,xmin_axisa;
float xmax_axisa,ymin_axisa,ymax_axisa,strt_vala;

/* set of plotting variables for phase vs. frequency plots: */
int ndivhp,ndivvp,n_hp,n_vp,extend_ticsp,minxp,minyp,maxxp,maxyp;
long int i_minp,i_maxp;
long int i_truncatep;
int interpolatep,int_divp;
long int nptsp;
float deltahp,deltavp,deltah_np,deltav_np,xminp,xmaxp,yminp,ymaxp,xmin_axisp;
float xmax_axisp,ymin_axisp,ymax_axisp,strt_valp;
float Tg;

int minx,maxx,miny,maxy,maxcolor,i,color;
int graphics_window_created=0;
int minx_div,maxx_div,miny_div,maxy_div;
int minx_mult,maxx_mult,miny_mult,maxy_mult;



void plot_results(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,
long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,float *THD_v,
long double plot_array[]);

void setup_horiz_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,long int *i_truncate,
int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,float *xmax,
float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,float *ymin_axis,
float *ymax_axis,float *delta,float *strt_val,long double plot_array[]);


void setup_vert_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,
int *extend_tics,int *minx,int *miny,int *maxx,int *maxy,
long int *i_min,long int *i_max,long int *i_truncate,int *interpolate,
int *int_div,int *plot_mode,int *THD,long int *npts,float *deltah,
float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,
float *xmax_axis,float *ymin_axis,float *ymax_axis,float *delta,
float *strt_val,long double plot_array[]);


void draw_horiz_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,
int *extend_tics,int *minx,int *miny,int *maxx,int *maxy,long int *i_min,
long int *i_max,long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,
int *THD,long int *npts,float *deltah,float *deltav,float *deltah_n,
float *deltav_n,float *xmin,float *xmax,float *ymin,float *ymax,
float *xmin_axis,float *xmax_axis,float *ymin_axis,float *ymax_axis,
float *delta,float *strt_val,long double plot_array[],HDC draw_device_context);


void draw_vert_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,
int *extend_tics,int *minx,int *miny,int *maxx,int *maxy,long int *i_min,
long int *i_max,long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,
int *THD,long int *npts,float *deltah,float *deltav,float *deltah_n,
float *deltav_n,float *xmin,float *xmax,float *ymin,float *ymax,
float *xmin_axis,float *xmax_axis,float *ymin_axis,float *ymax_axis,
float *delta,float *strt_val,long double plot_array[],HDC draw_device_context);


void draw_cursor_vert(long int ix,int dotted,int id,int *minx,int *miny,
int *maxx,int *maxy,float *delta,float *strt_val,float *xmin_axis,
float *xmax_axis,HDC draw_device_context,HDC save_device_context,
COLORREF foreground_color,COLORREF background_color);

void erase_cursor_vert(long int ix,int id,int *minx,int *miny,int *maxx,
int *maxy,float *delta,float *strt_val,float *xmin_axis,float *xmax_axis,
HDC draw_device_context,HDC save_device_context);

void find_pixel(long int i_func,int *i_pix,int *minx,int *maxx,
float *delta,float *strt_val,float *xmin_axis,float *xmax_axis);

void plot(int *init_graph,int *ndivh,int *ndivv,
int *n_h,int *n_v,int *extend_tics,int *minx,int *miny,int *maxx,
int *maxy,long int *i_min,long int *i_max,long int *i_truncate,int *interpolate,
int *int_div,int *plot_mode,int *THD,long int *npts,float *deltah,
float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,
float *THD_v,long double plot_array[]);

void setup_plot(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,
long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,
int *THD,long int *npts,float * deltah,float *deltav,float *deltah_n,
float *deltav_n,float * xmin,float *xmax,float *ymin,float *ymax,
float *xmin_axis,float * xmax_axis,float *ymin_axis,float *ymax_axis,
float *delta,float *strt_val);


void display_value_c1(int loc,int minx,int maxx,int maxy,int i_min,
float value,float delta,float strt_val,HDC display_device_context);

void display_value_c2(int loc,int minx,int maxx,int maxy,
int i_min,float single,float delta,float strt_val,HDC display_device_context);

void display_THD(int *minx,int *maxx,int *maxy,float *THD_value,
  HDC display_device_context);

void display_iavg(int iavg_cnt,int minx,int maxx,int maxy,
  HDC display_device_context,COLORREF foreground_color,COLORREF background_color);

void tg_adjust(int plot_mode,long int i,float plot_in,float *plot_value);

void resample(float * t,long int * npts,float *delt,long double h[],
float *result,double pi);

// void itoa(int n, char s[]);
void reverse(char s[]);

int textwidth(int max_length,char *text);

float frac(float float_number);
int truncfi(float float_number);

void my_Rectangle(int x1,int y1r,int x2,int y2r,HDC rect_device_context,
COLORREF foreground_color,COLORREF background_color);

long int Round(double real_n); 

void dotted_line(int x1, int y1d, int x2, int y2d,
HDC draw_device_context,COLORREF foreground_color,
COLORREF background_color);

void graphics_window_init(void);

void graphics_window_end(void);

void create_memory_device_context(HDC window_device_context,
  HDC *memory_device_context,HBITMAP *memory_bitmap,
  int width_dc,int height_dc);

void transfer_device_context(HDC source_device_context,
  HDC destination_device_context,int xmin_imag,int ymax_imag,
  int width_dc,int height_dc);

int check_window_message(HWND window_handle);

void set_foreground_color(HDC set_device_context,COLORREF foreground_color);

void invalid_program_section(void);





// --------------------------------------------------------
void invalid_program_section(void)
{
  printf("Invalid code section was accessed\n");
  printf("Program will be terminated\n");
  printf("Press any A/N key to continue\n");
  wait_for_key_pressed();
  terminate_program();
}
// --------------------------------------------------------







// ------------------------------------------------------------------------
void set_foreground_color(HDC set_device_context,COLORREF foreground_color)
{
  color_ret = SetDCPenColor(set_device_context,foreground_color);
  obj_ret = SelectObject(set_device_context,GetStockObject(DC_BRUSH));
  if( (obj_ret==NULL) )
  {
    printf("Error in SelectObject in set_foreground_color()\n");
    printf("Program will be terminated\n");
    printf("Press any A/N key to continue\n");
    wait_for_key_pressed();
    terminate_program();
  }
  SetDCBrushColor(set_device_context,foreground_color);
  if(color_ret==CLR_INVALID)
  {
    printf("Error with SetDCPenColor in set_foreground_color()\n");
    printf("Program will be terminated\n");
    printf("Press any A/N key to continue\n");
    wait_for_key_pressed();
    terminate_program();
  }
}
// ---------------------------------------------------------------------






// ---------------------------------------------------------------
int check_window_message(HWND window_handle)
{
MSG msg;
int bRet,bRet2;

//while( (bRet = GetMessage( &msg, NULL, 0, 0 )) != 0)
//{
    bRet = PeekMessage(&msg,window_handle,0,0,PM_NOREMOVE);
    if(bRet != 0)
    { // bRet2 != 0
      bRet2 = GetMessage(&msg,window_handle,0,0);

//    if (bRet2 == -1)
      if(bRet2 < 0)
      {
          // handle the error and possibly exit
        return bRet2;
      }
      else
      {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
        return bRet2;
      }
    } // bRet2 != 0
    else
    {
      return 0;
    }
//}

}
// ----------------------------------------------------------------








// ----------------------------------------------------------------
void transfer_device_context(HDC source_device_context,
  HDC destination_device_context,int xmin_imag,int ymax_imag,
  int width_dc,int height_dc)
{
BOOL bitblt_ret;

  if
  (
    (source_device_context != NULL)
    &&
    (destination_device_context != NULL)
  )
  {
    bitblt_ret =
    BitBlt(destination_device_context,xmin_imag,ymax_imag,width_dc,height_dc,
      source_device_context,xmin_imag,ymax_imag,SRCCOPY);
    if(bitblt_ret==0)
    {
      printf("Error with BitBlt in transfer_device_context\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    }
  }
//  UpdateWindow(window_handle);
}
// ----------------------------------------------------------------








// --------------------------------------------------------------------
void create_memory_device_context(HDC window_device_context,
  HDC *memory_device_context,HBITMAP *memory_bitmap,
  int width_dc,int height_dc)
{
  *memory_device_context = CreateCompatibleDC(window_device_context);
// note: use window_device_context when creating the bitmap for
// *memory_device_context; this is because the format of bitmaps
// created for a memory device context is different than that for
// a window device context:
  *memory_bitmap =
    CreateCompatibleBitmap(window_device_context,width_dc,height_dc);

  SelectObject(*memory_device_context,*memory_bitmap);
}
// ---------------------------------------------------------------------






void graphics_window_init(void)
{

if(!graphics_window_created)
{ /* !graphics_window_created */

//  color_value[0] = RGB(255,255,255); // white
//  color_value[1] = RGB(0,0,255); // blue
//  color_value[2] = RGB(0,255,0); // green
//  color_value[3] = RGB(255,0,0); // red
//  color_value[4] = RGB(255,255,0); // yellow
//  color_value[5] = RGB(255,0,255); // magenta
//  color_value[6] = RGB(0,255,255); // cyan

  foreground_color = RGB(foreground_color_components[0],
    foreground_color_components[1],foreground_color_components[2]);

  background_color = RGB(background_color_components[0],
    background_color_components[1],background_color_components[2]);

  if(foreground_brush != NULL) DeleteObject(foreground_brush);
  foreground_brush = CreateSolidBrush(foreground_color);
  if(background_brush != NULL) DeleteObject(background_brush);
  background_brush = CreateSolidBrush(background_color);

  if((foreground_brush==NULL) || (background_brush==NULL))
  {
    printf("Error with CreateSolidBrush\n");
    printf("Program will be terminated\n");
    printf("Press any A/N key to continue\n");
    wait_for_key_pressed();
    terminate_program();
  }

/* Define maximum extents for the window */

  window_device_context = NULL;
  bool_ret_value =
    SystemParametersInfo(SPI_GETWORKAREA,0,&desktop_window_rect,0);

  if(bool_ret_value != 0)
  {
    minx = desktop_window_rect.left;
    maxx = desktop_window_rect.right;
    maxy = desktop_window_rect.top;
    miny = desktop_window_rect.bottom;
  }
  else
  {
    printf("Error - unable to obtain system parameters info\n");
    printf("Program will be terminated\n");
    printf("Press any A/N key to continue\n");
    wait_for_key_pressed();
    terminate_program();
  }

//  maxcolor = NUM_PRIMARY_COLORS; /* maximum number of defined primary colors */

  if(window_class==0)
  { // window_class==0
    window_class_struct.style =
      CS_GLOBALCLASS|CS_HREDRAW|CS_SAVEBITS|CS_VREDRAW;
    window_class_struct.lpfnWndProc =
      (WNDPROC) window_callback_function;
    window_class_struct.cbClsExtra = 0;
    window_class_struct.cbWndExtra = 0;
    window_class_struct.hInstance = window_hinstance;
    window_class_struct.hIcon = LoadIcon(NULL, IDI_APPLICATION); 
    window_class_struct.hCursor = LoadCursor(NULL, IDC_ARROW); 
    window_class_struct.hbrBackground = GetStockObject(BLACK_BRUSH);
    window_class_struct.lpszMenuName =  "Plot";
    window_class_struct.lpszClassName = "PlotWindowClass"; 

    window_class = RegisterClass(&window_class_struct);

    if(window_class == 0)
    {
      printf("Error - failed to register window class\n");
      printf("Program will be terminated\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
//      exit(1);
      terminate_program();
    }
  } // window_class==0

  /* Create a window */

  window_handle = CreateWindow("PlotWindowClass","GRAPHICS_WINDOW",
    WS_SIZEBOX|WS_SYSMENU|WS_CAPTION|WS_MINIMIZEBOX|WS_MAXIMIZEBOX,
    minx,maxy,maxx,miny,NULL,NULL,NULL,NULL);

  if(window_handle != NULL)
  {
    EnableWindow(window_handle,TRUE);
  }

  if(window_handle==NULL)
  {
    printf("Error - failed to create window\n");
    printf("Program will be terminated\n");
    printf("Press any A/N key to continue\n");
    wait_for_key_pressed();
    terminate_program();
  }

  ShowWindow(window_handle,SW_SHOW);

  graphics_window_created = 1;

} /* !graphics_window_created */

}; /* end graphics_window_init */





// ---------------------------------------------------------------------------------
void graphics_window_end(void)
{
if(graphics_window_created)
{
/* clean up */
  if(window_handle != NULL)
  {
    CloseWindow(window_handle);
    DestroyWindow(window_handle);
    window_handle = NULL;
  }
  if(memory_bitmap != NULL) DeleteObject(memory_bitmap);
  if(memory_bitmap_untouched != NULL) DeleteObject(memory_bitmap_untouched);
  if(memory_bitmap_blank != NULL) DeleteObject(memory_bitmap_blank);
  if(memory_device_context != NULL) DeleteDC(memory_device_context);
  if(memory_device_context_untouched != NULL) DeleteDC(memory_device_context_untouched);
  if(memory_device_context_blank != NULL) DeleteDC(memory_device_context_blank);
  if(window_device_context != NULL) DeleteDC(window_device_context);
  memory_bitmap = NULL;
  memory_bitmap_untouched = NULL;
  memory_bitmap_blank = NULL;
  memory_device_context = NULL;
  memory_device_context_untouched = NULL;
  memory_device_context_blank = NULL;
  window_device_context = NULL;

  graphics_window_created=0;
}; /* graphics_window_created */
};
// -----------------------------------------------------------------------------------





void dotted_line(int x1, int y1, int x2, int y2,
HDC draw_device_context,COLORREF foreground_color,
COLORREF background_color)
{

float dot_length;
float length,x_step,y_step,ratio;
float xl1,xl2,yl1,yl2;
int i_alt;

dot_length = 2.0;
set_foreground_color(draw_device_context,foreground_color);

length = sqrt( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) );
if(length>0.0)
{
  ratio = dot_length / length;
  if(ratio>1.0) ratio = 1.0;
  x_step = (x2-x1)*ratio;
  y_step = (y2-y1)*ratio;
  xl1 = x1;
  yl1 = y1;
  i_alt = 1;
  while( ((xl2 = xl1+x_step) <= x2) && ((yl2 = yl1+y_step) <= y2) )
  {
    if(i_alt>0)
    {
      MoveToEx(draw_device_context,xl1,yl1,NULL);
      LineTo(draw_device_context,xl2,yl2);
    };
    if(i_alt==1)
    {
      i_alt = -1;
    }
    else
    {
      i_alt = i_alt + 1;
    };
    xl1 = xl2;
    yl1 = yl2;
  };
  MoveToEx(draw_device_context,xl1,yl1,NULL);
  LineTo(draw_device_context,x2,y2);
} /* length>0.0 */


} /* end dotted_line */





/* -------------------------------------------------------------------- */
/*
  The following routine draws a rectangle.
*/

void my_Rectangle(int x1,int y1r,int x2,int y2r,
HDC rect_device_context,COLORREF foreground_color,
COLORREF background_color)
{
  set_foreground_color(rect_device_context,foreground_color);

  MoveToEx(rect_device_context,x1,y1r,NULL);
  LineTo(rect_device_context,x2,y1r);
  LineTo(rect_device_context,x2,y2r);
  LineTo(rect_device_context,x1,y2r);
  LineTo(rect_device_context,x1,y1r);

};
/* --------------------------------------------------------------------- */






/* ----------------------------------------------------------------------- */
/*
This routine returns the fractional part of float_number. Note that if
float_number is negative the fractional part will also be negative.
*/

float frac(float float_number)
{

long int integral_part;
float float_whole_number,float_return;


  integral_part = float_number; 
  float_whole_number = integral_part;
  float_return = float_number - float_whole_number;
  return float_return;

};
/* ------------------------------------------------------------------------ */





/* ------------------------------------------------------------------------ */
/*
The following routine truncates float_number toward zero.
*/

int truncfi(float float_number)
{

int integral_part;

  integral_part = float_number;
  return integral_part;

};
/* ------------------------------------------------------------------------- */





/* ------------------------------------------------------------------------ */
int textwidth(int max_length,char *text)
{

int i_text,textwidth_return;

  i_text = -1;
  do
  {
    i_text = i_text + 1;
  }
  while( (text[i_text] != '\0') && (i_text < max_length) );

  textwidth_return = i_text * text_char_width;
  return textwidth_return;

};
/* ------------------------------------------------------------------------ */
  






///*------------------------------------------------------------------------ */
//void itoa(int n, char s[])
//{
//  int i,sign;
//
//  if((sign=n)<0)
//  n = -n; /* record sign and make n positive */
//  i = 0;
//  do  /* generate digits in reverse order  */
//  {
//    s[i++] = n % 10 + '0'; /* get next digit */
//  }
//  while((n /= 10) > 0); /* delete it */
//  if(sign < 0) s[i++] = '-';
//  s[i] = '\0';
//  reverse(s);
//};
///* ------------------------------------------------------------------------ */







/* ------------------------------------------------------------------------ */
void reverse(char s[])
{
  int c,i,j;

  for(i=0, j=strlen(s)-1; i < j; i++, j--)
  {
    c = s[i];
    s[i] = s[j];
    s[j] = c;
  }
};
/* ----------------------------------------------------------------------- */








/* ---------------------------------------------------------------------- */
void plot_results(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,
long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,float *THD_v,
long double plot_array[])
{


char ascii_plot,ascii_trnc;
int quit_pr,quit_trnc;
int init_graph;
int trnc_flag;
int i_curs;
int quit_curs;
char ascii_curs;
long int loc_curs[2];
int selct_curs;
int curs_app[2];
long int accel_mode;
float plot_value;



  quit_pr = 0;
  init_graph = 0;
  event_type = 0;
  ascii_plot = '0';
  window_keycode = '0';

// clear the buffer:
do
{
  if(window_handle != NULL) check_window_message(window_handle);
}
while((window_handle != NULL) && (event_type!=0));


do
{  /* plot_results main do loop */

// plots in window_device_context, copies to memory_device_context
// and memory_device_context_untouched, generates WM_PAINT:
  plot(&init_graph,ndivh,ndivv,n_h,n_v,extend_tics,
  minx,miny,maxx,maxy,i_min,i_max,i_truncate,interpolate,int_div,
  plot_mode,THD,npts,deltah,deltav,deltah_n,deltav_n,xmin,xmax,
  ymin,ymax,xmin_axis,xmax_axis,ymin_axis,ymax_axis,delta,strt_val,
  THD_v,&plot_array[0]);

  do
  {
    if(window_handle != NULL) check_window_message(window_handle);
  }
  while(event_type==0);

  if(event_type==KeyPressEvent)
  {
    ascii_plot=window_keycode;
    event_type=0;
  };

  if( my_toupper(ascii_plot) == 'Q' )
  {
    quit_pr = 1;
  };

  if(my_toupper(ascii_plot)=='C')
  {  /* section for vertical cursors */
/*
 To enable cursors, C must first be typed. The arrow keys are then
 used to move the cursors, while T toggles between cursors. D resets
 cursors to the default positions. Q exits the cursor section. Upon
 exiting, the plot will be re-defined between the cursor values, if
 non-default settings have been setup.
 'A' accelerates the cursor movement, 'B' decelerates cursor movement,
 when using the arrow keys.
*/
    quit_curs = 0;
    accel_mode = 0; /* used to speed up the effect of the arrow keys */

/* initialize cursor positions: */
    loc_curs[0] = *i_min;
    loc_curs[1] = *i_max;

 /* draw c1 (solid line) */
    draw_cursor_vert(loc_curs[0],0,1,minx,miny,maxx,maxy,delta,strt_val,
    xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched,
    foreground_color,background_color);

 /* draw c2 (dotted line) */
    draw_cursor_vert(loc_curs[1],1,2,minx,miny,maxx,maxy,delta,strt_val,
    xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched,
    foreground_color,background_color);

    tg_adjust(*plot_mode,loc_curs[0]-1,plot_array[loc_curs[0]-1],
      &plot_value);

    display_value_c1(loc_curs[0],*minx,*maxx,*maxy,*i_min,
    plot_value,*delta,*strt_val,window_device_context);

    tg_adjust(*plot_mode,loc_curs[1]-1,plot_array[loc_curs[1]-1],
      &plot_value);

    display_value_c2(loc_curs[1],*minx,*maxx,*maxy,*i_min,
    plot_array[loc_curs[1]-1],*delta,*strt_val,window_device_context);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
    transfer_device_context(window_device_context,
    memory_device_context,Client_Rect.left,Client_Rect.top,
    width_dc,height_dc);

    selct_curs = 1; /* start with c1 selected */
    curs_app[0] = 0; /* solid line for c1 */
    curs_app[1] = 1; /* dotted line for c2 */
    do  /* section to move cursors */
    {

    do
    {
      if(window_handle != NULL) check_window_message(window_handle);
    }
    while(event_type==0);

    if(event_type==KeyPressEvent)
    {
      ascii_curs=window_keycode;
      event_type=0;
      window_keycode=0;
    };

      if(my_toupper(ascii_curs)=='A')
      {
        if(accel_mode==0)
        {
          accel_mode=10;
        }
        else
        {
          if(accel_mode<1000)
          {
            accel_mode = accel_mode * 10;
          }
        }
      };

      if(my_toupper(ascii_curs)=='B')
      {
        accel_mode = accel_mode/10;
      } 

      if(my_toupper(ascii_curs) == 'D')
      {  /* go back to default cursor positions */

        erase_cursor_vert(loc_curs[0],1,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

        erase_cursor_vert(loc_curs[1],2,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
        transfer_device_context(window_device_context,
        memory_device_context,Client_Rect.left,Client_Rect.top,
        width_dc,height_dc);

        *i_min = 1;
        if(*plot_mode>1)
        {
          *i_max = (*npts/2) + 1;
        }
        else
        {
          *i_max = *npts;
        };

        *xmin = *strt_val;
        *xmax = (*i_max-1) * *delta + *strt_val;

        setup_horiz_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
        maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
        deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
        xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);

        setup_vert_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
        maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
        deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
        xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);

        plot(&init_graph,ndivh,ndivv,n_h,n_v,extend_tics,
          minx,miny,maxx,maxy,i_min,i_max,i_truncate,interpolate,int_div,
          plot_mode,THD,npts,deltah,deltav,deltah_n,deltav_n,xmin,xmax,
          ymin,ymax,xmin_axis,xmax_axis,ymin_axis,ymax_axis,delta,strt_val,
          THD_v,&plot_array[0]);
        loc_curs[0] = *i_min;
        loc_curs[1] = *i_max;

        draw_cursor_vert(loc_curs[0],curs_app[0],1,minx,miny,maxx,maxy,delta,
        strt_val,xmin_axis,xmax_axis,window_device_context,
        memory_device_context_untouched,foreground_color,background_color);

        draw_cursor_vert(loc_curs[1],curs_app[1],2,minx,miny,maxx,maxy,delta,
        strt_val,xmin_axis,xmax_axis,window_device_context,
        memory_device_context_untouched,foreground_color,background_color);

        tg_adjust(*plot_mode,loc_curs[0]-1,plot_array[loc_curs[0]-1],
          &plot_value);

        display_value_c1(loc_curs[0],*minx,*maxx,*maxy,*i_min,
        plot_value,*delta,*strt_val,window_device_context);

        tg_adjust(*plot_mode,loc_curs[1]-1,plot_array[loc_curs[1]-1],
          &plot_value);

        display_value_c2(loc_curs[1],*minx,*maxx,*maxy,*i_min,
        plot_array[loc_curs[1]-1],*delta,*strt_val,window_device_context);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
        transfer_device_context(window_device_context,
        memory_device_context,Client_Rect.left,Client_Rect.top,
        width_dc,height_dc);

      };

      if(my_toupper(ascii_curs) == 'T')
      {  /* toggle cursor selection */
        if(selct_curs==1)
        {  /* select c2 */
          selct_curs = 2;
          erase_cursor_vert(loc_curs[0],1,minx,miny,maxx,maxy,delta,strt_val,
          xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

          draw_cursor_vert(loc_curs[0],1,1,minx,miny,maxx,maxy,
          delta,strt_val,xmin_axis,xmax_axis,window_device_context,
          memory_device_context_untouched,foreground_color,background_color);

          erase_cursor_vert(loc_curs[1],2,minx,miny,maxx,maxy,delta,strt_val,
          xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

          draw_cursor_vert(loc_curs[1],0,2,minx,miny,maxx,maxy,
          delta,strt_val,xmin_axis,xmax_axis,window_device_context,
          memory_device_context_untouched,foreground_color,background_color);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
          transfer_device_context(window_device_context,
          memory_device_context,Client_Rect.left,Client_Rect.top,
          width_dc,height_dc);

          curs_app[1] = 0;
          curs_app[0] = 1;
        }
        else
        {  /* select c1 */
          selct_curs = 1;
          erase_cursor_vert(loc_curs[0],1,minx,miny,maxx,maxy,delta,strt_val,
          xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

          draw_cursor_vert(loc_curs[0],0,1,minx,miny,maxx,maxy,
          delta,strt_val,xmin_axis,xmax_axis,window_device_context,
          memory_device_context_untouched,foreground_color,background_color);

          erase_cursor_vert(loc_curs[1],2,minx,miny,maxx,maxy,delta,strt_val,
          xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

          draw_cursor_vert(loc_curs[1],1,2,minx,miny,maxx,maxy,
          delta,strt_val,xmin_axis,xmax_axis,window_device_context,
          memory_device_context_untouched,foreground_color,background_color);

          curs_app[0] = 0;
          curs_app[1] = 1;

// copy to memory_device_context in case we get a WM_PAINT interrupt:
          transfer_device_context(window_device_context,
          memory_device_context,Client_Rect.left,Client_Rect.top,
          width_dc,height_dc);
        };
      };  /* end toggle cursor section */

        if(ascii_curs==ASCII_WINDOW_LEFT_ARROW)
        {  /* left arrow */

          erase_cursor_vert(loc_curs[selct_curs-1],selct_curs,minx,miny,maxx,
          maxy,delta,strt_val,xmin_axis,xmax_axis,window_device_context,
          memory_device_context_untouched);

          if(accel_mode>0)
          {
            loc_curs[selct_curs-1] = loc_curs[selct_curs-1] - accel_mode;
          }
          else
          {
            loc_curs[selct_curs-1] = loc_curs[selct_curs-1] - 1;
          };

          if(loc_curs[selct_curs-1]<*i_min)
          {
            loc_curs[selct_curs-1] = *i_min;
          };

          /* draw cursor in new location: */
          draw_cursor_vert(loc_curs[selct_curs-1],curs_app[selct_curs-1],
          selct_curs,minx,miny,maxx,maxy,delta,strt_val,xmin_axis,xmax_axis,
          window_device_context,memory_device_context_untouched,foreground_color,
          background_color);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
          transfer_device_context(window_device_context,
          memory_device_context,Client_Rect.left,Client_Rect.top,
          width_dc,height_dc);


          if(selct_curs==1)
          {
            tg_adjust(*plot_mode,loc_curs[selct_curs-1]-1,
              plot_array[loc_curs[selct_curs-1]-1],&plot_value);
            display_value_c1(loc_curs[selct_curs-1],*minx,*maxx,*maxy,*i_min,
              plot_value,*delta,*strt_val,window_device_context);
// copy to memory_device_context in case we get a WM_PAINT interrupt:
            transfer_device_context(window_device_context,
            memory_device_context,Client_Rect.left,Client_Rect.top,
            width_dc,height_dc);

          }
          else
          {
            tg_adjust(*plot_mode,loc_curs[selct_curs-1]-1,
              plot_array[loc_curs[selct_curs-1]-1],&plot_value);
            display_value_c2(loc_curs[selct_curs-1],*minx,*maxx,*maxy,*i_min,
              plot_value,*delta,*strt_val,window_device_context);
// copy to memory_device_context in case we get a WM_PAINT interrupt:
            transfer_device_context(window_device_context,
            memory_device_context,Client_Rect.left,Client_Rect.top,
            width_dc,height_dc);
          };

        };  /* end left arrow */

        if(ascii_curs==ASCII_WINDOW_RIGHT_ARROW)
        {  /* right arrow */

          erase_cursor_vert(loc_curs[selct_curs-1],selct_curs,minx,miny,maxx,
          maxy,delta,strt_val,xmin_axis,xmax_axis,window_device_context,
          memory_device_context_untouched);

          if(accel_mode>0)
          {
            loc_curs[selct_curs-1] = loc_curs[selct_curs-1] + accel_mode;
          }
          else
          {
            loc_curs[selct_curs-1] = loc_curs[selct_curs-1] + 1;
          };

          if(loc_curs[selct_curs-1]>*i_max)
          {
            loc_curs[selct_curs-1] = *i_max;
          };

          /* draw cursor in new location: */
          draw_cursor_vert(loc_curs[selct_curs-1],curs_app[selct_curs-1],
          selct_curs,minx,miny,maxx,maxy,delta,strt_val,xmin_axis,xmax_axis,
          window_device_context,memory_device_context_untouched,foreground_color,
          background_color);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
          transfer_device_context(window_device_context,
          memory_device_context,Client_Rect.left,Client_Rect.top,
          width_dc,height_dc);


          if(selct_curs==1)
          {
            tg_adjust(*plot_mode,loc_curs[selct_curs-1]-1,
              plot_array[loc_curs[selct_curs-1]-1],&plot_value);
            display_value_c1(loc_curs[selct_curs-1],*minx,*maxx,*maxy,*i_min,
              plot_value,*delta,*strt_val,window_device_context);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
            transfer_device_context(window_device_context,
            memory_device_context,Client_Rect.left,Client_Rect.top,
            width_dc,height_dc);
          }
          else
          {
            tg_adjust(*plot_mode,loc_curs[selct_curs-1]-1,
              plot_array[loc_curs[selct_curs-1]-1],&plot_value);
            display_value_c2(loc_curs[selct_curs-1],*minx,*maxx,*maxy,*i_min,
              plot_value,*delta,*strt_val,window_device_context);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
            transfer_device_context(window_device_context,
            memory_device_context,Client_Rect.left,Client_Rect.top,
            width_dc,height_dc);
          };

        }; /* end right arrow */

      if(my_toupper(ascii_curs)=='Q')
      {
        quit_curs = 1;
      };
    }
    while(!quit_curs); /* end section to move cursors */

    if(loc_curs[0]<=loc_curs[1])
    {  /* re-define horizontal plot boundaries */
      *i_min = loc_curs[0];
      *i_max = loc_curs[1];
    }
    else
    {
      *i_min = loc_curs[1];
      *i_max = loc_curs[0];
    };
    *xmin = (*i_min-1) * *delta + *strt_val;
    *xmax = (*i_max-1) * *delta + *strt_val;

    setup_horiz_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);

    setup_vert_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);

  /* remove final cursors from memory */
  erase_cursor_vert(loc_curs[0],1,minx,miny,maxx,maxy,delta,strt_val,
  xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

  erase_cursor_vert(loc_curs[1],2,minx,miny,maxx,maxy,delta,strt_val,
  xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

  plot(&init_graph,ndivh,ndivv,n_h,n_v,extend_tics,
    minx,miny,maxx,maxy,i_min,i_max,i_truncate,interpolate,int_div,
    plot_mode,THD,npts,deltah,deltav,deltah_n,deltav_n,xmin,xmax,
    ymin,ymax,xmin_axis,xmax_axis,ymin_axis,ymax_axis,delta,strt_val,
    THD_v,&plot_array[0]);

  }; /* end section for vertical cursors */



  if(my_toupper(ascii_plot) == 'T')
  {  /* section to truncate waveform */

    if(*i_truncate > *i_max)
    {
      *i_truncate = *i_max;
    };

    quit_trnc = 0;
    accel_mode = 0; /* used to speed up the effect of the arrow keys */
    plot(&init_graph,ndivh,ndivv,n_h,n_v,extend_tics,
      minx,miny,maxx,maxy,i_min,i_max,i_truncate,interpolate,int_div,
      plot_mode,THD,npts,deltah,deltav,deltah_n,deltav_n,xmin,xmax,
      ymin,ymax,xmin_axis,xmax_axis,ymin_axis,ymax_axis,delta,strt_val,
      THD_v,&plot_array[0]);

 /* draw initial cursor */
    draw_cursor_vert(*i_truncate,0,1,minx,miny,maxx,maxy,delta,strt_val,
    xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched,
    foreground_color,background_color);


    tg_adjust(*plot_mode,*i_truncate-1,
      plot_array[*i_truncate-1],&plot_value);
    display_value_c1(*i_truncate,*minx,*maxx,*maxy,*i_min,
      plot_value,*delta,*strt_val,window_device_context);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
    transfer_device_context(window_device_context,
    memory_device_context,Client_Rect.left,Client_Rect.top,
    width_dc,height_dc);

  do
  { // truncate do loop

    do
    {
      if(window_handle != NULL) check_window_message(window_handle);
    }
    while(event_type==0);

    if(event_type==KeyPressEvent)
    {
      ascii_trnc=window_keycode;
      event_type=0;
    };

    if(my_toupper(ascii_trnc)=='A')
    {
      if(accel_mode==0)
      {
        accel_mode=10;
      }
      else
      {
        if(accel_mode<1000)
        {
          accel_mode = accel_mode * 10;
        }
      }
    };

    if(my_toupper(ascii_trnc)=='B')
    {
      accel_mode = accel_mode/10;
    } 

    if(my_toupper(ascii_trnc)=='Q')
    {
      quit_trnc = 1;
    };

    if(my_toupper(ascii_trnc)=='D')
    {  /* reset to default case of no truncation */

      erase_cursor_vert(*i_truncate,1,minx,miny,maxx,maxy,delta,strt_val,
      xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

      *i_truncate = *i_max;
      draw_cursor_vert(*i_truncate,0,1,minx,miny,maxx,maxy,delta,strt_val,
      xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched,
      foreground_color,background_color);


      tg_adjust(*plot_mode,*i_truncate-1,
        plot_array[*i_truncate-1],&plot_value);
      display_value_c1(*i_truncate,*minx,*maxx,*maxy,*i_min,
        plot_value,*delta,*strt_val,window_device_context);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
        transfer_device_context(window_device_context,
        memory_device_context,Client_Rect.left,Client_Rect.top,
        width_dc,height_dc);

    };  /* end default case */

      if(ascii_trnc==ASCII_WINDOW_LEFT_ARROW)
      {  /* left arrow */

        erase_cursor_vert(*i_truncate,1,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

        if(accel_mode>0)
        {
          *i_truncate = *i_truncate - accel_mode;
        }
        else
        {
          *i_truncate = *i_truncate - 1;
        };

        if(*i_truncate<*i_min)
        {
          *i_truncate = *i_max; /* wrap around */
        };
        draw_cursor_vert(*i_truncate,0,1,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched,
        foreground_color,background_color);

        display_value_c1(*i_truncate,*minx,*maxx,*maxy,*i_min,
          plot_array[*i_truncate-1],*delta,*strt_val,window_device_context);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
        transfer_device_context(window_device_context,
          memory_device_context,Client_Rect.left,Client_Rect.top,
          width_dc,height_dc);

      }; /* end left arrow */

      if(ascii_trnc==ASCII_WINDOW_RIGHT_ARROW)
      {  /* right arrow */

        erase_cursor_vert(*i_truncate,1,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

        if(accel_mode>0)
        {
          *i_truncate = *i_truncate + accel_mode;
        }
        else
        {
          *i_truncate = *i_truncate + 1;
        };

        if(*i_truncate>*i_max)
        {
          *i_truncate = *i_min; /* wrap around */
        };
        draw_cursor_vert(*i_truncate,0,1,minx,miny,maxx,maxy,delta,strt_val,
        xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched,
        foreground_color,background_color);
        tg_adjust(*plot_mode,*i_truncate-1,
          plot_array[*i_truncate-1],&plot_value);
        display_value_c1(*i_truncate,*minx,*maxx,*maxy,*i_min,
          plot_value,*delta,*strt_val,window_device_context);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
        transfer_device_context(window_device_context,
          memory_device_context,Client_Rect.left,Client_Rect.top,
          width_dc,height_dc);

      };  /* end right arrow */

  } // truncate do loop
  while(!quit_trnc);

  /* free final cursor memory */
  erase_cursor_vert(*i_truncate,1,minx,miny,maxx,maxy,delta,strt_val,
  xmin_axis,xmax_axis,window_device_context,memory_device_context_untouched);

// copy to memory_device_context in case we get a WM_PAINT interrupt:
  transfer_device_context(window_device_context,
    memory_device_context,Client_Rect.left,Client_Rect.top,
    width_dc,height_dc);

  };  /* end section to truncate waveform */
}  /* end plot_results main do loop */
while(!quit_pr);

ascii_plot='0';
ascii_curs='0';
ascii_trnc='0';
quit_pr=0;

};
/* ---------------------------------------------------------------------- */



/* ------------------------------------------------------------------------ */
void display_value_c1(int loc,int minx,int maxx,int maxy,int i_min,
float value,float delta,float strt_val,HDC display_device_context)
{


char disp1_str[200];
char disp2_str[50];
int ilocx,ilocy;
float x;
RECT display_c1_rect;



  x = (loc-1)*delta + strt_val;

  sprintf(&disp1_str[0],"%d",loc); /* convert int loc to a string */
  disp2_str[0] = ':';
  disp2_str[1] = '\0';
  strcat(disp1_str,disp2_str);

  sprintf(&disp2_str[0],"%12e",x); /* convert x-value to a string */
  strcat(disp1_str,disp2_str);
  disp2_str[0] = ':';
  disp2_str[1] = '\0';
  strcat(disp1_str,disp2_str);

  sprintf(&disp2_str[0],"%12e",value); /* convert y-value to a string */
  strcat(disp1_str,disp2_str);

  ilocx = minx / 2;
  ilocy = maxy-3*text_height-2*tic_offset-1;

  display_c1_rect.left = ilocx-textwidth(100,disp1_str)*text_char_width/2;
  display_c1_rect.right = ilocx+textwidth(100,disp1_str)*text_char_width/2;
  display_c1_rect.top = ilocy-text_height-1;
  display_c1_rect.bottom = ilocy+text_height+1;
/* erase the area where the string will be placed: */
/* Text appears to be centered in x and at the bottom in y */
//  FillRect(display_device_context,&display_c1_rect,
//    (HBRUSH)GetStockObject(BLACK_BRUSH));
  FillRect(display_device_context,&display_c1_rect,
    background_brush);
 
/* put disp1_str on the screen */
  TextOut(display_device_context,ilocx,ilocy,&disp1_str[0],
    strlen(&disp1_str[0]));

};
/* ------------------------------------------------------------------------ */





/* ------------------------------------------------------------------------ */
void display_THD(int *minx,int *maxx,int *maxy,float *THD_value,
  HDC display_device_context)
{


char disp1_str[200];
char disp2_str[50];
int ilocx,ilocy;
RECT display_THD_rect;



  disp1_str[0] = 'T';
  disp1_str[1] = 'H';
  disp1_str[2] = 'D';
  disp1_str[3] = ' ';
  disp1_str[4] = '=';
  disp1_str[5] = ' ';
  disp1_str[6] = '\0';

  sprintf(&disp2_str[0],"%12e",*THD_value); /* convert THD_value to a string */
  strcat(disp1_str,disp2_str);

  ilocx = *minx;
  ilocy = *maxy-3*text_height-2*tic_offset-1;


  display_THD_rect.left = ilocx-textwidth(100,disp1_str)*text_char_width/2;
  display_THD_rect.right = ilocx+textwidth(100,disp1_str)*text_char_width/2;
  display_THD_rect.top = ilocy-text_height-1;
  display_THD_rect.bottom = ilocy+text_height+1;
/* erase the area where the string will be placed: */
/* Text appears to be centered in x and at the bottom in y */
//  FillRect(display_device_context,&display_THD_rect,
//    (HBRUSH)GetStockObject(BLACK_BRUSH));
  FillRect(display_device_context,&display_THD_rect,
    background_brush);
 
/* put disp1_str on the screen */
  TextOut(display_device_context,ilocx,ilocy,&disp1_str[0],
    strlen(&disp1_str[0]));

  InvalidateRgn(window_handle,NULL,TRUE);

};
/* ------------------------------------------------------------------------ */







/* ------------------------------------------------------------------------ */
void display_value_c2(int loc,int minx,int maxx,int maxy,int i_min,
float value,float delta,float strt_val,HDC display_device_context)
{


char disp1_str[200];
char disp2_str[50];
int ilocx,ilocy;
float x;
RECT display_c2_rect;



  x = (loc-1)*delta + strt_val;

  sprintf(&disp1_str[0],"%d",loc); /* convert int loc to a string */
  disp2_str[0] = ':';
  disp2_str[1] = '\0';
  strcat(disp1_str,disp2_str);

  sprintf(&disp2_str[0],"%12e",x); /* convert x-value to a string */
  strcat(disp1_str,disp2_str);
  disp2_str[0] = ':';
  disp2_str[1] = '\0';
  strcat(disp1_str,disp2_str);

  sprintf(&disp2_str[0],"%12e",value); /* convert y-value to a string */
  strcat(disp1_str,disp2_str);

  ilocx = maxx - textwidth(200,&disp1_str[0]) + (minx / 2);
  ilocy = maxy-3*text_height-2*tic_offset-1;

  display_c2_rect.left = ilocx-textwidth(100,disp1_str)*text_char_width/2;
  display_c2_rect.right = ilocx+textwidth(100,disp1_str)*text_char_width/2;
  display_c2_rect.top = ilocy-text_height-1;
  display_c2_rect.bottom = ilocy+text_height+1;
/* erase the area where the string will be placed: */
/* Text appears to be centered in x and at the bottom in y */
//  FillRect(display_device_context,&display_c2_rect,
//    (HBRUSH)GetStockObject(BLACK_BRUSH));
  FillRect(display_device_context,&display_c2_rect,
    background_brush);
 
/* put disp1_str on the screen */
  TextOut(display_device_context,ilocx,ilocy,&disp1_str[0],
    strlen(&disp1_str[0]));

};
/* ------------------------------------------------------------------------ */








/* ------------------------------------------------------------------------- */
/*
 This procedure determines the number of increments and the numerical
 increment value for the horizontal axis.
*/
void setup_horiz_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,
long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,
long double plot_array[])
{

#define dim_table_h 5



float log_10_max,rnmax;
int ih;
float table_h[dim_table_h];
float delta_h[dim_table_h];



/*
 Set up possible normalized horizontal axis ranges. Note: although 0.1
 is included, it should never be selected; 1.0 should be used instead.
*/
  table_h[0] = 10.0;
  table_h[1] = 5.0;
  table_h[2] = 2.5;
  table_h[3] = 2.0;
  table_h[4] = 1.0;

/* set up normalized axis increments for the above cases: */
  delta_h[0] = 1.0;
  delta_h[1] = 0.5;
  delta_h[2] = 0.25;
  delta_h[3] = 0.2;
  delta_h[4] = 0.1;

  log_10_max = log(*xmax-*xmin) / ln_10;

  if(frac(log_10_max)>=0.0)
  {
    *n_h = truncfi(log_10_max);
  }
  else 
  {
    *n_h = truncfi(log_10_max)-1;
  };

/* normalize in range 1.0<=rnmax<=10.0 */
  rnmax = (*xmax-*xmin) / exp(*n_h * ln_10);

  ih = 0;
  do
  {
    ih = ih + 1;
  }
  while(!(  ((rnmax>table_h[ih]) && (rnmax<=table_h[ih-1]) ) || (ih==
    dim_table_h-1)  )  );

/* use table_h[ih-1] as max horizontal axis range, n_h as normalizing exponent */
/* set up axis according to selected i_h entry: */

/* un-normalized axis increment: */
  *deltah = delta_h[ih-1] * exp(*n_h * ln_10);
/* normalized axis increment: */
  *deltah_n = delta_h[ih-1];

  *ndivh = truncfi( ( *xmax- *xmin)/ *deltah );
/* extend axis if necessary to display all data: */
  if( (*ndivh * *deltah)!=(xmax-xmin) )
  {
    *ndivh = *ndivh + 1;
  };

  *xmin_axis = *xmin;
  *xmax_axis = *xmin + *ndivh * *deltah;

};  /* end setup_horiz_axis */
/* ---------------------------------------------------------------------- */



/* ------------------------------------------------------------------------- */
/*
 This procedure determines the number of increments and the numerical
 increment value for the vertical axis.
*/
void setup_vert_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx, int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,long int *i_truncate,
int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,
long double plot_array[])
{

#define dim_table_v 5



float log_10_max,rnmax;
int iv;
float table_v[dim_table_v];
float delta_v[dim_table_v];



/*
 Set up possible normalized vertical axis ranges. Note: although 0.1
 is included, it should never be selected; 1.0 should be used instead.
*/
  table_v[0] = 10.0;
  table_v[1] = 5.0;
  table_v[2] = 2.5;
  table_v[3] = 2.0;
  table_v[4] = 1.0;

/* set up normalized axis increments for the above cases: */
  delta_v[0] = 1.0;
  delta_v[1] = 0.5;
  delta_v[2] = 0.25;
  delta_v[3] = 0.2;
  delta_v[4] = 0.1;

  log_10_max = log(*ymax-*ymin) / ln_10;

  if(frac(log_10_max)>=0.0)
  {
    *n_v = truncfi(log_10_max);
  }
  else 
  {
    *n_v = truncfi(log_10_max)-1;
  };

/* normalize in range 1.0<=rnmax<=10.0 */
  rnmax = (*ymax-*ymin) / exp(*n_v * ln_10);

  iv = 0;
  do
  {
    iv = iv + 1;
  }
  while(!(   ((rnmax>table_v[iv]) && (rnmax<=table_v[iv-1]) ) || (iv==
    dim_table_v-1)  ) );

/* use table_v[iv-1] as max vertical axis range, n_v as normalizing exponent */
/* set up axis according to selected i_v entry: */

/* un-normalized axis increment: */
  *deltav = delta_v[iv-1] * exp(*n_v * ln_10);
/* normalized axis increment: */
  *deltav_n = delta_v[iv-1];

  *ndivv = truncfi( ( *ymax - *ymin) / *deltav );
/* extend axis if necessary to display all data: */
  if( (*ndivv *  *deltav)!=(*ymax-*ymin) )
  {
    *ndivv = *ndivv + 1;
  };

  *ymin_axis = *ymin;
  *ymax_axis = *ymin + *ndivv * *deltav;

}; /* end setup_vert_axis */
/* ---------------------------------------------------------------------- */




/* ---------------------------------------------------------------------- */
void draw_horiz_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,long int *i_truncate,
int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,
long double plot_array[],HDC draw_device_context)
{


int i_h,hloc_pix;
float rminx,rmaxx,rloc,rdelx;
long int h_long;
char xmin_str[50];
char xmax_str[50];
char horiz1_str[50];
char horiz2_str[50];
int ilocx,ilocy;



  rminx = *minx;
  rmaxx = *maxx;
  rdelx = (rmaxx-rminx)/ *ndivh;


/* draw rectangle defining the plot boundaries */
//  color = 1;
  my_Rectangle(*minx,*miny,*maxx,*maxy,draw_device_context,
  foreground_color,background_color);

  if(*extend_tics==0)
  {  /* only draw short tic marks on axes */

  for(i_h=2; i_h <= *ndivh; i_h++)
  {
    rloc = rminx + (i_h-1) * rdelx;
    h_long = Round(rloc); /* Round returns longint value */
    hloc_pix = h_long; /* convert to integer for Line procedure */
    /* set foreground color and draw tic mark: */
    set_foreground_color(draw_device_context,foreground_color);
    MoveToEx(draw_device_context,hloc_pix,*miny+tic_offset,NULL);
    LineTo(draw_device_context,hloc_pix,*miny-tic_offset);

  };

  }
  else
  {  /* draw interior dotted lines */

  for(i_h=1; i_h < *ndivh; i_h++)
  {
    rloc = rminx + i_h * rdelx;
    h_long = Round(rloc); /* Round returns longint value */
    hloc_pix = h_long; /* convert to integer for Line procedure */
    dotted_line(hloc_pix,*miny,hloc_pix,*maxy,draw_device_context,
    foreground_color,background_color);
  };

  };

/* convert axis endpoint values to strings for labelling: */
  sprintf(&xmin_str[0],"%14e",*xmin_axis); /* convert xmin_axis to a string */
  sprintf(&xmax_str[0],"%14e",*xmax_axis); /* convert xmax_axis to a string */

  ilocx = *minx- (textwidth(50,&xmin_str[0]) / 2);
  ilocy = *miny+2*text_height+2*tic_offset+5;
  set_foreground_color(draw_device_context,foreground_color);
  TextOut(draw_device_context,ilocx,ilocy,&xmin_str[0],
    strlen(&xmin_str[0]));

  ilocx = *maxx- (textwidth(50,&xmax_str[0]) / 2);
  ilocy = *miny+2*text_height+2*tic_offset+5;
  set_foreground_color(draw_device_context,foreground_color);
  TextOut(draw_device_context,ilocx,ilocy,&xmax_str[0],
    strlen(&xmax_str[0]));

/* next label horizontal axis division increment: */

  horiz1_str[0] = 'H';
  horiz1_str[1] = ':';
  horiz1_str[2] = ' ';
  horiz1_str[3] = '\0';
  sprintf(&horiz2_str[0],"%5.3e",*deltah_n); /* convert deltah_n to a string */
  strcat(horiz1_str,horiz2_str);
  horiz2_str[0] = ' ';
  horiz2_str[1] = 'x';
  horiz2_str[2] = ' ';
  horiz2_str[3] = '1';
  horiz2_str[4] = '0';
  horiz2_str[5] = '^';
  horiz2_str[6] = '\0';
  strcat(horiz1_str,horiz2_str);
  sprintf(&horiz2_str[0],"%d",*n_h); /* convert n_h to a string */
  strcat(horiz1_str,horiz2_str);

  if(*plot_mode==1)
  {
    horiz2_str[0] = ' ';
    horiz2_str[1] = 's';
    horiz2_str[2] = 'e';
    horiz2_str[3] = 'c';
    horiz2_str[4] = '\0';
  }
  else
  {
    horiz2_str[0] = ' ';
    horiz2_str[1] = 'H';
    horiz2_str[2] = 'z';
    horiz2_str[3] = '\0';
  };
  strcat(horiz1_str,horiz2_str);

  ilocx = *minx+(*maxx-*minx) / 2 - textwidth(100,&horiz1_str[0]) / 2;
  ilocy = *miny+2*text_height+2*tic_offset+5;
  set_foreground_color(draw_device_context,foreground_color);
  TextOut(draw_device_context,ilocx,ilocy,&horiz1_str[0],
    strlen(&horiz1_str[0]));

}; /* end procedure draw_horiz_axis */
/* ------------------------------------------------------------------ */




/* ---------------------------------------------------------------------- */
void draw_vert_axis(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,long int *i_truncate,
int *interpolate,int *int_div,int *plot_mode,int *THD,long int *npts,
float *deltah,float *deltav,float *deltah_n,float *deltav_n,float *xmin,
float *xmax,float *ymin,float *ymax,float *xmin_axis,float *xmax_axis,
float *ymin_axis,float *ymax_axis,float *delta,float *strt_val,
long double plot_array[],HDC draw_device_context)
{


int i_v,vloc_pix;
float rminy,rmaxy,rloc,rdely;
long int v_long;
char ymin_str[50],ymax_str[50],vert1_str[50],vert2_str[50];
int ilocx,ilocy;



  rminy = *miny;
  rmaxy = *maxy;
  rdely = (rminy-rmaxy)/ *ndivv;

  if( *extend_tics == 0 )
  {  /* only draw short tic marks on axes */

  for(i_v=2; i_v <= *ndivv; i_v++)
  {
    rloc = rmaxy + (i_v-1) * rdely;
    v_long = Round(rloc); /* Round returns longint value */
    vloc_pix = v_long; /* convert to integer for Line procedure */
    /* draw tic mark: */
    set_foreground_color(draw_device_context,foreground_color);
    MoveToEx(draw_device_context,*minx-tic_offset,vloc_pix,NULL);
    LineTo(draw_device_context,*minx+tic_offset,vloc_pix);
  };
  }
  else /* draw interior dotted lines */
  {

  for(i_v=1; i_v < *ndivv; i_v++)
  {
    rloc = rmaxy + i_v * rdely;
    v_long = Round(rloc); /* Round returns longint value */
    vloc_pix = v_long; /* convert to integer for Line procedure */
    dotted_line(*minx,vloc_pix,*maxx,vloc_pix,draw_device_context,
    foreground_color,background_color);
  };

  };

/* convert axis endpoint values to strings for labelling: */
  sprintf(&ymin_str[0],"%6.4f",*ymin_axis); /* convert ymin_axis to a string */
  sprintf(&ymax_str[0],"%6.4f",*ymax_axis); /* convert ymax_axis to a string */

  ilocx = *minx-textwidth(50,&ymin_str[0])-2* tic_offset-1;
  ilocy = *miny+(text_height / 2);
  set_foreground_color(draw_device_context,foreground_color);
  TextOut(draw_device_context,ilocx,ilocy,&ymin_str[0],
    strlen(&ymin_str[0]));

  ilocx = *minx-textwidth(50,&ymax_str[0])-2* tic_offset-1;
  ilocy = *maxy+(text_height / 2);
  set_foreground_color(draw_device_context,foreground_color);
  TextOut(draw_device_context,ilocx,ilocy,&ymax_str[0],
    strlen(&ymax_str[0]));

/* next label vertical axis division increment: */

  vert1_str[0] = 'V';
  vert1_str[1] = ':';
  vert1_str[2] = ' ';
  vert1_str[3] = '\0';
  sprintf(&vert2_str[0],"%5.3e",*deltav_n); /* convert deltav_n to a string */
  strcat(vert1_str,vert2_str);
  vert2_str[0] = ' ';
  vert2_str[1] = 'x';
  vert2_str[2] = ' ';
  vert2_str[3] = '1';
  vert2_str[4] = '0';
  vert2_str[5] = '^';
  vert2_str[6] = '\0';
  strcat(vert1_str,vert2_str);
  sprintf(&vert2_str[0],"%d",*n_v); /* convert normalization exponent to a string */
  strcat(vert1_str,vert2_str);

  if(*plot_mode==2)
  {
    if(impedance_mode==0)
    {
      vert2_str[0] = ' ';
      vert2_str[1] = 'd';
      vert2_str[2] = 'B';
      vert2_str[3] = '\0';
    }
    else
    {
      vert2_str[0] = ' ';
      vert2_str[1] = 'O';
      vert2_str[2] = 'h';
      vert2_str[3] = 'm';
      vert2_str[4] = 's';
      vert2_str[5] = '\0';
    };
    strcat(vert1_str,vert2_str);
  }
  else if(*plot_mode==3)
  {
    vert2_str[0] = ' ';
    vert2_str[1] = 'd';
    vert2_str[2] = 'e';
    vert2_str[3] = 'g';
    vert2_str[4] = '\0';
    strcat(vert1_str,vert2_str);
  };

  ilocx = *minx+(*maxx-*minx) / 2 - textwidth(50,&vert1_str[0]) / 2;
  ilocy = *maxy-text_height - 2* tic_offset-1;
  set_foreground_color(draw_device_context,foreground_color);
  TextOut(draw_device_context,ilocx,ilocy,&vert1_str[0],
    strlen(&vert1_str[0]));

}; /* end procedure draw_vert_axis */
/* ------------------------------------------------------------------ */



/* ------------------------------------------------------------------ */
/*
 find_pixel returns the horizontal pixel value in i_pix closest to
 the function index specified in i_func. It is assumed that i_func=0
 corresponds to t=0, and each increment of i_func increases the
 time according to delt.
*/
void find_pixel(long int i_func,int *i_pix,int *minx,int *maxx,float *delta,
float *strt_val,float *xmin_axis,float *xmax_axis)
{


long int i_longint;
float x_pix;
float rminx,rmaxx,r_ix;



  rminx = *minx; /* pixel value at axis lhs */
  rmaxx = *maxx; /* pixel value at axis rhs */
  r_ix = i_func;
/* xmin_axis,xmax_axis specify time values at ends of current horizontal axis */
  x_pix = rminx + ((r_ix-1.0)* *delta+ *strt_val- *xmin_axis)/
    (*xmax_axis - *xmin_axis)*(rmaxx-rminx);
  *i_pix = Round(x_pix); /* find pixel location closest to function value */


}; /* end find_pixel */
/* ---------------------------------------------------------------------- */



/* ------------------------------------------------------------------- */
/*
 The following procedure draws a vertical cursor at function value ix.
 If dotted=0 it draws a solid cursor, dotted=1 draws a dotted
 cursor. id identifies the cursor (1 or 2).
*/

void draw_cursor_vert(long int ix,int dotted,int id,int *minx,int *miny,
int *maxx,int *maxy,float *delta,float *strt_val,float *xmin_axis,
float *xmax_axis,HDC draw_device_context,HDC save_device_context,
COLORREF foreground_color,COLORREF background_color)
{



int ix_pix;



  find_pixel(ix,&ix_pix,minx,maxx,delta,strt_val,xmin_axis,xmax_axis);

/* first save the image under the cursor */
  transfer_device_context(draw_device_context,
  save_device_context,ix_pix,*maxy,1,*miny-*maxy+1);

/* now draw the cursor */
  if(dotted==0)
  {
    set_foreground_color(draw_device_context,foreground_color);
    MoveToEx(draw_device_context,ix_pix,*maxy,NULL);
    LineTo(draw_device_context,ix_pix,*miny);
  }
  else
  {
    dotted_line(ix_pix,*maxy,ix_pix,*miny,draw_device_context,
    foreground_color,background_color);
  };

}; /* end procedure draw_cursor_vert */
/* -------------------------------------------------- */




/* ------------------------------------------------------------------- */
/* 
 The following procedure removes a vertical cursor at pixel location ix.
 A previous call to draw_cursor_vert with the same id must have been
 made, so that the image under the cursor has been saved in either
 p1^ (id=1) or p2^ (id=2).
*/
void erase_cursor_vert(long int ix,int id,int *minx,int *miny,int *maxx,
int *maxy,float *delta,float *strt_val,float *xmin_axis,float *xmax_axis,
HDC draw_device_context,HDC save_device_context)
{


int ix_pix;


  find_pixel(ix,&ix_pix,minx,maxx,delta,strt_val,xmin_axis,xmax_axis);

/* retrieve the image under the cursor */
  transfer_device_context(save_device_context,
  draw_device_context,ix_pix,*maxy,1,*miny-*maxy+1);

}; /* end procedure erase_cursor_vert */
/* -------------------------------------------------- */





/* ----------------------------------------------------------------------- */
/* 
 The following procedure generates a plot of the values in plot_array
 vs. time. init_graph tells whether the graphics mode for the plot has
 already been initialized. xmin,xmax gives the range of horizontal
 axis data, and ymin,ymax gives the vertical axis data range.
 i_min and i_max give the index range of values in plot_array to be plotted
 (starting at 1).

 The plot is first drawn in window_device_context, then window_device_context
 is copied to memory_device_context and memory_device_context_untouched.
*/
void plot(int *init_graph,int *ndivh,int *ndivv,int *n_h,
int *n_v,int *extend_tics,int *minx,int *miny,int *maxx,int *maxy,
long int *i_min,long int *i_max,long int *i_truncate,int *interpolate,int *int_div,
int *plot_mode,int *THD,long int *npts,float *deltah,float *deltav,
float *deltah_n,float *deltav_n,float *xmin,float *xmax,float *ymin,
float *ymax,float *xmin_axis,float *xmax_axis,float *ymin_axis,
float *ymax_axis,float *delta,float *strt_val,float *THD_v,
long double plot_array[])
{


char ascii_graph,c_in;
long int i_graph;
float x_conv,y_conv;
float x,y;
long int x_longint, y_longint;
int y_pixel,x_pixel;
int x_pixel_old,y_pixel_old;
float t,time,result,deltt;
int i_int;
float plot_value;
float pi;


  pi = 4.0 * atan(1.0);

  if(!graphics_window_created)
  { // !graphics_window_created

    graphics_window_init();

    if(window_device_context != NULL)
    {
      ReleaseDC(window_handle,window_device_context);
    }
    window_device_context=GetDC(window_handle);
    if(window_device_context==NULL)
    {
      printf("Error - could not set up window_device_context\n");
      printf("Program will be terminated\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
      terminate_program();
    }

    SelectObject(window_device_context,GetStockObject(DC_PEN));
    SetDCPenColor(window_device_context,foreground_color);
    SelectObject(window_device_context,GetStockObject(DC_BRUSH));
    SetDCBrushColor(window_device_context,foreground_color);

    SelectObject(window_device_context,GetStockObject(SYSTEM_FONT));
    SetTextColor(window_device_context,foreground_color);
    SetBkColor(window_device_context,background_color);
    SetTextAlign(window_device_context,TA_BASELINE);
    GetTextMetrics(window_device_context,&text_info);
    text_height = text_info.tmHeight;
    text_char_width = text_info.tmAveCharWidth;


    if(GetClientRect(window_handle,&Client_Rect) == 0)
    {
      printf("Error in GetClientRect\n");
      printf("Program will be terminated\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
      terminate_program();
    }

// re-define values to correspond to client area
    *minx = Client_Rect.left;
    *maxx = Client_Rect.right;
    *maxy = Client_Rect.top;
    *miny = Client_Rect.bottom;

// width_dc,height_dc define the area you can write on in the
// window device context (differs from original window size
// because of the window borders):
    width_dc = Client_Rect.right - Client_Rect.left;
    height_dc = Client_Rect.bottom - Client_Rect.top;

// create memory device contexts
    create_memory_device_context(window_device_context,
      &memory_device_context_untouched,&memory_bitmap_untouched,
      width_dc,height_dc);
    create_memory_device_context(window_device_context,
      &memory_device_context,&memory_bitmap,
      width_dc,height_dc);
    create_memory_device_context(window_device_context,
      &memory_device_context_blank,&memory_bitmap_blank,
      width_dc,height_dc);

    mouse_x = *minx + ((*maxx-*minx)/4);
    mouse_y = *maxy + ((*miny-*maxy)/4);
/* Place the mouse pointer at a known starting position: */
    pt.x = mouse_x;
    pt.y = mouse_y; // in client window coordinates
// Convert to screen coordinates:
    if(ClientToScreen(window_handle,&pt) == 0)
    {
      printf("Error in ClientToScreen\n");
      printf("Program will be terminated\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
      terminate_program();
    }
    SetCursorPos(pt.x,pt.y);
    old_mouse_x = mouse_x;
    old_mouse_y = mouse_y;

/* Set up clipping in window: */
    if(clip_rectangle != NULL) DeleteObject(clip_rectangle);
    clip_rectangle = CreateRectRgn(Client_Rect.left,Client_Rect.top,
      Client_Rect.right,Client_Rect.bottom);
    if(clip_rectangle==NULL)
    {
      printf("Error in CreateRectRgn\n");
      printf("Program will be terminated\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
      terminate_program();
    }
    SelectClipRgn(window_device_context,clip_rectangle);
    SelectClipRgn(memory_device_context,clip_rectangle);
    SelectClipRgn(memory_device_context_untouched,clip_rectangle);
    SelectClipRgn(memory_device_context_blank,clip_rectangle);

//    FillRect(window_device_context,&Client_Rect,
//      (HBRUSH)GetStockObject(BLACK_BRUSH));
//    FillRect(memory_device_context,&Client_Rect,
//      (HBRUSH)GetStockObject(BLACK_BRUSH));
//    FillRect(memory_device_context_blank,&Client_Rect,
//      (HBRUSH)GetStockObject(BLACK_BRUSH));
    FillRect(window_device_context,&Client_Rect,
      background_brush);
    FillRect(memory_device_context,&Client_Rect,
      background_brush);
    FillRect(memory_device_context_blank,&Client_Rect,
      background_brush);

// keeps the parent console from initially obscuring graphics window:
    SetForegroundWindow(window_handle);

    shrink_x = *maxx / 10;
    shrink_y = *miny / 10;
    view_xmin = Client_Rect.left + shrink_x;
    view_xmax = Client_Rect.right - shrink_x;
    view_ymax = Client_Rect.top + shrink_y;
    view_ymin = Client_Rect.bottom - shrink_y;

    vxmin = view_xmin;
    vxmax = view_xmax;
    vymin = view_ymin;
    vymax = view_ymax;

    dxmin = *xmin;
    dxmax = *xmax;
    dymin = *ymin;
    dymax = *ymax;


    *maxx = Client_Rect.left + ( width_dc / maxx_div) * maxx_mult;
/* note: miny is at bottom of screen, it is actually larger than maxy: */
    *miny = Client_Rect.top + ( height_dc / miny_div) * miny_mult;
    *minx = Client_Rect.left + (width_dc / minx_div) * minx_mult;
    *maxy = Client_Rect.top + (height_dc / maxy_div) * maxy_mult;
  } // !graphics_window_created

  if(*init_graph==0)
  { /* *init_graph==0 */
    *init_graph = 1;

    setup_horiz_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);

    setup_vert_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0]);
  }; /* *init_graph==0 */


//    FillRect(window_device_context,&Client_Rect,
//      (HBRUSH)GetStockObject(BLACK_BRUSH));

    FillRect(window_device_context,&Client_Rect,
      background_brush);

    draw_horiz_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0],
    window_device_context);

    draw_vert_axis(ndivh,ndivv,n_h,n_v,extend_tics,minx,miny,maxx,
    maxy,i_min,i_max,i_truncate,interpolate,int_div,plot_mode,THD,npts,
    deltah,deltav,deltah_n,deltav_n,xmin,xmax,ymin,ymax,xmin_axis,
    xmax_axis,ymin_axis,ymax_axis,delta,strt_val,&plot_array[0],
    window_device_context);

/* Set up clipping in window: */
    if(clip_rectangle != NULL) DeleteObject(clip_rectangle);
    clip_rectangle = CreateRectRgn(*minx,*maxy,*maxx,*miny);
    if(clip_rectangle==NULL)
    {
      printf("Error in CreateRectRgn in plot()\n");
      printf("Program will be terminated\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
      terminate_program();
    }
    SelectClipRgn(window_device_context,clip_rectangle);

    x_conv = *maxx - *minx;
    x_conv = x_conv / (*xmax_axis- *xmin_axis); /* converts real number to pixels */
    y_conv = *miny - *maxy;
    y_conv = y_conv / (*ymax_axis- *ymin_axis);

/* location of first point in pixels: */
    x = ((*i_min-1)* *delta + *strt_val - *xmin_axis) * x_conv;
    x = x + *minx;
    x_longint = Round(x); /* to nearest pixel */
    x_pixel_old = x_longint;
    tg_adjust(*plot_mode,*i_min-1,plot_array[*i_min-1],&plot_value);
    y = (*ymax_axis - plot_value) * y_conv;
    y = y + *maxy;
    y_longint = Round(y); /* to nearest pixel */
    y_pixel_old = y_longint;
/* draw in first vertical line if it is a frequency plot: */
    if(*plot_mode>1)
    { 
      set_foreground_color(window_device_context,foreground_color);
      MoveToEx(window_device_context,x_pixel_old,*miny,NULL);
      LineTo(window_device_context,x_pixel_old,y_pixel_old);
    };

    if((*interpolate==0) || (*int_div==1))
    {  /* plot with no interpolation */
    for(i_graph=*i_min+1; i_graph <= *i_max; i_graph++)
    {  /* begin plot */

      x = ((i_graph-1)* *delta + *strt_val - *xmin_axis) * x_conv;
      x = x + *minx;
      x_longint = Round(x);
      x_pixel = x_longint;

      tg_adjust(*plot_mode,i_graph-1,plot_array[i_graph-1],&plot_value);
      if(i_graph <= *i_truncate)
      {
        y = (*ymax_axis-plot_value) * y_conv;
      }
      else if(*plot_mode==1)
      {
        y = *ymax_axis * y_conv;
      }
      else
      {
        y = (*ymax_axis-*ymin_axis) * y_conv;
      };

      y = y + *maxy;

      y_longint = Round(y); /* to nearest pixel */
      y_pixel = y_longint;
/*
 Connect points with line segments if vs. time, otherwise plot vertical
 line segments if vs. frequency:
*/
      if(*plot_mode==1)
      {
        set_foreground_color(window_device_context,foreground_color); 
        MoveToEx(window_device_context,x_pixel_old,y_pixel_old,NULL);
        LineTo(window_device_context,x_pixel,y_pixel);
      }
      else
      {
        set_foreground_color(window_device_context,foreground_color); 
        MoveToEx(window_device_context,x_pixel,*miny,NULL);
        LineTo(window_device_context,x_pixel,y_pixel);
      };

      x_pixel_old = x_pixel;
      y_pixel_old = y_pixel;

    };  /* end plot */
    }  /* end plot with no interpolation */
    else
    {  /* plot with interpolation (resampling) */
    for(i_graph=*i_min+1;i_graph <= *i_max;i_graph++)
    {  /* begin plot */

      time = (i_graph-2) * *delta + *strt_val; /* time at start of interval */
      deltt = *delta / *int_div;
      for(i_int=1;i_int <= *int_div; i_int++)
      {  /* begin interpolation */
        t = time + i_int * deltt;
        x = ((i_graph-2)* *delta+ *strt_val+i_int*deltt- *xmin_axis) * x_conv;
        x = x + *minx;
        x_longint = Round(x);
        x_pixel = x_longint;

        if(i_graph <= *i_truncate)
        {
/* Find value at t from sin(x)/x interpolation: */
          resample(&t,npts,delta,&plot_array[0],&result,pi);
          y = ( *ymax_axis-result ) * y_conv;
        }
        else if( *plot_mode==1)
        {
          y = *ymax_axis * y_conv;
        }
        else
        {
          y = (*ymax_axis-*ymin_axis) * y_conv;
        };

        y = y + *maxy;

        y_longint = Round(y); /* to nearest pixel */
        y_pixel = y_longint;

        if(*plot_mode==1)
        {
          set_foreground_color(window_device_context,foreground_color); 
          MoveToEx(window_device_context,x_pixel_old,y_pixel_old,NULL);
          LineTo(window_device_context,x_pixel,y_pixel);
        }
        else
        {
          set_foreground_color(window_device_context,foreground_color); 
          MoveToEx(window_device_context,x_pixel_old,*miny,NULL);
          LineTo(window_device_context,x_pixel,y_pixel);
        };

        x_pixel_old = x_pixel;
        y_pixel_old = y_pixel;

      }; /* end interpolation */

    };  /* end plot */

    };  /* end plot with interpolation (resampling) */


/* Set up clipping in window: */
    if(clip_rectangle != NULL) DeleteObject(clip_rectangle);
    clip_rectangle = CreateRectRgn(Client_Rect.left,Client_Rect.top,
      Client_Rect.right,Client_Rect.bottom);
    if(clip_rectangle==NULL)
    {
      printf("Error in CreateRectRgn in plot()\n");
      printf("Program will be terminated\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
      terminate_program();
    }
    SelectClipRgn(window_device_context,clip_rectangle);

  if(*THD>0)
  {
    display_THD(minx,maxx,maxy,THD_v,window_device_context);
  };

  transfer_device_context(window_device_context,
  memory_device_context,Client_Rect.left,Client_Rect.top,
  width_dc,height_dc);

  transfer_device_context(window_device_context,
  memory_device_context_untouched,Client_Rect.left,Client_Rect.top,
  width_dc,height_dc);

// to generate a WM_PAINT interrupt:
  InvalidateRgn(window_handle,NULL,TRUE);

};  /* end procedure plot */
/* ------------------------------------------------------------------------- */



/* ------------------------------------------------------------------------- */
void setup_plot(int *ndivh,int *ndivv,int *n_h,int *n_v,int *extend_tics,
int *minx,int *miny,int *maxx,int *maxy,long int *i_min,long int *i_max,
long int *i_truncate,int *interpolate,int *int_div,int *plot_mode,int *THD,
long int *npts,float *deltah,float *deltav,float *deltah_n,float *deltav_n,
float *xmin,float *xmax,float *ymin,float *ymax,float *xmin_axis,
float *xmax_axis,float *ymin_axis,float *ymax_axis,float *delta,float *strt_val)
{


int quit_sp;
char sp_ascii;


  quit_sp = 0;

do
{
  system("cls"); // clear the console screen

  printf("T to toggle tic mark options ");
  if( *extend_tics>0)
  {
    printf("(extended dotted lines)\n");
  }
  else
  {
    printf("(axis tic marks only)\n");
  };

  printf("R to toggle interpolation option");
  if( *interpolate>0)
  {
    printf("%s%d%s"," (enabled, division of ",*int_div,")\n");
  }
  else
  {
    printf(" (disabled)\n");
  };

  printf("V to select vertical axis settings for time plot\n");
  printf("Q to return from menu\n");

  printf("Enter Command :\n");

  sp_ascii = getch();

  if(my_toupper(sp_ascii) == 'Q')
  {
    quit_sp = 1;
  };

  if(my_toupper(sp_ascii) != 'Q')
  {

    if( my_toupper(sp_ascii) == 'T')
    {
      if( *extend_tics>0)
      {
        *extend_tics = 0;
      }
      else
      {
        *extend_tics = 1;
      };
    };

    if(my_toupper(sp_ascii) == 'R')
    {  /* setup interpolation */
      if( *interpolate==1)
      {
        *interpolate = 0;
      }
      else
      {
        *interpolate = 1;
        printf("Enter time step division (integer):\n");

        scanf("%d",int_div);  /* note: int_div is a pointer */

        if( *int_div<1)
        {
          *int_div = 1;
        };
      };
    };  /* end setup interpolation */

    if(my_toupper(sp_ascii) == 'V')
    {
      printf("Enter minimum vertical axis value:\n");

      scanf("%e",ymin);  /* note: ymin is a pointer */
      printf("Enter maximum vertical axis value:\n");
      scanf("%e",ymax);  /* note: ymax is a pointer */
// I think this is an error:
//      *strt_val = *ymin;
    };

  };  /* end of ascii_code <> 'Q' */
}
while(!quit_sp);

};  /* end of procedure setup_plot */
/* ---------------------------------------------------------------------- */



/* ---------------------------------------------------------------------- */
void display_iavg(int iavg_cnt,int minx,int maxx,int maxy,
  HDC display_device_context,COLORREF foreground_color,
  COLORREF background_color)
{


char disp1_str[50];
int ilocx,ilocy;
RECT display_iavg_rect;


  set_foreground_color(display_device_context,foreground_color);

  SelectObject(display_device_context,GetStockObject(DC_PEN));
  SetDCPenColor(display_device_context,foreground_color);
  SelectObject(display_device_context,GetStockObject(DC_BRUSH));
  SetDCBrushColor(display_device_context,foreground_color);

  SelectObject(display_device_context,GetStockObject(SYSTEM_FONT));
  SetTextColor(display_device_context,foreground_color);
  SetBkColor(display_device_context,background_color);

  sprintf(&disp1_str[0],"%3d",iavg_cnt); /* convert int iavg_cnt to a string */

  ilocx = minx / 2;
  ilocy = maxy-3*text_height-2*tic_offset-1;
  display_iavg_rect.left = ilocx-textwidth(100,disp1_str)*text_char_width/2;
  display_iavg_rect.right = ilocx+textwidth(100,disp1_str)*text_char_width/2;
  display_iavg_rect.top = ilocy-text_height-1;
  display_iavg_rect.bottom = ilocy+text_height+1;
/* erase the area where the string will be placed: */
//  FillRect(display_device_context,&display_iavg_rect,
//    (HBRUSH)GetStockObject(BLACK_BRUSH));
  FillRect(display_device_context,&display_iavg_rect,
    background_brush);

/* put disp1_str on the screen */
  TextOut(display_device_context,ilocx,ilocy,&disp1_str[0],
    strlen(&disp1_str[0]));

  InvalidateRgn(window_handle,NULL,TRUE);

};
/* ------------------------------------------------------------------------ */





/* ------------------------------------------------------------------------ */
void tg_adjust(int plot_mode,long int i,float plot_in,float *plot_value)
{


long int n_two_pi;



  *plot_value = plot_in;
  if(plot_mode==3)
  {
    *plot_value = *plot_value + 360.0*i*deltaf*Tg;
    n_two_pi = Round(*plot_value / 360.0 );
    *plot_value = *plot_value - n_two_pi * 360.0;
    do
    {
      if(*plot_value<-180.0)
      {
        *plot_value=*plot_value + 360.0;
      };
    }
    while(*plot_value<-180.0);
    do
    {
      if(*plot_value>180.0)
      {
        *plot_value=*plot_value - 360.0;
      };
    }
    while(*plot_value>180.0);
  };

};
/* -------------------------------------------------------------------- */




/* ------------------------------------------------------------------------ */
/*
 The following procedure resamples the discrete waveform in h[ix], with
 discretization delt, at arbitrary time t. Sin(x)/x reconstruction is
 used.
*/
void resample(float *t,long int *npts,float *delt,
long double h[],float *result,double pi)
{


int ix;
float arg,time;



  *result = 0.0; /* initialize sum */

  if( (*t>=0.0) && (*t<=(*npts-1)* *delt) )
  {  /* time within range of waveform */

  for(ix=0;ix < *npts; ix++)
  { /* sum over discrete time values */

      time = ix * *delt; /* time associated with discrete point */
      arg = pi*( *t-time)/ *delt;
      if(fabs(arg)<small_number)
      {
        *result = *result + h[ix];
      }
      else
      {
        *result = *result + h[ix]*sin(arg)/arg;
      };

  }; /* sum over discrete time values */

  }; /* time within range of waveform */

};
/* ---------------------------------------------------------------------- */
