/*
 *
 *
 * tf_win program for Windows
 *
 * The file tf_win.in must reside in the same directory where
 * tf_win is run. 
 *
 */



#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>  /* File control definitions */
#include <errno.h>  /* Error number definitions */
#include <time.h>
#include <math.h>

#include <windows.h>
#include <setupapi.h>
#include <tchar.h>

#include <winbase.h>
#include <winuser.h>

#include <conio.h> // for kbhit()

#include <wingdi.h>
#include <dos.h> // for gettime

#define MAX_DIM 75000

#define LARGEST_FP 0.999969482421875
int overflow_flag;

int i_rw_bin_ascii=2; // default to ascii rw mode

typedef struct {
 long double re;
 long double im;
} cmplx;

char window_keycode;
int keypressed;

#define BUTTON1 1
#define BUTTON3 3
int button = 0;

long double max_fft_mag;
char ascii_code_continue;
long int n_1_rr=0;
long int n_2_rr=0;
long int n_shift_rr=0;
int rr_wfm=0;
int rr_wfm_dest=0;
long double rr_threshold;

long int i_shift_wf1=0;
long int i_shift_wf2=0;

#define MAX_WINDOW_SIZE 10000
int window_type=0;
long int i_window_1=0;
long int i_window_2=0;
long double window_func[MAX_WINDOW_SIZE];

#define FILENAME_DIM 256
#define MAX_LINE_LENGTH 500

#define small_number_freq 0.01
#define small_number_delt 1e-7
#define small_number_imag 1e-5

FILE *file_pointer;

char file_name[FILENAME_DIM];

int i_read;
long double y1_val,y2_val;
char value_input_str[200];
int num_read;
int i;
char ascii_char,ascii_main_menu;
char ascii_keyboard_main;
FILE *input_file;
char filename[FILENAME_DIM];
char Quit_str[2];
char quit_str[2];
char input_line[MAX_LINE_LENGTH];

#define INBUF_DIM 256

int i_error;

char ascii_code;
FILE *input_file,*output_file;
char inbuf[INBUF_DIM];
char *string_pointer,*srch_str_ptr;
long int fft_size,fft_size_test;
long int num_meas_points,num_meas_points_new,nstage,i_init;
float deltat_float,deltaf_float;
char char_str[256];
long double sin_array[MAX_DIM],cos_array[MAX_DIM];
long double pi,rn2;
long double xinr[MAX_DIM],xini[MAX_DIM];
long double fftr[MAX_DIM],ffti[MAX_DIM];

long double fft_mag_avg[MAX_DIM];
// 0=no averaging,1=fixed number of points,
// 2=fraction of octave averaging:
int fft_mag_avg_mode = 0;
long int fft_mag_avg_npts,npts_cutoff_avg;
long double fft_mag_avg_frac,fft_mag_avg_center_freq,freq_cutoff_avg;
long double fft_mag_avg_max_freq,fft_mag_avg_min_freq;
long double fft_avg_val,fft_mag_avg_mult,ln_2,fft_mag_avg_delta;

long double delt,sampling_freq;

long double sampling_rate;

#define MAX_NPTS_DIM MAX_DIM
long double y1a[MAX_NPTS_DIM],y2a[MAX_NPTS_DIM];
long double y1a_buf[MAX_NPTS_DIM],y2a_buf[MAX_NPTS_DIM];
long double fftr1[MAX_NPTS_DIM],ffti1[MAX_NPTS_DIM];
long double fftr2[MAX_NPTS_DIM],ffti2[MAX_NPTS_DIM];

long double fft1mag[MAX_NPTS_DIM],fft1ph[MAX_NPTS_DIM];
long double fft2mag[MAX_NPTS_DIM],fft2ph[MAX_NPTS_DIM];

long int num_ptst1,num_ptst2;
long int num_ptsa1,num_ptsa2;
long int n;


#define MAX_BUTTERWORTH_ORDER 10
int max_butterworth_order_print;
long double Re_rrc_filt[MAX_NPTS_DIM],Im_rrc_filt[MAX_NPTS_DIM];
char rrc_filt_filename[FILENAME_DIM],rrc_filt_save_filename[FILENAME_DIM];
int rrc_filt=0;
int rrc_error=0;
int rrc_int_type=0;
int rrc_src,rrc_dest;
int rrc_cmp_src_wfm,rrc_cmp_dst_wfm;
long int n1_rrc=0;
long int n2_rrc=0;
int use_lpf_rrc=0;
long int n_lpf=0;
long double f0_lpf=0.0,fmax_rrc_decompress,fmax_rrc_compress,save_mag_fmax_compress;
long double mag_fmax_compress;
int enable_fmax_rrc_decompress=0;
int enable_fmax_rrc_compress=0;

long double del_om_fmax_compress;
long double om_tot_fmax_rrc_compress,rn_tot_fmax_rrc_compress;
long int n_tot_fmax_rrc_compress;
int sign_om_tot_fmax_rrc_compress;
long int n_del_om_fmax_compress=100;
long double phase_comp_fmax_compress=1.0;
long double r1_fc,r2_fc,i1_fc,i2_fc,om_save_fmax_rrc_compress;
long double arg_fmax_rrc_compress;
long int i_save_fmax_rrc_compress;
long double om1_fmax_compress,om2_fmax_compress,om21_fmax_compress;;
long double check_n_del_om;
int i_trans_fmax_compress;
int i_constant_phase_slope=1;
int rrc_lpf_type=2;
int rrc_epzc_enable=1;
long double rrc_epzc_value;
int rrc_lim_lpf_inv=0;
long double fmax_rrc_lim_lpf_inv=0.0;
long double save_mag_rrc_lim_lpf_inv,mag_rrc_lim_lpf_inv;
long double scale_wf1,scale_wf2,scale_wf1_old,scale_wf2_old;
int i_wfm_scale;

int minp_option=0;
long double lpfr[MAX_NPTS_DIM],lpfi[MAX_NPTS_DIM];
long double delf_minp;

long double deltat1,deltat2;

long int num_ptst1,num_ptst2;

#define CCIF_IM_SETUP_ID 4
#define SMPTE_IM_SETUP_ID 5

float CCIF_v1,CCIF_v2,SMPTE_v1,SMPTE_v2;
long int num_ccif_pts,num_ccif_19khz_cycles,num_ccif_20khz_cycles,i_ccif;
long double rnum_ccif_cycles,rccif,ccif_19khz,ccif_20khz;
long int ccif_longint,num_smpte_pts,num_smpte_60hz_cycles,num_smpte_7khz_cycles,i_smpte;
long double rnum_smpte_cycles,rsmpte,smpte_60hz,smpte_7khz;
long int smpte_longint;

long double long_double_value;
int init_plot,THD_plot,key_pressed_in_window;
int key_pressed_in_window_empty;
long int iavg_cnt,i_p;
char ascii_plot_main;
long int j;

int is_whitespace(char *test_char);

void report_file_format_error(void);

void terminate_program(void);

void read_long_int(FILE *input_file,long int *longint_number);

void read_int(FILE *input_file,int *int_number);

void read_string(FILE *input_file,char *char_str);

void read_float(FILE *input_file,float *float_number);

void read_long_double(FILE *input_file,long double *long_double_number);

void fft(int for_inv,long int *n,long int *nstage,long double xinr[],
long double xini[],long double fftr[],long double ffti[],
long double cos_array[],long double sin_array[],long double *max_mag);

void calc_minp(long double xinr_minp[],long double xini_minp[],
long double xoutr_minp[],long double xouti_minp[]);

void transform_phase(long double *phase);

void time_waveforms_menu(void);

void window_menu(void);

void get_long_double(long double *long_double_value);

void rrc_menu(void);

void read_time_waveform(int iwf,long int max_num_pts,long double y[],
long double *delt,long int *num,char *filename);

void readt_from_disk(void);

void savet_to_disk(void);

void save_time_waveform(int iwf,int save_truncated,int itruncate,long double y[],
long double *delt,long int *num);

long int Round(double real_n); 
long int Round_long(long double real_n); 

void to_next_line(FILE *input_file);

void fft_menu(void);

void read_fft(int iwf,long double fftr[],long double ffti[],long double fftnmag[],long double fftnph[],
long double *delf,long int *num);

void read_rrc_filt(char rrc_filt_filename[],long double Re_rrc_filt[],long double Im_rrc_filt[],
long double *delf,long int *num);

void save_fft(int ifft,long double fftr[],long double ffti[],
long double fftnmag[],long double fftnph[],long double *delf,long int *num_pts);

void calc_fft_mag_ph(long int *npts,long double fftr[],long double ffti[],
long double fftnmag[],long double fftnph[]);
void calc_fft_mag_ph_no_avg(long int *npts,long double fftr[],long double ffti[],
long double fftnmag[],long double fftnph[]);

void get_integer(int *int_number);

void get_long_int(long int *int_number);

void get_real(float *real_number);
void read_real(int *int_pointer, char *inbuf, char *real_string);

int check_power_of_2(long int n_check);

char read_any_an_key(int *keypressed);
void skip_comments(FILE *input_file,int max_length,
  char *input_line);
void wait_for_key_pressed(void);
char wait_for_char_no_echo(void);
char my_toupper(char input_char);

void calculate_butterworth_lpf(long int blpf_order,long double blpf_f0,
long double blpf_out_re[],long double blpf_out_im[]);

cmplx cadd(cmplx cnum1,cmplx cnum2);

cmplx csub(cmplx cnum1,cmplx cnum2);

cmplx cmul(cmplx cnum1,cmplx cnum2);

cmplx cdiv(cmplx cnum1,cmplx cnum2);

void end_program(void);


long double deltaf;
#define ASCII_CONSOLE_UP_ARROW 72
#define ASCII_CONSOLE_DOWN_ARROW 80
#define ASCII_CONSOLE_LEFT_ARROW 75
#define ASCII_CONSOLE_RIGHT_ARROW 77
#define ASCII_WINDOW_UP_ARROW 38
#define ASCII_WINDOW_DOWN_ARROW 40
#define ASCII_WINDOW_LEFT_ARROW 37
#define ASCII_WINDOW_RIGHT_ARROW 39
#include "plot_win.c"



/* ------------------------------------------------ */
cmplx cadd(cmplx cnum1,cmplx cnum2)
{
 cmplx cres;

 cres.re = cnum1.re + cnum2.re;
 cres.im = cnum1.im + cnum2.im;

 return cres;
}
/* ----------------------------------------------- */


/* ------------------------------------------------ */
cmplx csub(cmplx cnum1,cmplx cnum2)
{
 cmplx cres;

 cres.re = cnum1.re - cnum2.re;
 cres.im = cnum1.im - cnum2.im;

 return cres;
}
/* ----------------------------------------------- */

/* ------------------------------------------------ */
cmplx cmul(cmplx cnum1,cmplx cnum2)
{
 cmplx cres;

 cres.re = (cnum1.re*cnum2.re) - (cnum1.im*cnum2.im);
 cres.im = (cnum1.re*cnum2.im) + (cnum1.im*cnum2.re);

 return cres;
}
/* ----------------------------------------------- */

/* ------------------------------------------------ */
cmplx cdiv(cmplx cnum,cmplx cdnom)
{
 cmplx cres;
 long double denom;

 denom = (cdnom.re*cdnom.re) + (cdnom.im*cdnom.im);
 cres.re = ((cnum.re*cdnom.re) + (cnum.im*cdnom.im))/denom;
 cres.im = ((cnum.im*cdnom.re) - (cnum.re*cdnom.im))/denom;

 return cres;
}
/* ----------------------------------------------- */




/* ------------------------------------------------------------ */
// This routine calculates the FFT of a Butterworth LPF starting
// from the time domain.
void calculate_butterworth_lpf(long int blpf_order,long double blpf_f0,
long double blpf_out_re[],long double blpf_out_im[])
{
long double omega0,real_num1,real_num2;
long int i,j,npts_blpf,nstage_blpf;
cmplx s,residue_calc,numr,dnom,prod,x;
cmplx exp_term,section_term;
long double exp_term_mag,time_ld,blpf_mag;
cmplx pole[MAX_BUTTERWORTH_ORDER],residue[MAX_BUTTERWORTH_ORDER];
cmplx num_coeff;
long int num_imag_err;
char cbf_ascii_wait;
long double delt_blpf;
#define SMALL_NUMBER_BLPF 1e-5

  omega0 = 2.0 * pi * blpf_f0;
  num_coeff.re = omega0;
  num_coeff.im = 0.0;
  real_num1 = blpf_order;
  npts_blpf = nptst;

// Calculate the poles:
  for(i=1;i<=blpf_order;i++)
  { // i-loop
      real_num2 = i;
      pole[i-1].re = -omega0*sinl( ((2.0*real_num2)-1.0)*pi/2.0/real_num1 );
      pole[i-1].im = omega0*cosl( ((2.0*real_num2)-1.0)*pi/2.0/real_num1 );
  } // i-loop

// Calculate the residues:
  for(i=0;i<blpf_order;i++)
  { // i-loop
    s = pole[i];
    residue_calc.re = 1.0; // initialize
    residue_calc.im = 0.0;
    for(j=0;j<blpf_order;j++)
    { // j-loop
      residue_calc = cmul(residue_calc,num_coeff);
      if(i != j)
      { // i != j
        dnom = csub(s,pole[j]);
        residue_calc = cdiv(residue_calc,dnom);
      } // i != j
    } // j-loop
    residue[i] = residue_calc;
  } // i-loop

  num_imag_err = 0;

// Calculate the response at nptst times:
  for(i=0;i<nptst;i++)
  { // i-loop over time
    x.re = 0.0; // initialize
    x.im = 0.0;
    time_ld = i*delt;
// Sum the contributions from the terms:
    for(j=0;j<blpf_order;j++)
    { // j-loop over terms
      exp_term_mag = expl(pole[j].re*time_ld);
      exp_term.re = exp_term_mag * cosl(pole[j].im*time_ld);
      exp_term.im = exp_term_mag * sinl(pole[j].im*time_ld);
      section_term = cmul(exp_term,residue[j]);
      x = cadd(x,section_term);
    } // j-loop over terms

    xinr[i] = x.re * delt;
    xini[i] = 0.0;
    x.im = x.im * delt;

// check for imaginary part:
    if(fabsl(xinr[i]) > SMALL_NUMBER_BLPF)
    {
      if(fabsl(x.im/xinr[i]) > SMALL_NUMBER_BLPF)
      {
        num_imag_err++;
      }
    }

  } // i-loop over time

  if(num_imag_err > 0)
  {
    printf("%s%ld%s","Warning - imaginary part of Butterworth LPF at ",num_imag_err,"different times\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
  }

// Take FFT:

  j=1;
  nstage_blpf=0;
  do
  {
    j = j*2;
    nstage_blpf++;
  }
  while(j < nptst);

// set up sin_array[],cos_array[] for FFT calculation:
  rn2 = nptst/2;
  for(i=0;i<= (nptst / 2) - 1;i++)
  { /* setup trig arrays for FFT */
    cos_array[i] = cosl(i * pi / rn2);
    sin_array[i] = -sinl(i * pi / rn2);
  }

  fft(2,&npts_blpf,&nstage_blpf,xinr,xini,blpf_out_re,
    blpf_out_im,cos_array,sin_array,&blpf_mag);

} // end calculate_butterworth_lpf
/* ------------------------------------------------------ */




//
// This routine transforms the frequency domain function given by xinr_minp[],xini_minp[]
// in RI format to its minimum-phase equivalent. The procedure is as follows.
// First, logl of the magnitude is put in xinr_minp[] and zero in xini_minp[]. Then
// the function is transformed to the time domain. The time-domain function
// is then transformed to a causal sequence. This causal sequence is next
// transformed to the frequency domain. After transformation, xoutr_minp[] contains
// the log magnitude of the minp frequency response, and xouti_minp[] contains the
// phase in radians of the frequency response. These values are finally converted
// to RI format.
//
void calc_minp(long double xinr_minp[],long double xini_minp[],
long double xoutr_minp[],long double xouti_minp[])
{
char minp_ascii_wait;
int minp_error=0;
long int minp_imag=0;
long double minp_mag,delf;
long int npts_minp,nstage_minp,i_folding_minp,i_lim_minp;
#define SMALL_MINP 1e-50
#define BIG_MINP 1e50
#define MINP_SMALL_IMAG 1e-5

      i_lim_minp = 0;
      rn2 = nptst / 2;
      npts_minp = nptst;
      delf = nptst;
      delf = 1.0 / ( delf * delt);
      i_folding_minp = nptst/2;

      j=1;
      nstage_minp=0;
      do
      {
        j = j*2;
        nstage_minp++;
      }
      while(j < nptst);

      if(j>nptst)
      {
        printf("Error - number of points in RI waveform is not a power of 2;\n");
        printf("Can't proceed with minp conversion\n");
        printf("Press any A/N key to continue:\n");
        wait_for_key_pressed();
        minp_error=1;
      }

      if(minp_error==0)
      { // minp_error==0

// set up sin_array[],cos_array[] for FFT calculation
        for(i=0;i<= (nptst / 2) - 1;i++)
        { /* setup trig arrays for FFT */
          cos_array[i] = cosl(i * pi / rn2);
          sin_array[i] = -sinl(i * pi / rn2);
        }; /* end setup trig arrays for FFT procedure */

// calculate log magnitude of frequency-domain function:
//        xinr[0] = 0.0;
//        xini[0] = 0.0;
        for(i=0;i<nptst;i++)
        {
          minp_mag = sqrtl( (xinr_minp[i]*xinr_minp[i]) +
                     (xini_minp[i]*xini_minp[i]) );
          xini_minp[i] = 0.0;
          if(fabsl(minp_mag) > SMALL_MINP)
          {
            xinr_minp[i] = logl(minp_mag);
          }
          else
          {
            xinr_minp[i] = logl(SMALL_MINP);
            i_lim_minp++;
          }
        }

        if(i_lim_minp > 0)
        {
          printf("%s%ld%s","Warning - log magnitude was limited ",i_lim_minp," times in calc_minp\n");
          printf("Press any A/N key to continue:\n");
          wait_for_key_pressed();
        }

// calculate inverse fft:

        fft(1,&npts_minp,&nstage_minp,xinr_minp,xini_minp,xoutr_minp,
           xouti_minp,cos_array,sin_array,&minp_mag);

        for(i=0;i<npts_minp;i++)
        { // i-loop
          if
          (  
//            (fabsl(xoutr_minp[i])>MINP_SMALL_IMAG)
//            &&
//            (fabsl(xouti_minp[i]/xoutr_minp[i])>MINP_SMALL_IMAG)
            fabsl(xouti_minp[i]) > MINP_SMALL_IMAG
          )
          {
            minp_imag++;
          }
        } // i-loop

        if(minp_imag>0)
        {
            printf("%s%ld%s","Warning - imaginary part in inverse log magnitude calculation ",minp_imag," times\n");
            printf("Press any A/N key to continue:\n");
            wait_for_key_pressed();
        }

// transform log(x[]) to a causal sequence:

        for(i=0;i<nptst;i++)
        {
          xini_minp[i] = 0.0;
          if((i==0) || (i==i_folding_minp))
          {
            xinr_minp[i]=xoutr_minp[i];
          }
          else if(i>i_folding_minp)
          {
            xinr_minp[i]=0.0;
          }
          else
          {
            xinr_minp[i]=2.0*xoutr_minp[i];
          }
        }
// Transform log(x[]) to the frequency domain

        fft(0,&npts_minp,&nstage_minp,xinr_minp,xini_minp,
          xoutr_minp,xouti_minp,cos_array,sin_array,&minp_mag);

// xoutr_minp[] contains log magnitude of frequency response
// xouti_minp[] contains phase (in radians) of frequency response
// convert back to RI format

        for(i=0;i<nptst;i++)
        {
          minp_mag = expl(xoutr_minp[i]);
          transform_phase(&xouti_minp[i]);
          xoutr_minp[i] = minp_mag * cosl(xouti_minp[i]);
          xouti_minp[i] = minp_mag * sinl(xouti_minp[i]);
        }  

      } // minp_error==0

} // end calc_minp





/* --------------------------------------------------- */
void transform_phase(long double *phase)
{

long int i_tf;

  while(*phase>pi)
  {
    *phase = *phase - 2.0*pi;
  }

  while(*phase<(-pi))
  {
    *phase = *phase + 2.0*pi;
  }
}
/* -------------------------------------------------- */








/* ---------------------------------------------------------------- */
void end_program(void)
{
    printf("Program will be terminated\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
}
/* --------------------------------------------------------------- */





// ----------------------------------------------------------------------------
char my_toupper(char input_char)
{
char return_char;

  return_char = input_char;
  if
  (
    (input_char >= 'a')
    &&
    (input_char <= 'z')
  )
  {
    return_char -= 32;
  }
return return_char;
}
// -----------------------------------------------------------------------------







// ------------------------------------------
void wait_for_key_pressed(void)
{
//  printf("Press any A/N key to continue\n");
  do
  {
    read_any_an_key(&keypressed);
    if(window_handle != NULL) check_window_message(window_handle);
  }
  while((keypressed==0) );

}
// --------------------------------------------







/* --------------------------------------------------------------- */
/*
  This procedure sets keypressed to 1 if any A/N key is pressed,
  otherwise it is set to 0. If a key was pressed it returns the
  value, else it returns -1.
*/
char read_any_an_key(int *keypressed)
{

  if
  (
    kbhit()!=0
  )
  {
    *keypressed=1;
    return getch();
  }
  else
  {
    *keypressed=0;
    return -1;
  }

} // end read_any_an_key
/* --------------------------------------------------------------- */





/* --------------------------------------------------------------- */
char wait_for_char_no_echo(void)
{

  do
  {
    if(window_handle != NULL) check_window_message(window_handle);
  }
  while(kbhit()==0);

  return getch();

} // end wait_for_char_no_echo
/* --------------------------------------------------------------- */








// ------------------------------------------------------------------------
int check_power_of_2(long int n_check)
{

long int n_mult;

  n_mult=1;
  do
  {
    n_mult *= 2;
  }
  while
  (n_mult < n_check);

  if(n_mult==n_check)
  {
    return 1;
  }
  else
  {
    return 0;
  }

} // end check_power_of_2
// --------------------------------------------------------------------------








/* ----------------------------------------------------------- */
void read_real(int *int_pointer, char *inbuf, char *real_string)
{
  int i, j;
  i = *int_pointer;
  j = 0;
  while( (inbuf[i] == ' ') || (inbuf[i] == '\t') )
  {
    i++;
  }
  while( (inbuf[i] != ' ') && (inbuf[i] != '\t') &&
    (inbuf[i] != '\n') )
  {
    real_string[j] = inbuf[i];
    i++;
    j++;
  }
  real_string[j] = '\0';
  *int_pointer = i;
}
/* ------------------------------------------------------------- */







/* ------------------------------------------------------------ */
long int power(int base, int n)
{

long int i,p;

p=1;
if(n>0)
{
  for(i=1;i<=n;i++)
  {
    p=p*base;
  }
}

return p;
} // end power
/* ----------------------------------------------------------- */





/* ---------------------------------------------------------- */
void get_real(float *real_number)
{

  scanf("%e",real_number);

};
/* --------------------------------------------------------- */







/* ---------------------------------------------------------- */
void get_long_double(long double *long_double_value)
{

  scanf("%Le",long_double_value);

};
/* --------------------------------------------------------- */









/* ---------------------------------------------------------- */
void get_integer(int *int_number)
{

  scanf("%d",int_number);

};
/* --------------------------------------------------------- */






/* ---------------------------------------------------------- */
void get_long_int(long int *int_number)
{

  scanf("%ld",int_number);

};
/* --------------------------------------------------------- */









/* ----------------------------------------------------------------------- */
/*
 Magnitude in dB is returned in fftnmag,phase in degrees in fftnph.
*/
void calc_fft_mag_ph(long int *npts,long double fftr[],long double ffti[],
long double fftnmag[],long double fftnph[])
{


int i;
long int j,jmin,jmax,jnum;
long int i_folding;
long double fftmag,fftph;
#define SMALL_NUMBER_CALC_MAG_PHASE 1e-50


  for(i=0;i<=*npts-1;i++)
  { /* calculate FFT magnitude and phase */

    fftmag = fftr[i]*fftr[i] + ffti[i]*ffti[i]; /* magnitude squared */
    fft_mag_avg[i] = fftmag;

    if(fftmag>0.0)
    {
      fftmag = 10.0 * logl(fftmag) / ln_10; /* convert magnitude squared to dB */
    }
    else
    {
      fftmag = -1.0e3;
    }

    if(fabsl(fftr[i])<SMALL_NUMBER_CALC_MAG_PHASE)
    { /* real part zero */
      if(ffti[i]>=0.0)
      {
        fftph=pi/2.0;
      }
      else
      {
        fftph=-pi/2.0;
      };
    }
    else
    {
      fftph = atanl(ffti[i]/fftr[i]);
      if(fftr[i]<0.0)
      {
        fftph = fftph + pi;
      };
      if(fftph>pi)
      {
        fftph = fftph - 2.0*pi;
      };
    };


    fftnmag[i] = fftmag;
    fftnph[i] = fftph * 180.0 / pi;

  }; /* calculate FFT magnitude and phase */

  if(fft_mag_avg_mode==1)
  { // fft_mag_avg_mode==1
    jmin=1; // don't include DC value in average
    do
    { // do-loop
      jmax = jmin + fft_mag_avg_npts - 1;
      if(jmax > (*npts-1))jmax = *npts - 1;
      jnum = jmax - jmin + 1;

      fft_avg_val=0.0;

      for(j=jmin;j<=jmax;j++)
      {
        fft_avg_val += fft_mag_avg[j];
      }

      fft_avg_val /= (long double) jnum;

        if(fft_avg_val>0.0)
        {
          fft_avg_val = 10.0 * logl(fft_avg_val) / ln_10; /* convert magnitude squared to dB */
        }
        else
        {
          fft_avg_val = -1.0e3;
        }

      for(j=jmin;j<=jmax;j++)
      {
        fftnmag[j] = fft_avg_val;
      }

      jmin = jmax + 1;

    } // do-loop
    while(jmax < npts_cutoff_avg - 1);

  } // fft_mag_avg_mode==1

  if(fft_mag_avg_mode==2)
  { // fft_mag_avg_mode==2
    jmin=1; // don't include DC value in average
    do
    { // do-loop

      fft_mag_avg_min_freq = deltaf * (long double) jmin;
      fft_mag_avg_max_freq = fft_mag_avg_min_freq * fft_mag_avg_mult;
      fft_mag_avg_delta = (fft_mag_avg_max_freq-fft_mag_avg_min_freq)/deltaf;

      jmax = jmin + (long int) fft_mag_avg_delta;
      if(jmax > (npts_cutoff_avg - 1))jmax = npts_cutoff_avg - 1;

      jnum = jmax - jmin + 1;

      fft_avg_val=0.0;

      for(j=jmin;j<=jmax;j++)
      {
        fft_avg_val += fft_mag_avg[j];
      }

      fft_avg_val /= (long double) jnum;

        if(fft_avg_val>0.0)
        {
          fft_avg_val = 10.0 * logl(fft_avg_val) / ln_10; /* convert magnitude squared to dB */
        }
        else
        {
          fft_avg_val = -1.0e3;
        }

      for(j=jmin;j<=jmax;j++)
      {
        fftnmag[j] = fft_avg_val;
      }

      jmin = jmax + 1;

    } // do-loop
    while(jmax < npts_cutoff_avg - 1);

  } // fft_mag_avg_mode==2

}; /* end procedure calc_fft_mag_ph */
/* -------------------------------------------------------------------- */






/* ----------------------------------------------------------------------- */
/*
 Magnitude in dB is returned in fftnmag,phase in degrees in fftnph.
*/
void calc_fft_mag_ph_no_avg(long int *npts,long double fftr[],long double ffti[],
long double fftnmag[],long double fftnph[])
{


int i;
long int i_folding;
long double fftmag,fftph;
#define SMALL_NUMBER_CALC_MAG_PHASE 1e-50

  for(i=0;i<=*npts-1;i++)
  { /* calculate FFT magnitude and phase */

    fftmag = fftr[i]*fftr[i] + ffti[i]*ffti[i]; /* magnitude squared */

    if(fftmag>0.0)
    {
      fftmag = 10.0 * logl(fftmag) / ln_10; /* convert magnitude squared to dB */
    }
    else
    {
      fftmag = -1.0e3;
    }

    if(fabs(fftr[i])<SMALL_NUMBER_CALC_MAG_PHASE)
    { /* real part zero */
      if(ffti[i]>=0.0)
      {
        fftph=pi/2.0;
      }
      else
      {
        fftph=-pi/2.0;
      };
    }
    else
    {
      fftph = atanl(ffti[i]/fftr[i]);
      if(fftr[i]<0.0)
      {
        fftph = fftph + pi;
      };
      if(fftph>pi)
      {
        fftph = fftph - 2.0*pi;
      };
    };


    fftnmag[i] = fftmag;
    fftnph[i] = fftph * 180.0 / pi;

  }; /* calculate FFT magnitude and phase */

}; /* end procedure calc_fft_mag_ph_no_avg */
/* -------------------------------------------------------------------- */









/* ---------------------------------------------------------------------- */
/*
 n is number of points, n=2^nstage, cos_array and sin_array each contain
 n/2 trig values, xinr contains n input values (starting at index 0),
 fftr and ffti each contain n fft result values. for_rev=0 for forward
 fft (time to frequency domain), for_rev=1 for inverse fft (frequency
 to time domain), for_rev=2 for forward fft but without final normalization.
*/
void fft(int for_rev,long int *n,long int *nstage,long double xinr[],
long double xini[],long double fftr[],long double ffti[],long double cos_array[],
long double sin_array[],long double *max_mag)
{


long double realn,wr,wi,mag;
long int nm1,j,n2j,nrm1,ni,i,in2j,ir;
long int isub,isub1,isub2,isub3,n2;


  realn = *n;
  nm1 = *n - 1;
  n2j = *n;
  ni = 1;
  n2 = *n / 2;
  for(j=1; j<=*nstage; j++)
  { /* j-loop */
    n2j = n2j / 2;
    nrm1 = n2j - 1;
    for(i=1;i<=ni;i++)
    { /* i-loop */
      in2j = (i-1) * n2j;
      wr = cos_array[in2j];

      if( (for_rev==0) || (for_rev==2) )
      {
        wi = sin_array[in2j];
      }
      else
      {
        wi=-sin_array[in2j];
      }

      for(ir=0;ir<=nrm1;ir++)
      { /* ir-loop */
        isub = ir + in2j;
        isub1 = ir + in2j * 2;
        isub2 = isub1 + n2j;
        isub3 = isub + n2;
        fftr[isub] = xinr[isub1] + wr * xinr[isub2] - wi * xini[isub2];
        ffti[isub] = xini[isub1] + wi * xinr[isub2] + wr * xini[isub2];
        fftr[isub3] = xinr[isub1] - wr * xinr[isub2] + wi * xini[isub2];
        ffti[isub3] = xini[isub1] -wi * xinr[isub2] - wr * xini[isub2];
      }; /* end ir-loop */

    }; /* end i-loop */

    *max_mag=0.0;

    for(ir=0;ir<=nm1;ir++)
    { /* ir-loop */
      xinr[ir] = fftr[ir];
      xini[ir] = ffti[ir];
      mag=sqrtl((xinr[ir]*xinr[ir])+(xini[ir]*xini[ir]));
      if(mag>*max_mag) *max_mag=mag;
    }; /* end ir-loop */

    ni = ni * 2;
  }; /* end j-loop */

  if(for_rev==0)
  { /* forward fft */
    for(ir=0;ir<=nm1;ir++)
    { /* ir-loop */
      fftr[ir] = xinr[ir] / realn;
      ffti[ir] = xini[ir] / realn;
    }; /* end ir-loop */
    *max_mag=*max_mag/realn;
  } /* forward fft */

}; /* end procedure fft */
/* ------------------------------------------------------------------ */







/* ---------------------------------------------------------------------- */
void save_fft(int ifft,long double fftr[],long double ffti[],long double fftnmag[],
long double fftnph[],long double *delf,long int *num_pts)
{

char filename[FILENAME_DIM];
long double freq_save_fft;
FILE *output_file;
long int i_wr;
char Quit_str[2];
char quit_str[2];


  Quit_str[0] = 'Q';
  Quit_str[1] = '\0';
  quit_str[0] = 'q';
  quit_str[1] = '\0';


  printf("%s%d%s","Enter file name for FFT ",ifft,":\n");

  scanf("%s",filename);


/* open file for write access */

    if(i_rw_bin_ascii==2)
    {
      while( (output_file=fopen(filename,"w")) == NULL)
      {
        printf("Error opening file, enter another name or Q to quit:\n");
        scanf("%s",filename);
        if( (strcmp(filename,Quit_str)==0) || (strcmp(filename,quit_str)==0) )
        {
          terminate_program();
        };
      };
    }
    else if(i_rw_bin_ascii==1)
    {
      while( (output_file=fopen(filename,"wb")) == NULL)
      {
        printf("Error opening file, enter another name or Q to quit:\n");
        scanf("%s",filename);
        if( (strcmp(filename,Quit_str)==0) || (strcmp(filename,quit_str)==0) )
        {
          terminate_program();
        };
      };
    }

  printf("Enter single line of comments:\n");
  scanf("%s",filename);
  if(i_rw_bin_ascii==2)
  {
    fprintf(output_file,"%s%s",filename,"\n");
    fprintf(output_file,"%s","x\n");
  }
  else if(i_rw_bin_ascii==1)
  {
    fwrite(filename,FILENAME_DIM,1,output_file);
  }


  for(i_wr=0;i_wr <= *num_pts-1; i_wr++)
  {
    if(i_rw_bin_ascii==1)
    {
      freq_save_fft = i_wr * (*delf);
      fwrite(&freq_save_fft,sizeof(long double),1,output_file);
      fwrite(&fftr[i_wr],sizeof(long double),1,output_file);
      fwrite(&ffti[i_wr],sizeof(long double),1,output_file);
    }
    else if(i_rw_bin_ascii==2)
    {
      fprintf(output_file,"%.10Le%s%.10Le%s%.10Le%s",i_wr * *delf," ",fftnmag[i_wr]," ",
        fftnph[i_wr],"\n");
    }
  };

  if(i_rw_bin_ascii==2)
  {
    fprintf(output_file,"%s","y\n");
  }

  fclose(output_file);

}; /* end procedure save_fft */
/* -------------------------------------------------------------------- */






/* ------------------------------------------------------------------------ */
void save_rrc_filter(char rrc_filt_save_filename[],long double Re_rrc_filt[],
long double Im_rrc_filt[],long double delf,long int nptst)
{

FILE *output_file;
long int i_wr;
char Quit_str[2];
char quit_str[2];
char line_input[FILENAME_DIM];
long double freq_save_rrc_filter;

  rrc_error = 0;
  Quit_str[0] = 'Q';
  Quit_str[1] = '\0';
  quit_str[0] = 'q';
  quit_str[1] = '\0';


  printf("Enter file name to save compression filter:\n");

  scanf("%s",rrc_filt_filename);


/* open file for write access */

      if(i_rw_bin_ascii==2)
      {
        while( (output_file=fopen(rrc_filt_filename,"w")) == NULL)
        {
          printf("Error opening file, enter another name or Q to quit:\n");
          scanf("%s",rrc_filt_filename);
          if( (strcmp(rrc_filt_filename,Quit_str)==0) || (strcmp(rrc_filt_filename,quit_str)==0) )
          {
            printf("File save aborted\n");
            rrc_error = 1;
          };
        };
      }
      else if(i_rw_bin_ascii==1)
      {
        while( (output_file=fopen(rrc_filt_filename,"wb")) == NULL)
        {
          printf("Error opening file, enter another name or Q to quit:\n");
          scanf("%s",rrc_filt_filename);
          if( (strcmp(rrc_filt_filename,Quit_str)==0) || (strcmp(rrc_filt_filename,quit_str)==0) )
          {
            printf("File save aborted\n");
            rrc_error = 1;
          };
        };
      }

  if(rrc_error==0)
  { // rrc_error==0

  printf("Enter single line of comments:\n");
//  getnstr(line_input,FILENAME_DIM-1);
  scanf("%s",line_input);
  if(i_rw_bin_ascii==2)
  {
    fprintf(output_file,"%s%s",line_input,"\n");
    fprintf(output_file,"%s","x\n");
  }
  else if(i_rw_bin_ascii==1)
  {
    fwrite(line_input,FILENAME_DIM,1,output_file);
  }


  for(i_wr=0;i_wr < nptst; i_wr++)
  {
    if(i_rw_bin_ascii==2)
    {
      fprintf(output_file,"%18.10Le%s%41.33Le%s%41.33Le%s",i_wr*delf," ",Re_rrc_filt[i_wr]," ",
        Im_rrc_filt[i_wr],"\n");
    }
    else if(i_rw_bin_ascii==1)
    {
      freq_save_rrc_filter = i_wr * delf;
      fwrite(&freq_save_rrc_filter,sizeof(long double),1,output_file);
      fwrite(&Re_rrc_filt[i_wr],sizeof(long double),1,output_file);
      fwrite(&Im_rrc_filt[i_wr],sizeof(long double),1,output_file);
    }

  };

  if(i_rw_bin_ascii==2)
  {
    fprintf(output_file,"%s","y\n");
  }

  fclose(output_file);

  } // rrc_error==0

}; /* end procedure save_rrc_filter */
/* -------------------------------------------------------------------- */








/* ----------------------------------------------------------------------- */
/*
 Reads FFT waveform iwf (1 or 2) from disk, puts values in arrays fftr,ffti
 (ri format) and in fftnmag,fftnph (magnitude and phase format).
 Delf is time step inferred from the first two data lines read. Num
 is the number of values read from waveform.
*/
void read_fft(int iwf,long double fftr[],long double ffti[],long double fftnmag[],
long double fftnph[],long double *delf,long int *num)
{

char filename[FILENAME_DIM];
FILE *input_file;
int io_error,quit_wf;
long int i_read;
long double freq_read;
long double freq[2];
char ascii_readt;
char quit_str[2];
char Quit_str[2];
int num_read;
long double fft_mag_read_fft;
int num_read_1,num_read_2,num_read_3;


  quit_wf = 0;
  Quit_str[0] = 'Q';
  Quit_str[1] = '\0';
  quit_str[0] = 'q';
  quit_str[1] = '\0';
  do
  {
      printf("%s%d%s","Enter file name for FFT ",iwf,", or Q to quit:\n");

      scanf("%s",filename);
      if( strcmp(filename,quit_str)==0 || strcmp(filename,Quit_str)==0) 
        quit_wf = 1;

      if(i_rw_bin_ascii==2)
      {
        if(! quit_wf)
        {
          if((input_file=fopen(filename,"r")) == NULL)
          {
            io_error = 1;
          }
          else
          {
            io_error = 0;
          };
          if(io_error) 
          {
            printf("%s%s%s","Error opening file ",filename,";\n");
          };
        };
      }
      else if(i_rw_bin_ascii==1)
      {
        if(! quit_wf)
        {
          if((input_file=fopen(filename,"rb")) == NULL)
          {
            io_error = 1;
          }
          else
          {
            io_error = 0;
          };
          if(io_error) 
          {
            printf("%s%s%s","Error opening file ",filename,";\n");
          };
        };
      }
  }
  while(!( (! io_error) || (quit_wf) ) );
  if(! quit_wf)
  {
    io_error = 0;
    if(i_rw_bin_ascii==2)
    {
      to_next_line(input_file); /* read labels */
      to_next_line(input_file); /* read line with x */
    }
    else if(i_rw_bin_ascii==1)
    {
      fread(filename,FILENAME_DIM,1,input_file);
    }
    i_read = -1;
    do
    {
      i_read = i_read + 1;
      if(i_rw_bin_ascii==1)
      {
        num_read_1 = fread(&freq_read,sizeof(long double),1,input_file);
        num_read_2 = fread(&fftr[i_read],sizeof(long double),1,input_file);
        num_read_3 = fread(&ffti[i_read],sizeof(long double),1,input_file);
        num_read = num_read_1 + num_read_2 + num_read_3;
      }
      else if(i_rw_bin_ascii==2)
      {
        num_read = fscanf(input_file,"%Le%Le%Le",&freq_read,&fftnmag[i_read],
          &fftnph[i_read]);
      }
      if(i_read==0) freq[0] = freq_read;
      if(i_read==1) freq[1] = freq_read;
      if(num_read != 3) io_error = 1;
    }
    while(!( (i_read==num_meas_points-1) || io_error ) );


    if(! io_error)
    {
      *num = i_read+1;
    }
    else
    {
      *num = i_read;
    };

    if(*num<1)
    {
      printf("Warning - no data was found\n");
    };

    *delf = freq[1] - freq[0];

    if(*num<num_meas_points)
    {
      printf("%s%d%s","Warning: number of points in wf ",iwf," less than num_meas_points;\n");
      if(i_rw_bin_ascii==2)
      {
        printf("Fill remaining values with small value? 1=Y, 0=N:\n");
      }
      else if(i_rw_bin_ascii==1)
      {
        printf("Fill remaining values with zero? 1=Y, 0=N:\n");
      }
      scanf("%d",&i_read);
      if(i_read==1)
      {
        for(i_read = *num; i_read <= num_meas_points-1; i_read++)
        {
          if(i_rw_bin_ascii==2)
          {
            fftr[i_read] = -1.0e3;
          }
          else if(i_rw_bin_ascii==1)
          {
            fftr[i_read] = 0.0;
          }
          ffti[i_read] = 0.0;
        };
      };
    };
    if(fabsl(*delf-deltaf)>small_number_freq)
    {
      printf("%s%d%s","Warning - delf in FFT ",iwf," file doesn't match program value;\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    };

  if(i_rw_bin_ascii==1)
  {
    calc_fft_mag_ph_no_avg(&num_meas_points,&fftr[0],&ffti[0],&fftnmag[0],&fftnph[0]);
  }
  else if(i_rw_bin_ascii==2)
  {
    for(i_read=0;i_read<num_meas_points;i_read++)
    { // i_read loop
        fft_mag_read_fft = expl(ln_10*fftnmag[i_read]/20.0);
      fftr[i_read] = fft_mag_read_fft * cosl(fftnph[i_read]*pi/180.0);
      ffti[i_read] = fft_mag_read_fft * sinl(fftnph[i_read]*pi/180.0);
    } // i_read loop
  }

  fclose(input_file);

  };  /* not quit_wf */


};  /* end procedure read_fft */
/* -------------------------------------------------------------------- */






/* ----------------------------------------------------------------------- */
/*
 Reads rrc compression filter from disk, puts values in arrays Re_rrc_filt,Im_rrc_filt
 Delf is time step inferred from the first two data lines read. Num
 is the number of values read from waveform. Variable rrc_error set to 1 if
 there was a problem reading data.
*/
void read_rrc_filt(char rrc_filt_filename[],long double Re_rrc_filt[],long double Im_rrc_filt[],
long double *delf,long int *num)
{

FILE *input_file;
int io_error,quit_wf;
int i_read;
long double freq_read;
long double freq[2];
char ascii_readt;
char quit_str[2];
char Quit_str[2];
int num_read;
int num_read_1,num_read_2,num_read_3;

  quit_wf = 0;
  Quit_str[0] = 'Q';
  Quit_str[1] = '\0';
  quit_str[0] = 'q';
  quit_str[1] = '\0';
  do
  {
      printf("Enter file name containing compression filter, or Q to quit:\n");

      scanf("%s",rrc_filt_filename);
      if( strcmp(rrc_filt_filename,quit_str)==0 || strcmp(rrc_filt_filename,Quit_str)==0)
      {
        quit_wf = 1;
        rrc_error = 1;
      }

      if(i_rw_bin_ascii==2)
      {
        if(! quit_wf)
        {
          if((input_file=fopen(rrc_filt_filename,"r")) == NULL)
          {
            io_error = 1;
          }
          else
          {
            io_error = 0;
          };
          if(io_error) 
          {
            printf("%s%s%s","Error opening file ",rrc_filt_filename,";\n");
          };
        };
      }
      else if(i_rw_bin_ascii==1)
      {      
        if(! quit_wf)
        {
          if((input_file=fopen(rrc_filt_filename,"rb")) == NULL)
          {
            io_error = 1;
          }
          else
          {
            io_error = 0;
          };
          if(io_error) 
          {
            printf("%s%s%s","Error opening file ",rrc_filt_filename,";\n");
          };
        };
      }
  }
  while(!( (! io_error) || (quit_wf) ) );

  if(! quit_wf)
  {
    io_error = 0;
    if(i_rw_bin_ascii==2)
    {
      to_next_line(input_file); /* read labels */
      to_next_line(input_file); /* read line with x */
    }
    else if(i_rw_bin_ascii==1)
    {
      fread(filename,FILENAME_DIM,1,input_file);
    }
    i_read = -1;
    do
    {
      i_read = i_read + 1;
      if(i_rw_bin_ascii==2)
      {
        num_read = fscanf(input_file,"%Le%Le%Le",&freq_read,&Re_rrc_filt[i_read],
          &Im_rrc_filt[i_read]);
      }
      else if(i_rw_bin_ascii==1)
      {
        num_read_1 = fread(&freq_read,sizeof(long double),1,input_file);
        num_read_2 = fread(&Re_rrc_filt[i_read],sizeof(long double),1,input_file);
        num_read_3 = fread(&Im_rrc_filt[i_read],sizeof(long double),1,input_file);
        num_read = num_read_1 + num_read_2 + num_read_3;
      }
      if(i_read==0) freq[0] = freq_read;
      if(i_read==1) freq[1] = freq_read;
      if(num_read != 3) io_error = 1;        
    }
    while(!( (i_read==num_meas_points-1) || io_error ) );

    if(! io_error)
    {
      *num = i_read+1;
    }
    else
    {
      *num = i_read;
    };

    if(*num<1)
    {
      rrc_error = 1;
      printf("Warning - no data was found\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    };

    *delf = freq[1] - freq[0];

    if(*num<num_meas_points)
    {
      rrc_error = 1;
      printf("Warning: number of points in rrc_filter file less than num_meas_points;\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    };

    if(fabsl(*delf-deltaf)>small_number_freq)
    {
      printf("Warning - delf in rrc_filter file doesn't match program value;\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    };

  fclose(input_file);

  }  /* not quit_wf */

} // end read_rrc_filt
/* -------------------------------------------------------------------- */







/* ---------------------------------------------------------------------- */
void fft_menu(void)
{


int quit_fft;
char fft_ascii;
int i,ifft;
long double fftmagsq,delf;
int i_max_fft,mag_plot_num,ph_plot_num;
char ascii_code_add;
long double fftmag_1,fftmag_2,fftreal_1,fftreal_2,fftimag_1,fftimag_2;
long double real_value;
int inv_src,inv_dest,imag_err_inv;
char inv_ascii_wait;
long double fftmag_inv,max_mag_inv;
#define SMALL_NUMBER_INV 1.0e-8

// color = 1;
quit_fft = 0;

do
{
  system("cls"); // clear the console screen
  printf("1 to take FFT of time waveform 1\n");
  printf("2 to take FFT of time waveform 2\n");
  printf("B to take FFT of both time waveforms\n");
  printf("D to form amplitude ratio and phase difference in FFT1\n");
  printf("U to add FFTs and put result in FFT1\n");
  printf("C to subtract FFTs and put result in FFT1\n");
  printf("M to multiply (convolve) FFTs and put result in FFT1\n");
  printf("A to plot FFT amplitude\n");
  printf("H to plot FFT phase\n");
  printf("S to save FFT to a file\n");
  printf("R to read FFT from a file\n");
  printf("P to set FFT amplitude plot vertical scale\n");
  printf("%s%e%s","G to set tau for phase plot (",Tg,")\n");
  printf("V to set up FFT magnitude averaging");
  if(fft_mag_avg_mode==1)
  {
    printf("%s%ld%s"," (",fft_mag_avg_npts," points)\n");
  }
  else if(fft_mag_avg_mode==2)
  {
    printf("%s%Le%s"," (",fft_mag_avg_frac," octave)\n");
  }
  else
  {
    printf(" (disabled)\n");
  }
  if(fft_mag_avg_mode>0)
  {
    printf("%s%Le%s","F to set cutoff frequency for FFT averaging (",freq_cutoff_avg,")\n");
  }
  printf("N to calculate inverse FFT and place result in time waveform\n");
  printf("Q to return to main menu\n");
  printf("Enter Command :\n");


  fft_ascii = getch();

  if( my_toupper(fft_ascii) == 'Q' )
  {
    quit_fft = 1;
  };

  if( my_toupper(fft_ascii) != 'Q')
  { /* fft_ascii!='q' */

    if(my_toupper(fft_ascii)=='N')
    { // 'N'

      rn2 = nptst / 2;
      fft_size=nptst;
      delf = nptst;
      delf = 1.0 / ( delf * delt);

      j=1;
      nstage=0;
      do
      {
        j = j*2;
        nstage++;
      }
      while(j < nptst);

// set up sin_array[],cos_array[] for FFT calculation
        for(i=0;i<= (nptst / 2) - 1;i++)
        { /* setup trig arrays for FFT */
          cos_array[i] = cosl(i * pi / rn2);
          sin_array[i] = -sinl(i * pi / rn2);
        }; /* end setup trig arrays for FFT procedure */

      printf("Enter source FFT (1 or 2):\n");
      do
      {
        get_integer(&inv_src);
        if((inv_src<0) || (inv_src>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((inv_src<0) || (inv_src>2));

      printf("Enter destination time waveform (1 or 2):\n");
      do
      {
        get_integer(&inv_dest);
        if((inv_dest<0) || (inv_dest>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((inv_dest<0) || (inv_dest>2));

      if(inv_src==1)
      {
        for(i=0;i<nptst;i++)
        { // i-loop
          xinr[i] = fftr1[i];
          xini[i] = ffti1[i];
        } // i-loop
      }
      else if(inv_src==2)
      {
        for(i=0;i<nptst;i++)
        { // i-loop
          xinr[i] = fftr2[i];
          xini[i] = ffti2[i];
        } // i-loop
      }

// calculate reverse FFT:
      fft(1,&fft_size,&nstage,xinr,xini,fftr,ffti,cos_array,sin_array,
      &max_mag_inv);

// Check for imaginary part
      imag_err_inv=0;
      for(i=0;i<nptst;i++)
      { // i-loop
        if(inv_dest==1)
        {
          y1a[i] = fftr[i];
        }
        else
        {
          y2a[i] = fftr[i];
        }
        if(fabsl(ffti[i]) > SMALL_NUMBER_INV)
        {
          imag_err_inv=1;
        }
      } // i-loop
      if(imag_err_inv>0)
      {
        printf("%s%d%s","Warning - imaginary part in time waveform ",inv_dest,"\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      }
    } // 'N'


    if(my_toupper(fft_ascii) == 'R')
    {
      printf("Enter 1 or 2 for FFT:\n");

      scanf("%d",&ifft);

      if(ifft==1)
      {
        read_fft(ifft,&fftr1[0],&ffti1[0],&fft1mag[0],&fft1ph[0],&delf,&num_ptsa1);
      }
      else
      {
        read_fft(ifft,&fftr2[0],&ffti2[0],&fft2mag[0],&fft2ph[0],&delf,&num_ptsa2);
      };
    };

    if(my_toupper(fft_ascii)=='V')
    { // toupper(fft_ascii)=='V'
      printf("Enter 0 for no averaging, 1 for number of points, 2 for fraction of octave:\n");
      scanf("%d",&fft_mag_avg_mode);

      if(fft_mag_avg_mode<0)fft_mag_avg_mode=0;
      if(fft_mag_avg_mode>2)fft_mag_avg_mode=2;

      if(fft_mag_avg_mode==1)
      {
        printf("Enter number of frequency points to average:\n");
        scanf("%d",&fft_mag_avg_npts);

        if(fft_mag_avg_npts<1)fft_mag_avg_npts=1;
      }

      if(fft_mag_avg_mode==2)
      {
        do
        {
          printf("Enter octave fractions to average:\n");
          scanf("%Le",&fft_mag_avg_frac);

          if(fft_mag_avg_frac<=0.0)
          {
            printf("Error entering octave fraction; try again\n");
          }
        }
        while(fft_mag_avg_frac <= 0.0);

// natural log of multiplier:
        fft_mag_avg_mult = ln_2 * fft_mag_avg_frac;
        fft_mag_avg_mult = expl(fft_mag_avg_mult);
      }

    } // toupper(fft_ascii)=='V'


    if(my_toupper(fft_ascii)=='F')
    { // toupper(fft_ascii)=='F'

        freq_cutoff_avg=0.0;
        do
        {
          printf("Enter cutoff frequency for FFT averaging in Hz:\n");
          scanf("%Le",&freq_cutoff_avg);

          if(freq_cutoff_avg<=0.0)
          {
            printf("Error entering frequency; try again\n");
          }
        }
        while(freq_cutoff_avg <= 0.0);

        real_value = ((freq_cutoff_avg + 0.1)/deltaf) + 1.0;
        npts_cutoff_avg = (long int) real_value;
        if(npts_cutoff_avg > (nptst/2))npts_cutoff_avg=(nptst/2);

    } // toupper(fft_ascii)=='F'


    if(my_toupper(fft_ascii)=='G')
    {
      printf("Enter tau in seconds:\n");
      scanf("%e",&Tg);
    };

    if(my_toupper(fft_ascii)=='S')
    {
      printf("Enter 1 or 2 for FFT:");

      scanf("%d",&ifft);
      if(ifft==1)
      {
        save_fft(ifft,&fftr1[0],&ffti1[0],&fft1mag[0],&fft1ph[0],&deltaf,&num_ptsa1);
      }
      else if(ifft==2)
      {
        save_fft(ifft,&fftr2[0],&ffti2[0],&fft2mag[0],&fft2ph[0],&deltaf,&num_ptsa1);
      }
    };

    if(my_toupper(fft_ascii)=='P')
    {
      system("cls"); // clear the console screen
      printf("Enter FFT amplitude maximum vertical scale value in dB :\n");
      get_real(&ymaxa);
      printf("Enter FFT amplitude minimum vertical scale value in dB :\n");
      get_real(&ymina);

      deltaf_float = deltaf;
      setup_vert_axis(&ndivha,&ndivva,&n_ha,&n_va,&extend_ticsa,&minxa,&minya,&maxxa,
      &maxya,&i_mina,&i_maxa,&i_truncatea,&interpolatea,&int_diva,&plot_mode,&THD,
      &nptsa,
      &deltaha,&deltava,&deltah_na,&deltav_na,&xmina,&xmaxa,&ymina,&ymaxa,&xmin_axisa,
      &xmax_axisa,&ymin_axisa,&ymax_axisa,&deltaf_float,&strt_vala,&fft1mag[0]);

    };


    if( (fft_ascii=='1') || (my_toupper(fft_ascii)=='B') )
    { /* take FFT1 */
      system("cls"); // clear the console screen
      printf("Taking FFT ...\n");

      nstage=0;
      i=n;
      while((i/2) != 0)
      {
        i=i/2;
        nstage += 1;
      }

      rn2 = n / 2;
      for(i_init=0;i_init <= (n / 2) - 1;i_init++)
      { /* setup trig arrays for FFT procedure */
        cos_array[i_init] = cosl(i_init * pi / rn2);
        sin_array[i_init] = -sinl(i_init * pi / rn2);
      }; /* end setup trig arrays for FFT procedure */

      for(i=0;i<=nptsa-1;i++)
      { /* setup input arrays for FFT1 */
        if(i<i_truncatet1)
        {
            xinr[i] = y1a[i];
        }
        else
        {
          xinr[i] = 0.0;
        };
        xini[i] = 0.0;
      }; /* end setup input arrays for FFT1 */

      fft(2,&n,&nstage,&xinr[0],&xini[0],&fftr1[0],&ffti1[0],
      &cos_array[0],&sin_array[0],&max_fft_mag);

      calc_fft_mag_ph(&nptsa,&fftr1[0],&ffti1[0],&fft1mag[0],&fft1ph[0]);

    }; /* end take FFT1 */


    if( (fft_ascii=='2') || (my_toupper(fft_ascii)=='B'))
    { /* take FFT2 */
      system("cls"); // clear the console screen
      printf("Taking FFT ...\n");

      nstage=0;
      i=n;
      while((i/2) != 0)
      {
        i=i/2;
        nstage += 1;
      }

      rn2 = n / 2;
      for(i_init=0;i_init <= (n / 2) - 1;i_init++)
      { /* setup trig arrays for FFT procedure */
        cos_array[i_init] = cosl(i_init * pi / rn2);
        sin_array[i_init] = -sinl(i_init * pi / rn2);
      }; /* end setup trig arrays for FFT procedure */

      for(i=0;i<=nptsa-1;i++)
      { /* setup input arrays for FFT2 */
        if(i<i_truncatet2)
        {
            xinr[i] = y2a[i];
        }
        else
        {
          xinr[i] = 0.0;
        };
        xini[i] = 0.0;
      }; /* end setup input arrays for FFT2 */

      fft(2,&n,&nstage,&xinr[0],&xini[0],&fftr2[0],&ffti2[0],
      &cos_array[0],&sin_array[0],&max_fft_mag);

      calc_fft_mag_ph(&nptsa,&fftr2[0],&ffti2[0],&fft2mag[0],&fft2ph[0]);

    }; /* end take FFT2 */


    if(my_toupper(fft_ascii)=='A')
    { /* plot FFT magnitude */
      printf("Select FFT 1 or 2:\n");
      get_integer(&mag_plot_num);
      if(mag_plot_num<1)
      {
        mag_plot_num = 1;
      };
      if(mag_plot_num>2)
      {
        mag_plot_num = 2;
      };

      plot_mode = 2; /* plot mode for FFT magnitude vs. frequency */
      if(mag_plot_num==1)
      {
        deltaf_float = deltaf;
        plot_results(&ndivha,&ndivva,&n_ha,&n_va,&extend_ticsa,&minxa,&minya,&maxxa,
          &maxya,&i_mina,&i_maxa,&i_truncatea,&interpolatea,&int_diva,&plot_mode,
          &THD,&nptsa,&deltaha,&deltava,&deltah_na,&deltav_na,&xmina,&xmaxa,&ymina,
          &ymaxa,&xmin_axisa,&xmax_axisa,&ymin_axisa,&ymax_axisa,&deltaf_float,&strt_vala,
          &THD_v1,&fft1mag[0]);
        graphics_window_end();
      }
      else
      {
        deltaf_float = deltaf;
        plot_results(&ndivha,&ndivva,&n_ha,&n_va,&extend_ticsa,&minxa,&minya,&maxxa,
          &maxya,&i_mina,&i_maxa,&i_truncatea,&interpolatea,&int_diva,&plot_mode,
          &THD,&nptsa,&deltaha,&deltava,&deltah_na,&deltav_na,&xmina,&xmaxa,&ymina,
          &ymaxa,&xmin_axisa,&xmax_axisa,&ymin_axisa,&ymax_axisa,&deltaf_float,&strt_vala,
          &THD_v2,&fft2mag[0]);
        graphics_window_end();
      };

    }; /* end plot FFT magnitude */


    if(my_toupper(fft_ascii)=='H')
    { /* plot FFT phase */
      printf("Select FFT 1 or 2:\n");
      get_integer(&ph_plot_num);
      if(ph_plot_num<1)
      {
        ph_plot_num = 1;
      };
      if(ph_plot_num>2)
      {
        ph_plot_num = 2;
      };

      plot_mode = 3; /* plot mode for FFT phase vs. frequency */

      if(ph_plot_num==1)
      {
        deltaf_float = deltaf;
        plot_results(&ndivhp,&ndivvp,&n_hp,&n_vp,&extend_ticsp,&minxp,&minyp,&maxxp,
          &maxyp,&i_minp,&i_maxp,&i_truncatep,&interpolatep,&int_divp,&plot_mode,
          &THD,&nptsp,&deltahp,&deltavp,&deltah_np,&deltav_np,&xminp,&xmaxp,&yminp,
          &ymaxp,&xmin_axisp,&xmax_axisp,&ymin_axisp,&ymax_axisp,&deltaf_float,&strt_valp,
          &THD_v1,&fft1ph[0]);
        graphics_window_end();
      }
      else
      {
        deltaf_float = deltaf;
        plot_results(&ndivhp,&ndivvp,&n_hp,&n_vp,&extend_ticsp,&minxp,&minyp,&maxxp,
          &maxyp,&i_minp,&i_maxp,&i_truncatep,&interpolatep,&int_divp,&plot_mode,
          &THD,&nptsp,&deltahp,&deltavp,&deltah_np,&deltav_np,&xminp,&xmaxp,&yminp,
          &ymaxp,&xmin_axisp,&xmax_axisp,&ymin_axisp,&ymax_axisp,&deltaf_float,&strt_valp,
          &THD_v2,&fft2ph[0]);
        graphics_window_end();
      };

    }; /* end plot FFT phase */


    if(my_toupper(fft_ascii)=='D')
    { // 'D'
      system("cls"); // clear the console screen
      printf("Computing values ...\n");
      for(i=0;i<=nptsa-1;i++)
      { // i-loop
        fft1mag[i] = fft1mag[i] - fft2mag[i]; /* magnitude ratio in dB */
        fft1ph[i] = fft1ph[i] - fft2ph[i]; /* phase difference in degrees */
        if(fft1ph[i]>180.0)
        {
          fft1ph[i] = fft1ph[i] - 360.0;
        };
        if(fft1ph[i]<-180.0)
        {
          fft1ph[i] = fft1ph[i] + 360.0;
        };
        fftmag_1 = expl(ln_10*fft1mag[i]/20.0);
        fftr1[i] = fftmag_1*cosl(fft1ph[i]*pi/180.0);     
        ffti1[i] = fftmag_1*sinl(fft1ph[i]*pi/180.0);
      } // i-loop
    } // 'D'

    if(my_toupper(fft_ascii)=='M')
    { // 'M'
      for(i=0;i<=nptsa-1;i++)
      { // i-loop
          fftreal_1 = fftr1[i];
          fftimag_1 = ffti1[i];
          fftreal_2 = fftr2[i];
          fftimag_2 = ffti2[i];
          fftr1[i] = fftreal_1*fftreal_2 - fftimag_1*fftimag_2;
          ffti1[i] = fftreal_1*fftimag_2 + fftimag_1*fftreal_2;
      } // i-loop
      calc_fft_mag_ph_no_avg(&nptsa,&fftr1[0],&ffti1[0],&fft1mag[0],&fft1ph[0]);
      printf("FFTs have been multiplied\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    } // 'M'


    if(my_toupper(fft_ascii)=='U')
    { // 'U'
      for(i=0;i<=nptsa-1;i++)
      { // i-loop
          fftreal_1 = fftr1[i];
          fftimag_1 = ffti1[i];
          fftreal_2 = fftr2[i];
          fftimag_2 = ffti2[i];
          fftr1[i] = fftreal_1+fftreal_2;
          ffti1[i] = fftimag_1+fftimag_2;
      } // i-loop
      calc_fft_mag_ph_no_avg(&nptsa,&fftr1[0],&ffti1[0],&fft1mag[0],&fft1ph[0]);
      printf("FFTs have been added\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    } // 'U'

    if(my_toupper(fft_ascii)=='C')
    { // 'C'
      for(i=0;i<=nptsa-1;i++)
      { // i-loop
          fftreal_1 = fftr1[i];
          fftimag_1 = ffti1[i];
          fftreal_2 = fftr2[i];
          fftimag_2 = ffti2[i];
          fftr1[i] = fftreal_1-fftreal_2;
          ffti1[i] = fftimag_1-fftimag_2;
      } // i-loop
      calc_fft_mag_ph_no_avg(&nptsa,&fftr1[0],&ffti1[0],&fft1mag[0],&fft1ph[0]);
      printf("FFTs have been subtracted\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    } // 'C'


  }; /* end fft_ascii!='q' */

}
while(!quit_fft);

}; /* end of procedure fft_menu */
/* ---------------------------------------------------------------------- */






/* ----------------------------------------------------------------- */
/*
 The following procedure reads to the end of the current line. It stops
 when either \n or eof is found.
*/


void to_next_line(FILE *input_file_nl)

{

char ascii_read_nl;

if(!feof(input_file_nl))
{
  do
  {
    fscanf(input_file_nl,"%c",&ascii_read_nl);
  }
  while(!( (ascii_read_nl=='\n') || (feof(input_file_nl)) ) );

}

};  /* end procedure to_next_line */
/* ------------------------------------------------------------------- */







/* ----------------------------------------------------------------- */
long int Round_long(long double real_n)
{

long int longint_round;
long double double_round;

  longint_round = real_n;
  double_round = longint_round;
  if(real_n-double_round >= 0.5) longint_round = longint_round + 1;
  if(real_n-double_round <= -0.5) longint_round = longint_round - 1;

  return longint_round;
};
/* ------------------------------------------------------------------ */




/* ----------------------------------------------------------------- */
long int Round(double real_n)
{

long int longint_round;
double double_round;

  longint_round = real_n;
  double_round = longint_round;
  if(real_n-double_round >= 0.5) longint_round = longint_round + 1;
  if(real_n-double_round <= -0.5) longint_round = longint_round - 1;

  return longint_round;
};
/* ------------------------------------------------------------------ */






/* ---------------------------------------------------------------------- */
void readt_from_disk(void)
{

int quit_readt;
char readt_ascii;

quit_readt = 0;

do
{
  system("cls"); // clear the console screen
  printf("1 to read time waveform 1 from disk\n");
  printf("2 to read time waveform 2 from disk\n");
  printf("B to read both time waveforms from disk\n");
  printf("Q to return to time waveforms menu\n");
  printf("Enter Command :\n");

  readt_ascii = getch();

  if(my_toupper(readt_ascii) == 'Q') quit_readt = 1;
  if(my_toupper(readt_ascii) != 'Q')
  {
    if( (readt_ascii=='1') || (my_toupper(readt_ascii)=='B') )
    {
      read_time_waveform(1,num_meas_points,&y1a[0],&deltat1,&num_ptst1,
        &file_name[0]);
      i_shift_wf1=0;
    }

    if( (readt_ascii=='2') || (my_toupper(readt_ascii)=='B') )
    {
      read_time_waveform(2,num_meas_points,&y2a[0],&deltat2,&num_ptst2,
        &file_name[0]);
      i_shift_wf2=0;
    }

  };  /* end of readt_ascii != 'Q' */
}
while(!quit_readt);

};  /* end of procedure readt_from_disk */
/* ---------------------------------------------------------------------- */





/* ---------------------------------------------------------------------- */
void savet_to_disk(void)
{

int quit_savet,save_truncated;
char savet_ascii;

  quit_savet = 0;

do
{
  system("cls"); // clear the console screen
  printf("1 to save time waveform 1 to disk\n");
  printf("2 to save time waveform 2 to disk\n");
  printf("B to save both time waveforms to disk\n");
  printf("Q to return to time waveforms menu\n");
  printf("Enter Command :\n");

  savet_ascii = getch();

  if(my_toupper(savet_ascii) == 'Q') quit_savet = 1;
  if(my_toupper(savet_ascii) != 'Q')
  {
    if((savet_ascii=='1') || (my_toupper(savet_ascii)=='B') )
    {
      save_truncated = 0;

      save_time_waveform(1,save_truncated,i_truncatet1,&y1a[0],&deltat1,&num_ptst1);
    }

    if((savet_ascii=='2') || (my_toupper(savet_ascii)=='B') )
    {
      save_truncated = 0;

      save_time_waveform(2,save_truncated,i_truncatet2,&y2a[0],&deltat1,&num_ptst2);
    }

  };  /* end of savet_ascii != 'Q' */
}
while(!quit_savet);

};  /* end of procedure savet_to_disk */
/* ---------------------------------------------------------------------- */






/* ----------------------------------------------------------------------- */
/*
 Reads time waveform iwf (1 or 2) from disk, puts values in array y.
 If iwf=0, just read time waveform into y[] without identifying its number.
 Delt is time step inferred from the first two data lines read. Num
 is the number of values read from waveform. max_num_pts is the maximum
 number of points y[] can have, and y[] is optionally filled with zeroes
 out to this point if the waveform does not contain max_num_pts.
*/
void read_time_waveform(int iwf,long int max_num_pts,long double y[],
long double *delt,long int *num,char *filename)
{

FILE *input_file;
int io_error,quit_wf;
int i_read,i_read_2,num_read;
long double time_read;
long double value_read;
long double time[2];
char ascii_readt;
char quit_str[2];
char Quit_str[2];
long double data_time_value[2];

  *delt = deltat; // initialize in case delt is not set in this routine

  quit_str[0] = 'q';
  quit_str[1] = '\0';
  Quit_str[0] = 'Q';
  Quit_str[1] = '\0';
  quit_wf = 0;
  do
  {
      if(iwf>0)
      {
        printf("%s%d%s","Enter file name for time waveform ",iwf,", or Q to quit:\n");
      }
      else
      {
        printf("Enter file name for time waveform or Q to quit:\n");
      }


      scanf("%s",filename);
//      getnstr(&filename[0],FILENAME_DIM-1);
      if( (strcmp(&filename[0],&quit_str[0])==0) || (strcmp(&filename[0],&Quit_str[0])==0) )
        quit_wf = 1;

      if(! quit_wf)
      {  /* !quit_wf */
        if(i_rw_bin_ascii==2)
        { // i_rw_bin_ascii==2
          if((input_file=fopen(filename,"r")) == NULL)
          {
            io_error = 1;
          }
          else
          {
            io_error = 0;
          };
        } // i_rw_bin_ascii==2
        else if(i_rw_bin_ascii==1)
        { // i_rw_bin_ascii==1
          if((input_file=fopen(filename,"rb")) == NULL)
          {
            io_error = 1;
          }
          else
          {
            io_error = 0;
          };
        } // i_rw_bin_ascii==1

        if(io_error) 
        {
          printf("%s%s%s","Error opening file ",&filename[0],";\n");
        };
      };  /* !quit_wf */
  }
  while( !( (!io_error) || (quit_wf) ) );

  if(! quit_wf)
  {
    io_error = 0;
    if(i_rw_bin_ascii==2)
    { // i_rw_bin_ascii==2
      to_next_line(input_file);  /* read labels */
      to_next_line(input_file);  /* read line with x */
    } // i_rw_bin_ascii==2
    else if(i_rw_bin_ascii==1)
    { // i_rw_bin_ascii==1
      fread(filename,FILENAME_DIM,1,input_file); // read comment
    } // i_rw_bin_ascii==1
    i_read = -1;
    i_read_2 = -1;
    do
    {
      i_read_2 = i_read_2 + 1;
      if(i_rw_bin_ascii==2)
      {
//      num_read = fscanf(input_file,"%Le%Le",&time_read,&value_read);
        num_read = fscanf(input_file,"%Le%Le",&data_time_value[0],&data_time_value[1]);
      }
      else if(i_rw_bin_ascii==1)
      {
        num_read = fread(&data_time_value[0],sizeof(long double),2,input_file);
      }
      if( (i_read_2==0) && (num_read==2) )
      {
        time[0] = data_time_value[0];
      };
      if( (i_read_2==1) && (num_read==2) )
      {
        time[1] = data_time_value[0];
        *delt = time[1] - time[0];
      };
      if(num_read < 1)
      {
        io_error = 1;
      };
      if( (! io_error) && (i_read_2<max_num_pts) )
      {
        i_read = i_read_2;
        if(num_read==2)
        {
          y[i_read] = data_time_value[1];
        }
        else if(num_read==1)
        {
            y[i_read] = data_time_value[0];
        }
      }
    }
    while(!( (i_read_2==(max_num_pts-1)) || io_error) );

/* try to read one more line to determine eof: */
    if(i_rw_bin_ascii==2)
    {
      num_read = fscanf(input_file,"%Le%Le",&time_read,&value_read);
    }
    else if(i_rw_bin_ascii==1)
    {
      num_read = fread(&data_time_value[0],sizeof(long double),2,input_file);
    }

    if(num_read < 1) io_error = 1;

    *num = i_read+1;

    if((*num==max_num_pts) && (! io_error) )
    {
      printf("Warning - array is filled up, but not at end of file;\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    };

    if(*num<1)
    {
      printf("Warning - no data was found\n");
    };

    if(*num<max_num_pts)
    {
      printf("Warning: number of points is less than max_num_pts;\n");
      printf("Fill remaining values with 0s? 1=Y, 0=N:\n");
      scanf("%d",&i_read);
      if(i_read==1)
      {
        for(i_read=*num; i_read<=(max_num_pts-1); i_read++)
        {
          y[i_read] = 0.0;
        };
// fix for variable number of waveform points:
        *num=max_num_pts;
      };
    };
    if(fabs(*delt-deltat)>small_number)
    {
      printf("Warning - delt in file doesnt match program value;\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    };

  fclose(input_file);

  if(iwf==1)
  {
    i_truncatet1 = nptst;
    i_shift_wf1 = 0;
    scale_wf1 = 1.0;
  }
  else if(iwf==2)
  {
    i_truncatet2 = nptst;
    i_shift_wf2 = 0;
    scale_wf2 = 1.0;
  }

  };  /* not quit_wf */


};  /* end procedure read_time_waveform */
/* -------------------------------------------------------------------- */






/* ----------------------------------------------------------------------- */
/*
 Saves time waveform iwf (1 or 2) to disk file.
*/
void save_time_waveform(int iwf,int save_truncated,int itruncate,long double y[],
long double *delt,long int *num)
{

char filename[FILENAME_DIM];
FILE *output_file;
long int i_wr;
long double data_time_value[2];
char Quit_str[2];
char quit_str[2];


  Quit_str[0] = 'Q';
  Quit_str[1] = '\0';
  quit_str[0] = 'q';
  quit_str[1] = '\0';
  if(save_truncated)
  {
    printf("%s%d%s","Enter file name for truncated time waveform ",iwf,":\n");
  }
  else
  {
    printf("%s%d%s","Enter file name for time waveform ",iwf,":\n");
  }

  scanf("%s",filename);

  if(i_rw_bin_ascii==2)
  { // i_rw_bin_ascii==2
    while( (output_file=fopen(filename,"w")) == NULL)
    {
      printf("Error opening file, enter another name or Q to quit:\n");
      scanf("%s",filename);
      if( (strcmp(filename,Quit_str)==0) || (strcmp(filename,quit_str)==0))
        terminate_program();
    };
  } // i_rw_bin_ascii==2
  else if(i_rw_bin_ascii==1)
  { // i_rw_bin_ascii==1
    while( (output_file=fopen(filename,"wb")) == NULL)
    {
      printf("Error opening file, enter another name or Q to quit:\n");
      scanf("%s",filename);
      if( (strcmp(filename,Quit_str)==0) || (strcmp(filename,quit_str)==0))
        terminate_program();
    };
  } // i_rw_bin_ascii==1

  printf("Enter single line of comments:\n");
  fgets(filename,FILENAME_DIM,stdin);
  if
  (
    (filename[0]=='\n')
    &&
    (filename[1]=='\0')
  )
  {
    fgets(filename,FILENAME_DIM,stdin);
  }
  i_wr=0;
  while
  (
    (filename[i_wr]!='\n')
    &&
    (filename[i_wr] != '\0')
    &&
    (i_wr < FILENAME_DIM)
  )
  {
    i_wr++;
  }
  filename[i_wr]='\0';

  if(i_rw_bin_ascii==2)
  {
    fprintf(output_file,"%s%s",filename,"\n");
    fprintf(output_file,"%s","x\n");
  }
  else if(i_rw_bin_ascii==1)
  {
    fwrite(filename,FILENAME_DIM,1,output_file);
  }

  for(i_wr=0; i_wr <= *num - 1; i_wr++)
  { 
    if(save_truncated)
    {
      if(i_wr>=itruncate)
      {
        if(i_rw_bin_ascii==2)
        {
          fprintf(output_file,"%18.10Le%s",i_wr*(*delt)," 0.0\n");
        }
        else if(i_rw_bin_ascii==1)
        {
          data_time_value[0] = i_wr*(*delt);
          data_time_value[1] = 0.0;
          fwrite(&data_time_value[0],sizeof data_time_value,1,output_file);
        }
      }
      else
      {
        if(i_rw_bin_ascii==2)
        {
          fprintf(output_file,"%18.10Le%s%18.10Le%s",i_wr*(*delt),"  ",y[i_wr],"\n");
        }
        else if(i_rw_bin_ascii==1)
        {
          data_time_value[0] = i_wr*(*delt);
          data_time_value[1] = y[i_wr];
          fwrite(&data_time_value[0],sizeof data_time_value,1,output_file);
        }
      }
    }
    else
    {
        if(i_rw_bin_ascii==2)
        {
          fprintf(output_file,"%18.10Le%s%18.10Le%s",i_wr*(*delt),"  ",y[i_wr],"\n");
        }
        else if(i_rw_bin_ascii==1)
        {
          data_time_value[0] = i_wr*(*delt);
          data_time_value[1] = y[i_wr];
          fwrite(&data_time_value[0],sizeof data_time_value,1,output_file);
        }
    }

  };
  if(i_rw_bin_ascii==2)
  {
    fprintf(output_file,"%s","y\n");
  }

  fclose(output_file);

};  /* end procedure save_time_waveform */
/* -------------------------------------------------------------------- */






/* ------------------------------------------------------------------------------ */
void time_waveforms_menu(void)
{


int quit_time;
char time_ascii;
int i_plot;
int i_window_apply;
int i_wfm_shift;
long int i_shift,i_shift_value,j_shift;

  quit_time = 0;
//  color = 1;

do
{
  system("cls"); // clear the console screen
  printf("R to read time waveform(s) from disk\n");
  printf("S to save time waveform(s) to disk\n");
  printf("P to plot time waveforms\n");
  printf("A to change vertical axis range for plots vs. time\n");
  printf("T to subtract");
  if( (i_truncatet1<nptst) || (i_truncatet2<nptst) )
  {
    printf(" ***truncated*** time waveforms (y1 - y2 -> y1)\n");
  }
  else
  {
    printf(" time waveforms (y1 - y2 -> y1)\n");
  }
  printf("U to add");
  if( (i_truncatet1<nptst) || (i_truncatet2<nptst) )
  {
    printf(" ***truncated*** time waveforms (y1 + y2 -> y1)\n");
  }
  else
  {
    printf(" time waveforms (y1 + y2 -> y1)\n");
  }
  printf("W to set up window function");
  if(window_type==1)
  {
    printf("%s%ld%s%ld%s"," Bartlett(linear) (",i_window_1+1,",",i_window_2+1,")\n");
  }
  else if(window_type==2)
  {
    printf("%s%ld%s%ld%s"," Hanning(cosine) (",i_window_1+1,",",i_window_2+1,")\n");
  }
  else if(window_type==3)
  {
    printf("%s%ld%s%ld%s"," Hamming(cosine-residual) (",i_window_1+1,",",i_window_2+1,")\n");
  }
  else if(window_type==4)
  {
    printf("%s%ld%s%ld%s"," Blackman(double cosine) (",i_window_1+1,",",i_window_2+1,")\n");
  }
  else if(window_type==5)
  {
    printf("%s%ld%s%ld%s"," Parzen(cubic) (",i_window_1+1,",",i_window_2+1,")\n");
  }
  else if(window_type==0)
  {
    printf("\n");
  }
  if(window_type>0)
  {
    printf("Y to apply window function\n");
  }
  printf("L to remove reflections using a compression filter\n");
  printf("%s%ld%s%ld%s","I to shift time waveforms (",i_shift_wf1,",",
    i_shift_wf2,")\n");
  printf("%s%Le%s%Le%s","C to scale time waveforms (",scale_wf1,",",scale_wf2,")\n");
  printf("Q to return to main menu\n");
  printf("Enter Command :\n");

  time_ascii = getch();

  if(my_toupper(time_ascii) == 'Q') quit_time = 1;

  if(my_toupper(time_ascii) != 'Q')
  {

    if(my_toupper(time_ascii) == 'C')
    { // 'C'
      printf("Enter waveform number to be scaled, 1 or 2:\n");
      do
      {
        get_integer(&i_wfm_scale);
        if((i_wfm_scale<1) || (i_wfm_scale>2))
        {
          printf("Error - enter waveform number again\n");
        }
      }
      while((i_wfm_scale<1) || (i_wfm_scale>2));

      printf("%s%d%s","Enter scale factor for waveform ",i_wfm_scale,":\n");
      if(i_wfm_scale==1)
      {
        scale_wf1_old = scale_wf1;
        get_long_double(&scale_wf1);
      }
      else
      {
        scale_wf2_old = scale_wf2;
        get_long_double(&scale_wf2);
      }

      if(i_wfm_scale==1)
      {
        for(i=0;i<nptst;i++)
        {
          y1a[i] *= scale_wf1;
        }
        scale_wf1 *= scale_wf1_old;
      }
      else
      {
        for(i=0;i<nptst;i++)
        {
          y2a[i] *= scale_wf2;
        }
        scale_wf2 *= scale_wf2_old;
      }
    } // 'C'


    if(my_toupper(time_ascii) == 'I')
    { // 'I'
      printf("Enter waveform number to be shifted, 1 or 2:\n");
      do
      {
        get_integer(&i_wfm_shift);
        if((i_wfm_shift<1) || (i_wfm_shift>2))
        {
          printf("Error - enter waveform number again\n");
        }
      }
      while((i_wfm_shift<1) || (i_wfm_shift>2));

      printf("Enter shift value (integer - positive to the right):\n");
      do
      {
        get_long_int(&i_shift_value);
        if((i_shift_value<-(nptst-1)) || (i_shift_value>(nptst-1)))
        {
          printf("Enter again - shift is too large\n");
        }
      }
      while((i_shift_value<-(nptst-1)) || (i_shift_value>(nptst-1)));

// first copy time waveform into buffer
      for(i_shift=0;i_shift<nptst;i_shift++)
      {
        if(i_wfm_shift==1)
        {
          fftr[i_shift] = y1a[i_shift];
        }
        else
        {
          fftr[i_shift] = y2a[i_shift];
        }
      }

// now put th values back in shifted order, taking into account previous shifts
// i_shift indexes into the buffer array
      for(i_shift=0;i_shift<nptst;i_shift++)
      {
        if(i_wfm_shift==1)
        {
          j_shift = i_shift + i_shift_value - i_shift_wf1;
        }
        else
        {
          j_shift = i_shift + i_shift_value - i_shift_wf2;
        }

        if(j_shift<0)j_shift += nptst;
        if(j_shift>(nptst-1))j_shift -= nptst;

        if(i_wfm_shift==1)
        {
          y1a[j_shift] = fftr[i_shift];
        }
        else
        {
          y2a[j_shift] = fftr[i_shift];
        }
      }

      if(i_wfm_shift==1)
      {
        i_shift_wf1 = i_shift_value;
      }
      else
      {
        i_shift_wf2 = i_shift_value;
      }

      printf("%s%d%s%ld%s","Waveform ",i_wfm_shift," has been shifted to ",i_shift_value,"\n");
      printf("Press any A/N key to continue\n");
      ascii_code_continue = getch();

    } // 'I'


    if(my_toupper(time_ascii) == 'L')
    { // 'L'
      rrc_menu();
    } // 'L'

    if(my_toupper(time_ascii) == 'A')
    { // 'A'
      printf("Enter maximum vertical scale value:\n");
      get_real(&ymaxt);
      printf("Enter minimum vertical scale value:\n");
      get_real(&ymint);
      deltat_float = deltat;
      setup_vert_axis(&ndivht,&ndivvt,&n_ht,&n_vt,&extend_ticst,&minxt,&minyt,&maxxt,
      &maxyt,&i_mint,&i_maxt,&i_truncatet1,&interpolatet,&int_divt,&plot_mode,&THD,
      &nptst,
      &deltaht,&deltavt,&deltah_nt,&deltav_nt,&xmint,&xmaxt,&ymint,&ymaxt,&xmin_axist,
      &xmax_axist,&ymin_axist,&ymax_axist,&deltat_float,&strt_valt,&fft1mag[0]);
    } // 'A'


    if(my_toupper(time_ascii) == 'T')
    { // 'T'
      for(i=0;i<nptsa;i++)
      {
        if(i>=i_truncatet1)
        {
          y1a[i] = 0.0;
        }
        if(i<i_truncatet2)
        {
          y1a[i] = y1a[i] - y2a[i];
        }
      }
      printf("Waveforms have been subtracted\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    } // 'T'


    if(my_toupper(time_ascii) == 'U')
    { // 'U'
      for(i=0;i<nptsa;i++)
      {
        if(i>=i_truncatet1)
        {
          y1a[i] = 0.0;
        }
        if(i<i_truncatet2)
        {
          y1a[i] = y1a[i] + y2a[i];
        }
      }
      printf("Waveforms have been added\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
    } // 'U'


    if(my_toupper(time_ascii) == 'Y')
    { // 'Y'
      if(window_type>0)
      { // window_type>0
      do
      {
      printf("Apply window to which time waveform (1 or 2)?\n");
      get_integer(&i_window_apply);
      if((i_window_apply<1) || (i_window_apply>2))printf("Error - enter integer again:\n");
      }
      while( (i_window_apply<1) || (i_window_apply>2) );

      for(i=0;i<nptsa;i++)
      {
        if( (i>=i_window_1) && (i<=i_window_2) )
        {
          if(i_window_apply==1)
          {
            y1a[i] *= window_func[i-i_window_1];
          }
          else if(i_window_apply==2)
          {
            y2a[i] *= window_func[i-i_window_1];
          }
        }
        else if(i>i_window_2)
        {
          if(i_window_apply==1)
          {
            y1a[i] *= window_func[i_window_2-i_window_1];
          }
          else if(i_window_apply==2)
          {
            y2a[i] *= window_func[i_window_2-i_window_1];
          }
        }
      }
      printf("%s%d%s","Window has been applied to waveform ",i_window_apply,"\n");
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();
      } // window_type>0
    } // 'Y'

    if(my_toupper(time_ascii) == 'W')
    { // 'W'
      window_menu();
    }


    if(my_toupper(time_ascii) == 'P')
    {
      printf("Enter waveform number, 1 or 2:\n");

      scanf("%d",&i_plot);

      if(i_plot<=1)
      {
        i_plot = 1;
      }
      else
      {
        i_plot = 2;
      };
      plot_mode = 1;

      if(i_plot==1)
      {
      THD_plot=0;
      deltat_float = deltat;
      plot_results(&ndivht,&ndivvt,&n_ht,&n_vt,&extend_ticst,&minxt,&minyt,&maxxt,
        &maxyt,&i_mint,&i_maxt,&i_truncatet1,&interpolatet,&int_divt,&plot_mode,
        &THD_plot,&nptst,&deltaht,&deltavt,&deltah_nt,&deltav_nt,&xmint,&xmaxt,&ymint,
        &ymaxt,&xmin_axist,&xmax_axist,&ymin_axist,&ymax_axist,&deltat_float,&strt_valt,
        &THD_v1,&y1a[0]);
      graphics_window_end();
      }
      else
      {
      THD_plot=0;
      deltat_float = deltat;
      plot_results(&ndivht,&ndivvt,&n_ht,&n_vt,&extend_ticst,&minxt,&minyt,&maxxt,
        &maxyt,&i_mint,&i_maxt,&i_truncatet2,&interpolatet,&int_divt,&plot_mode,
        &THD_plot,&nptst,&deltaht,&deltavt,&deltah_nt,&deltav_nt,&xmint,&xmaxt,&ymint,
        &ymaxt,&xmin_axist,&xmax_axist,&ymin_axist,&ymax_axist,&deltat_float,&strt_valt,
        &THD_v2,&y2a[0]);
      graphics_window_end();
      };
    };

    if(my_toupper(time_ascii) == 'R') readt_from_disk();

    if(my_toupper(time_ascii) == 'S') savet_to_disk();

  };  /* end of time_ascii != 'Q' */
}
while(!quit_time);

};  /* end of procedure time_waveforms_menu */
/* ---------------------------------------------------------------------- */







/* ------------------------------------------------------------------------------ */
void rrc_menu(void)
{

#define SMALL_NUMBER_RRC 1.0e-8

int quit_rrc;
char rrc_ascii,rrc_ascii_wait;
char quit_str[2];
long double delf,delf_read_rrc;
long double rnp,freq,abs_freq,ratio,ratio_n,denom_sq,lpf_valr,lpf_vali,max_mag,imag_err;
long int num_read_rrc;
long double trmr,trmi,prodr,prodi,om_rrc;
long double a2,b2,om2,om02;
long double save_ratio;
long int n_lpf_read;

  quit_rrc = 0;
  rrc_error=0;

do
{ // do-while loop
  system("cls"); // clear the console screen
  printf("G to generate compression filter");
  if(rrc_filt==0)
  {
    printf("\n");
  }
  else if( (rrc_filt==1) || (rrc_filt==2) )
  {
    printf(" (internally generated)\n");
  }
  else if(rrc_filt==3)
  {
    printf("\n");
  }
  printf("E to toggle fmax for compression filter generation");
  if(enable_fmax_rrc_compress==1)
  {
    printf(" (enabled)\n");
  }
  else
  {
    printf(" (disabled)\n");
  }
  if(enable_fmax_rrc_compress==1)
  {
    printf("N to set fmax for compression filter generation");
    printf("%s%Le%s"," (fmax = ",fmax_rrc_compress,")\n");
    printf("M to toggle fmax phase entension method ");
    if(i_constant_phase_slope>0)
    {
      printf("(constant phase slope)\n");
    }
    else
    {
      printf("(maintain phase of compression filter)\n");
    }
    if(i_constant_phase_slope>0)
    {
      printf("%s%ld%s","O to set number of points for phase average (",
      n_del_om_fmax_compress,")\n");
      printf("%s%Le%s","U to set phase slope compensation factor (",
        phase_comp_fmax_compress,")\n");
    }
  }
  printf("H to toggle compression filter minimum phase option");
  if(minp_option==0)
  {
    printf(" (disabled)\n");
  }
  else if(minp_option==1)
  {
    printf(" (enabled)\n");
  }
  printf("R to read compression filter from a file");
  if(rrc_filt==3)
  {
    printf("%s%s%s"," (read from ",rrc_filt_filename,")\n");
  }
  else
  {
    printf("\n");
  }

  if(rrc_filt>0)
  { // rrc_filt>0
    printf("S to save compression filter to a file\n");
  } // rrc_filt>0

  printf("L to toggle optional low-pass filter");
  if(use_lpf_rrc==1)
  {
    printf(" (enabled)\n");
  }
  else
  {
    printf(" (disabled)\n");
  }

  if(use_lpf_rrc==1)
  { // use_lpf_rrc==1
    printf("P to set parameters of optional low-pass filter");
    if( (n_lpf>0) && (f0_lpf>0.0) )
    {
      printf("%s%ld%s%Le%s"," (order=",n_lpf,", f0=",f0_lpf,")\n");
    }
    else
    {
      printf("\n");
    }
    printf("Y to toggle type of optional low-pass filter");
    if(rrc_lpf_type==0)
    {
      printf(" (digital)\n");
    }
    else if(rrc_lpf_type==1)
    {
      printf(" (Butterworth)\n");
    }
    else if(rrc_lpf_type==2)
    {
      printf(" (minimum phase digital)\n");
    }
    printf("A to apply present lpf to a waveform\n");
    printf("B to apply present inverse lpf to a waveform\n");
    printf("J to toggle limiting of inverse lpf application");
    if(rrc_lim_lpf_inv==0)
    {
      printf(" (disabled)\n");
    }
    else
    {
      printf(" (enabled)\n");
    }
    if(rrc_lim_lpf_inv>0)
    {
      printf("%s%Le%s","K to set fmax for limiting inverse lpf application (",fmax_rrc_lim_lpf_inv,")\n");
    }
  } // use_lpf_rrc==1

  if(rrc_filt>0)
  { // rrc_filt>0
    printf("F to toggle fmax for de-compression");
    if(enable_fmax_rrc_decompress==1)
    {
      printf(" (enabled)\n");
    }
    else
    {
      printf(" (disabled)\n");
    }
    if(enable_fmax_rrc_decompress==1)
    {
      printf("X to set fmax for de-compression");
      printf("%s%Le%s"," (fmax = ",fmax_rrc_decompress,")\n");
    }

    printf("C to compress a waveform\n");
    printf("I to setup waveform interval for decompression");
    if( (n1_rrc>0) && (n2_rrc>0) )
    {
      printf("%s%ld%s%ld%s"," (",n1_rrc,",",n2_rrc,")\n");
    }
    else
    {
      printf("\n");
    }
    printf("T to toggle decompression interval type");
    if(rrc_int_type==0)
    {
      printf(" (inclusive)\n");
    }
    else if(rrc_int_type==1)
    {
      printf(" (exclusive)\n");
    }
    if((n1_rrc>0) && (n2_rrc>0) )
    {
      printf("D to de-compress a waveform\n");
    }
    printf("Z to toggle endpoint zero correction for de-compression");
    if(rrc_epzc_enable>0)
    {
      printf(" (enabled)\n");
    }
    else
    {
      printf(" (disabled)\n");
    }

  } // rrc_filt>0

  printf("Q to return to time waveforms menu\n");

  if( (i_shift_wf1!=0) && (i_truncatet1<nptst) )
  {    
    printf("***Waveform 1 is shifted and truncated***\n");
  }
  else if(i_shift_wf1!=0)
  {
    printf("***Waveform 1 is shifted***\n");
  }
  else if(i_truncatet1<nptst)
  {
    printf("***Waveform 1 is truncated***\n");
  } 
  if(scale_wf1 != 1.0)
  {
    printf("***Waveform 1 is scaled***\n");
  }

  if( (i_shift_wf2!=0) && (i_truncatet2<nptst) )
  {    
    printf("***Waveform 2 is shifted and truncated***\n");
  }
  else if(i_shift_wf2!=0)
  {
    printf("***Waveform 2 is shifted***\n");
  }
  else if(i_truncatet2<nptst)
  {
    printf("***Waveform 2 is truncated***\n");
  } 
  if(scale_wf2 != 1.0)
  {
    printf("***Waveform 2 is scaled***\n");
  }

  printf("\n");

  printf("Enter Command :\n");

  rrc_ascii = getch();

  if(my_toupper(rrc_ascii) == 'Q') quit_rrc = 1;

  if(my_toupper(rrc_ascii) != 'Q')
  { // my_toupper(rrc_ascii) != 'Q'

    if((enable_fmax_rrc_compress>0) && (my_toupper(rrc_ascii)=='M'))
    {
      i_constant_phase_slope++;
      if(i_constant_phase_slope>1) i_constant_phase_slope=0;
    }

    if( (enable_fmax_rrc_compress>0) && (toupper(rrc_ascii)=='U')
        && (i_constant_phase_slope>0) )
    {
          printf("Enter phase compensation factor:\n");
          get_long_double(&phase_comp_fmax_compress);
    }

    if( (enable_fmax_rrc_compress>0) && (my_toupper(rrc_ascii)=='O')
        && (i_constant_phase_slope>0) )
    {
          printf("Enter number of points for phase averaging:\n");
          do
          {
            get_long_int(&n_del_om_fmax_compress);
            check_n_del_om = sampling_rate / nptst;
            check_n_del_om *= n_del_om_fmax_compress;
            if(n_del_om_fmax_compress <= 0)
            {
              printf("Error - enter again:\n");
            }
            else if(check_n_del_om > fmax_rrc_compress)
            {
              printf("Number of points too big for fmax - enter again:\n");
            }
          }
//          while(n_del_om_fmax_compress <= 0);
          while( (n_del_om_fmax_compress <= 0) || (check_n_del_om > fmax_rrc_compress) );
   }

    if(my_toupper(rrc_ascii)=='H')
    {
      minp_option += 1;
      if(minp_option > 1) minp_option = 0;
    }


    if( (toupper(rrc_ascii) == 'J') && (use_lpf_rrc>0) )
    { // 'J'
      if(rrc_lim_lpf_inv==0)
      {
        rrc_lim_lpf_inv=1;
        if(fmax_rrc_lim_lpf_inv <= 0.0)
        {
          printf("Enter fmax for inverse lpf limiting:\n");
          do
          {
            get_long_double(&fmax_rrc_lim_lpf_inv);
            if(fmax_rrc_lim_lpf_inv <= 0.0)
            {
              printf("Error - enter again:\n");
            }
          }
          while(fmax_rrc_lim_lpf_inv <= 0.0);
        }
      }
      else
      {
        rrc_lim_lpf_inv=0;
      }
    } // 'J'


    if( (toupper(rrc_ascii) == 'K') && (use_lpf_rrc>0) )
    { // 'K'
      printf("Enter fmax for inverse lpf limiting:\n");
      do
      {
        get_long_double(&fmax_rrc_lim_lpf_inv);
        if(fmax_rrc_lim_lpf_inv <= 0.0)
        {
          printf("Error - enter again:\n");
        }
      }
      while(fmax_rrc_lim_lpf_inv <= 0.0);
    } // 'K'


    if( (my_toupper(rrc_ascii) == 'A') && (use_lpf_rrc>0) )
    { // 'A'
      rrc_error = 0;
      printf("Enter waveform to apply lpf (1 or 2):\n");
      do
      {
        get_integer(&rrc_src);
        if((rrc_src<0) || (rrc_src>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((rrc_src<0) || (rrc_src>2));

      printf("Enter destination for waveform after applying lpf (1 or 2):\n");
      do
      {
        get_integer(&rrc_dest);
        if((rrc_dest<0) || (rrc_dest>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((rrc_dest<0) || (rrc_dest>2));

      if( (rrc_src==1) && (rrc_dest==2) )
      {
        i_shift_wf2 = i_shift_wf1;
        scale_wf2 = scale_wf1;
      }
      else if( (rrc_src==2) && (rrc_dest==1) )
      {
        i_shift_wf1 = i_shift_wf2;
        scale_wf1 = scale_wf2;
      }

      if(rrc_dest==1)
      {
        i_truncatet1 = nptst;
      }
      else if(rrc_dest==2)
      {
        i_truncatet2 = nptst;
      }

// take FFT of waveform rrc_src:

      j=1;
      nstage=0;
      do
      {
        j = j*2;
        nstage++;
      }
      while(j < nptst);

      if(j>nptst)
      {
        printf("Error - number of points in time waveform is not a power of 2;\n");
        printf("Can't proceed with compression filter generation\n");
        printf("Press any A/N key to continue:\n");
        wait_for_key_pressed();
        rrc_error=1;
      }

      rn2 = nptst / 2;
      fft_size=nptst;
      delf = nptst;
      delf = 1.0 / ( delf * delt);
      rnp = nptst;


// set up sin_array[],cos_array[] for FFT calculation
      for(i=0;i < (nptst / 2);i++)
      { /* setup trig arrays for FFT */
        cos_array[i] = cosl(i * pi / rn2);
        sin_array[i] = -sinl(i * pi / rn2);
      }; /* end setup trig arrays for FFT procedure */

// set up input arrays for FFT
      if(rrc_src==1)
      {
        for(i=0;i<nptst;i++)
        {
          xini[i]=0.0;
          if(i>=i_truncatet1)
          {
            xinr[i] = 0.0;
          }
          else
          {
            xinr[i] = y1a[i];
          }
        }
      }
      else
      {
        for(i=0;i<nptst;i++)
        {
          xini[i]=0.0;
          if(i>=i_truncatet2)
          {
            xinr[i] = 0.0;
          }
          else
          {
            xinr[i] = y2a[i];
          }
        }
      }

// calculate forward FFT with normalization
      fft(0,&fft_size,&nstage,xinr,xini,fftr,ffti,cos_array,sin_array,
      &max_mag);

      if( (use_lpf_rrc>0) && (rrc_lpf_type==2) )
      { // (use_lpf_rrc>0) && (rrc_lpf_type==2)
        // minimum phase digital filter

        for(i=0;i<nptst;i++)
        { // i-loop
          if(i <= (nptst/2))
          {
            freq = i;
          }
          else
          {
            freq = i - nptst;
          }
          freq = freq * delf_minp;
          abs_freq = fabsl(freq);
          ratio = abs_freq / f0_lpf;
          ratio_n = 1.0;

          for( j = 1; j <= n_lpf; j++)
          {
            ratio_n = ratio_n * ratio;
          }
          xinr[i] = (1.0 / (1.0 + ratio_n));
          xini[i] = 0.0;
        } // i-loop
          calc_minp(xinr,xini,lpfr,lpfi);
        // minimum phase digital filter
      } // (use_lpf_rrc>0) && (rrc_lpf_type==2)

      if( (use_lpf_rrc>0) && (rrc_lpf_type==1) )
      { // Butterworth lpf

        calculate_butterworth_lpf(n_lpf,f0_lpf,lpfr,lpfi);

      } // Butterworth lpf

      for(i=0;i<nptst;i++)
      { // i-loop
        if(use_lpf_rrc>0)
        { // use_lpf_rrc>0

          if(rrc_lpf_type==0)
          { // rrc_lpf_type==0
            if(i <= (nptst/2))
            {
              freq = i;
            }
            else
            {
              freq = i - nptst;
            }
            freq = freq * delf_minp;
            abs_freq = fabsl(freq);
            ratio = abs_freq / f0_lpf;
            ratio_n = 1.0;

            for( j = 1; j <= n_lpf; j++)
            {
              ratio_n = ratio_n * ratio;
            }
            lpf_valr = (1.0 / (1.0 + ratio_n));
            lpf_vali = 0.0;
          } // rrc_lpf_type==0
          else if( (rrc_lpf_type==1) || (rrc_lpf_type==2) )
          {
            lpf_valr = lpfr[i];
            lpf_vali = lpfi[i];
          }
        } // use_lpf_rrc>0
        else
        {
          lpf_valr = 1.0;
          lpf_vali = 0.0;
        };
        prodr = fftr[i];
        xinr[i] = (prodr*lpf_valr) - (ffti[i]*lpf_vali);
        xini[i] = (prodr*lpf_vali) + (ffti[i]*lpf_valr);
      } // i-loop

// calculate reverse FFT to obtain waveform with applied lpf:
      fft(1,&fft_size,&nstage,xinr,xini,fftr,ffti,cos_array,sin_array,
      &max_mag);

// Check for imaginary part
      imag_err=0;
      for(i=0;i<nptst;i++)
      { // i-loop
        if(rrc_dest==1)
        {
          y1a[i] = fftr[i];
        }
        else
        {
          y2a[i] = fftr[i];
        }
        if(fabsl(ffti[i]) > SMALL_NUMBER_RRC)
        {
          imag_err=1;
        }
      } // i-loop
      if(imag_err>0)
      {
        printf("%s%d%s","Warning - imaginary part in waveform after applying lpf",rrc_dest,"\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      }
      else
      {
        printf("%s%d%s%d%s","lpf was applied to waveform ",rrc_src," and result stored in waveform ",rrc_dest,"\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      }

    } // 'A'



    if( (my_toupper(rrc_ascii) == 'B') && (use_lpf_rrc>0) )
    { // 'B'
      rrc_error = 0;
      printf("Enter waveform to apply inverse lpf (1 or 2):\n");
      do
      {
        get_integer(&rrc_src);
        if((rrc_src<0) || (rrc_src>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((rrc_src<0) || (rrc_src>2));

      printf("Enter destination for waveform after applying inverse lpf (1 or 2):\n");
      do
      {
        get_integer(&rrc_dest);
        if((rrc_dest<0) || (rrc_dest>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((rrc_dest<0) || (rrc_dest>2));

      if( (rrc_src==1) && (rrc_dest==2) )
      {
        i_shift_wf2 = i_shift_wf1;
        scale_wf2 = scale_wf1;
      }
      else if( (rrc_src==2) && (rrc_dest==1) )
      {
        i_shift_wf1 = i_shift_wf2;
        scale_wf1 = scale_wf2;
      }

      if(rrc_dest==1)
      {
        i_truncatet1 = nptst;
      }
      else if(rrc_dest==2)
      {
        i_truncatet2 = nptst;
      }

// take FFT of waveform rrc_src:

      j=1;
      nstage=0;
      do
      {
        j = j*2;
        nstage++;
      }
      while(j < nptst);

      if(j>nptst)
      {
        printf("Error - number of points in time waveform is not a power of 2;\n");
        printf("Can't proceed with compression filter generation\n");
        printf("Press any A/N key to continue:\n");
        wait_for_key_pressed();
        rrc_error=1;
      }

      rn2 = nptst / 2;
      fft_size=nptst;
      delf = nptst;
      delf = 1.0 / ( delf * delt);
      rnp = nptst;


// set up sin_array[],cos_array[] for FFT calculation
      for(i=0;i < (nptst / 2);i++)
      { /* setup trig arrays for FFT */
        cos_array[i] = cosl(i * pi / rn2);
        sin_array[i] = -sinl(i * pi / rn2);
      }; /* end setup trig arrays for FFT procedure */

// set up input arrays for FFT
      if(rrc_src==1)
      {
        for(i=0;i<nptst;i++)
        {
          xini[i]=0.0;
          if(i>=i_truncatet1)
          {
            xinr[i] = 0.0;
          }
          else
          {
            xinr[i] = y1a[i];
          }
        }
      }
      else
      {
        for(i=0;i<nptst;i++)
        {
          xini[i]=0.0;
          if(i>=i_truncatet2)
          {
            xinr[i] = 0.0;
          }
          else
          {
            xinr[i] = y2a[i];
          }
        }
      }

// calculate forward FFT with normalization
      fft(0,&fft_size,&nstage,xinr,xini,fftr,ffti,cos_array,sin_array,
      &max_mag);

      if( (use_lpf_rrc>0) && (rrc_lpf_type==2) )
      { // (use_lpf_rrc>0) && (rrc_lpf_type==2)
        // minimum phase digital filter

        for(i=0;i<nptst;i++)
        { // i-loop
          if(i <= (nptst/2))
          {
            freq = i;
          }
          else
          {
            freq = i - nptst;
          }
          freq = freq * delf_minp;
          abs_freq = fabsl(freq);
          ratio = abs_freq / f0_lpf;
          ratio_n = 1.0;

          for( j = 1; j <= n_lpf; j++)
          {
            ratio_n = ratio_n * ratio;
          }
          xinr[i] = (1.0 / (1.0 + ratio_n));
          xini[i] = 0.0;
        } // i-loop
          calc_minp(xinr,xini,lpfr,lpfi);
        // minimum phase digital filter
      } // (use_lpf_rrc>0) && (rrc_lpf_type==2)

      if( (use_lpf_rrc>0) && (rrc_lpf_type==1) )
      { // Butterworth lpf

        calculate_butterworth_lpf(n_lpf,f0_lpf,lpfr,lpfi);

      } // Butterworth lpf


      for(i=0;i<nptst;i++)
      { // i-loop

        if(i <= (nptst/2))
        {
          freq = i;
        }
        else
        {
          freq = i - nptst;
        }
        freq = freq * delf_minp;
        abs_freq = fabsl(freq);

        if(use_lpf_rrc>0)
        { // use_lpf_rrc>0

          if(rrc_lpf_type==0)
          { // rrc_lpf_type==0
            ratio = abs_freq / f0_lpf;
            ratio_n = 1.0;

            for( j = 1; j <= n_lpf; j++)
            {
              ratio_n = ratio_n * ratio;
            }
            lpf_valr = (1.0 / (1.0 + ratio_n));
            lpf_vali = 0.0;
          } // rrc_lpf_type==0
          else if( (rrc_lpf_type==1) || (rrc_lpf_type==2) )
          {
            lpf_valr = lpfr[i];
            lpf_vali = lpfi[i];
          }
        } // use_lpf_rrc>0
        else
        {
          lpf_valr = 1.0;
          lpf_vali = 0.0;
        };


        if(rrc_lim_lpf_inv>0)
        {
          mag_rrc_lim_lpf_inv = sqrtl(lpf_valr*lpf_valr + lpf_vali*lpf_vali);
          if(abs_freq <= fmax_rrc_lim_lpf_inv)
          { 
            save_mag_rrc_lim_lpf_inv = mag_rrc_lim_lpf_inv;
          }
          else
          {
            lpf_valr *= save_mag_rrc_lim_lpf_inv/mag_rrc_lim_lpf_inv;
            lpf_vali *= save_mag_rrc_lim_lpf_inv/mag_rrc_lim_lpf_inv;
          }
        }

        denom_sq = lpf_valr*lpf_valr + lpf_vali*lpf_vali;
        prodr = fftr[i];
        xinr[i] = (prodr*lpf_valr + ffti[i]*lpf_vali)/denom_sq;
        xini[i] = (ffti[i]*lpf_valr - prodr*lpf_vali)/denom_sq;
      } // i-loop

// calculate reverse FFT to obtain waveform with applied lpf:
      fft(1,&fft_size,&nstage,xinr,xini,fftr,ffti,cos_array,sin_array,
      &max_mag);

// Check for imaginary part
      imag_err=0;
      for(i=0;i<nptst;i++)
      { // i-loop
        if(rrc_dest==1)
        {
          y1a[i] = fftr[i];
        }
        else
        {
          y2a[i] = fftr[i];
        }
        if(fabsl(ffti[i]) > SMALL_NUMBER_RRC)
        {
          imag_err=1;
        }
      } // i-loop
      if(imag_err>0)
      {
        printf("%s%d%s","Warning - imaginary part in waveform after applying inverse lpf",rrc_dest,"\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      }
      else
      {
        printf("%s%d%s%d%s","Inverse lpf was applied to waveform ",rrc_src," and result stored in waveform ",rrc_dest,"\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      }

    } // 'B'

    if( (toupper(rrc_ascii) == 'Z') && (rrc_filt>0) )
    { // 'Z'
      if(rrc_epzc_enable==0)
      {
        rrc_epzc_enable = 1;
      }
      else
      {
        rrc_epzc_enable = 0;
      }
    } // 'Z'

    if( (my_toupper(rrc_ascii) == 'C') && (rrc_filt>0) )
    { // 'C'
      rrc_error = 0;
      printf("Enter waveform to compress (1 or 2):\n");
      do
      {
        get_integer(&rrc_src);
        if((rrc_src<0) || (rrc_src>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((rrc_src<0) || (rrc_src>2));

      printf("Enter destination for compressed waveform (1 or 2):\n");
      do
      {
        get_integer(&rrc_dest);
        if((rrc_dest<0) || (rrc_dest>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((rrc_dest<0) || (rrc_dest>2));

      if( (rrc_src==1) && (rrc_dest==2) )
      {
        i_shift_wf2 = i_shift_wf1;
        scale_wf2 = scale_wf1;
      }
      else if( (rrc_src==2) && (rrc_dest==1) )
      {
        i_shift_wf1 = i_shift_wf2;
        scale_wf1 = scale_wf2;
      }

      if(rrc_dest==1)
      {
        i_truncatet1 = nptst;
      }
      else if(rrc_dest==2)
      {
        i_truncatet2 = nptst;
      }

// take FFT of waveform rrc_src:

      j=1;
      nstage=0;
      do
      {
        j = j*2;
        nstage++;
      }
      while(j < nptst);

      if(j>nptst)
      {
        printf("Error - number of points in time waveform is not a power of 2;\n");
        printf("Can't proceed with compression filter generation\n");
        printf("Press any A/N key to continue:\n");
        wait_for_key_pressed();
        rrc_error=1;
      }

      rn2 = nptst / 2;
      fft_size=nptst;
      delf = nptst;
      delf = 1.0 / ( delf * delt);
      rnp = nptst;

// set up sin_array[],cos_array[] for FFT calculation
      for(i=0;i < (nptst / 2);i++)
      { /* setup trig arrays for FFT */
        cos_array[i] = cosl(i * pi / rn2);
        sin_array[i] = -sinl(i * pi / rn2);
      }; /* end setup trig arrays for FFT procedure */

// set up input arrays for FFT
      if(rrc_src==1)
      {
        for(i=0;i<nptst;i++)
        {
          xini[i]=0.0;
          if(i>=i_truncatet1)
          {
            xinr[i] = 0.0;
          }
          else
          {
            xinr[i] = y1a[i];
          }
        }
      }
      else
      {
        for(i=0;i<nptst;i++)
        {
          xini[i]=0.0;
          if(i>=i_truncatet2)
          {
            xinr[i] = 0.0;
          }
          else
          {
            xinr[i] = y2a[i];
          }
        }
      }

// calculate forward FFT with normalization
      fft(0,&fft_size,&nstage,xinr,xini,fftr,ffti,cos_array,sin_array,
      &max_mag);


      if( (use_lpf_rrc>0) && (rrc_lpf_type==2) )
      { // (use_lpf_rrc>0) && (rrc_lpf_type==2)
        // minimum phase digital filter

        for(i=0;i<nptst;i++)
        { // i-loop
          if(i <= (nptst/2))
          {
            freq = i;
          }
          else
          {
            freq = i - nptst;
          }
          freq = freq * delf_minp;
          abs_freq = fabsl(freq);
          ratio = abs_freq / f0_lpf;
          ratio_n = 1.0;

          for( j = 1; j <= n_lpf; j++)
          {
            ratio_n = ratio_n * ratio;
          }
          xinr[i] = (1.0 / (1.0 + ratio_n));
          xini[i] = 0.0;
        } // i-loop
          calc_minp(xinr,xini,lpfr,lpfi);
        // minimum phase digital filter
      } // (use_lpf_rrc>0) && (rrc_lpf_type==2)


      if( (use_lpf_rrc>0) && (rrc_lpf_type==1) )
      { // Butterworth lpf

        calculate_butterworth_lpf(n_lpf,f0_lpf,lpfr,lpfi);

      } // Butterworth lpf

// apply compression filter (and optionally lpf):


      for(i=0;i<nptst;i++)
      { // i-loop
        if(use_lpf_rrc>0)
        { // use_lpf_rrc>0

          if(rrc_lpf_type==0)
          { // rrc_lpf_type==0
            if(i <= (nptst/2))
            {
              freq = i;
            }
            else
            {
              freq = i - nptst;
            }
            freq = freq * delf_minp;
            abs_freq = fabsl(freq);
            ratio = abs_freq / f0_lpf;
            ratio_n = 1.0;

            for( j = 1; j <= n_lpf; j++)
            {
              ratio_n = ratio_n * ratio;
            }
            lpf_valr = (1.0 / (1.0 + ratio_n));
            lpf_vali = 0.0;
          } // rrc_lpf_type==0
          else if( (rrc_lpf_type==1) || (rrc_lpf_type==2) )
          {
            lpf_valr = lpfr[i];
            lpf_vali = lpfi[i];
          }
        } // use_lpf_rrc>0
        else
        {
          lpf_valr = 1.0;
          lpf_vali = 0.0;
        };
        xinr[i] = (fftr[i]*Re_rrc_filt[i]) - (ffti[i]*Im_rrc_filt[i]);
        xini[i] = (fftr[i]*Im_rrc_filt[i]) + (Re_rrc_filt[i]*ffti[i]);
        prodr = xinr[i];
        xinr[i] = (prodr*lpf_valr) - (xini[i]*lpf_vali);
        xini[i] = (prodr*lpf_vali) + (xini[i]*lpf_valr);
      } // i-loop

// calculate reverse FFT to obtain compressed waveform:
      fft(1,&fft_size,&nstage,xinr,xini,fftr,ffti,cos_array,sin_array,
      &max_mag);

// Check for imaginary part
      imag_err=0;
      for(i=0;i<nptst;i++)
      { // i-loop
        if(rrc_dest==1)
        {
          y1a[i] = fftr[i];
        }
        else
        {
          y2a[i] = fftr[i];
        }
        if(fabsl(ffti[i]) > SMALL_NUMBER_RRC)
        {
          imag_err=1;
        }
      } // i-loop
      if(imag_err>0)
      {
        printf("%s%d%s","Warning - imaginary part in compressed waveform ",rrc_dest,"\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      }
      else
      {
        printf("%s%d%s%d%s","Waveform ",rrc_src," was compressed to waveform ",rrc_dest,"\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      }

    } // 'C'


    if( (my_toupper(rrc_ascii) == 'D') && (rrc_filt>0) && (n1_rrc>0) && (n2_rrc>0) )
    { // 'D'
      rrc_error = 0;
      printf("Enter waveform to de-compress (1 or 2):\n");
      do
      {
        get_integer(&rrc_src);
        if((rrc_src<0) || (rrc_src>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((rrc_src<0) || (rrc_src>2));

      printf("Enter destination for de-compressed waveform (1 or 2):\n");
      do
      {
        get_integer(&rrc_dest);
        if((rrc_dest<0) || (rrc_dest>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((rrc_dest<0) || (rrc_dest>2));

      if( (rrc_src==1) && (rrc_dest==2) )
      {
        i_shift_wf2 = i_shift_wf1;
        scale_wf2 = scale_wf1;
      }
      else if( (rrc_src==2) && (rrc_dest==1) )
      {
        i_shift_wf1 = i_shift_wf2;
        scale_wf1 = scale_wf2;
      }

      if(rrc_dest==1)
      {
        i_truncatet1 = nptst;
      }
      else if(rrc_dest==2)
      {
        i_truncatet2 = nptst;
      }

// take FFT of waveform rrc_src:

      j=1;
      nstage=0;
      do
      {
        j = j*2;
        nstage++;
      }
      while(j < nptst);

      if(j>nptst)
      {
        printf("Error - number of points in time waveform is not a power of 2;\n");
        printf("Can't proceed with compression filter generation\n");
        printf("Press any A/N key to continue:\n");
        wait_for_key_pressed();
        rrc_error=1;
      }

      rn2 = nptst / 2;
      fft_size=nptst;
      delf = nptst;
      delf = 1.0 / ( delf * delt);
      rnp = nptst;
      delf_minp = nptst;
      delf_minp = 1.0 / ( delf_minp * delt);

// set up sin_array[],cos_array[] for FFT calculation
      for(i=0;i < (nptst / 2);i++)
      { /* setup trig arrays for FFT */
        cos_array[i] = cosl(i * pi / rn2);
        sin_array[i] = -sinl(i * pi / rn2);
      }; /* end setup trig arrays for FFT procedure */

// set up input arrays for FFT
      if(rrc_src==1)
      { //rrc_src==1
        if(rrc_int_type==0)
        { // rrc_int_type==0
          rrc_epzc_value = 0.0;
          if(rrc_epzc_enable>0)
          {
            rrc_epzc_value = 0.5*(y1a[n1_rrc-1] + y1a[n2_rrc-1]);
          }
          for(i=0;i<nptst;i++)
          { // i-loop
            xini[i]=0.0;
            if( (i >= (n1_rrc-1)) && (i <= (n2_rrc-1)) )
            {
              xinr[i] = y1a[i] - rrc_epzc_value;
            }
            else
            {
              xinr[i] = 0.0;
            }
          } // i-loop
        } // rrc_int_type==0
        else if(rrc_int_type==1)
        { // rrc_int_type==1
          rrc_epzc_value = 0.0;
          if(rrc_epzc_enable>0)
          {
            if(n1_rrc>1)
            {
              rrc_epzc_value += 0.5*y1a[n1_rrc-2];
            }
            else
            {
              rrc_epzc_value += 0.5*y1a[nptst-1];
            } 
            if(n2_rrc<nptst)
            {
              rrc_epzc_value += 0.5*y1a[n2_rrc];
            }
            else
            {
              rrc_epzc_value += 0.5*y1a[0];
            }
          }
          for(i=0;i<nptst;i++)
          { // i-loop
            xini[i]=0.0;
            if( (i < (n1_rrc-1)) || (i > (n2_rrc-1)) )
            {
              xinr[i] = y1a[i] - rrc_epzc_value;
            }
            else
            {
              xinr[i] = 0.0;
            }
          } // i-loop
        } // rrc_int_type==1
      } // rrc_src==1
      else if(rrc_src==2)
      { //rrc_src==2
        if(rrc_int_type==0)
        { // rrc_int_type==0
          if(rrc_epzc_enable>0)
          {
            rrc_epzc_value = 0.5*(y2a[n1_rrc-1] + y2a[n2_rrc-1]);
          }
          for(i=0;i<nptst;i++)
          { // i-loop
            xini[i]=0.0;
            if( (i >= (n1_rrc-1)) && (i <= (n2_rrc-1)) )
            {
              xinr[i] = y2a[i] - rrc_epzc_value;
            }
            else
            {
              xinr[i] = 0.0;
            }
          } // i-loop
        } // rrc_int_type==0
        else if(rrc_int_type==1)
        { // rrc_int_type==1
          rrc_epzc_value = 0.0;
          if(rrc_epzc_enable>0)
          {
            if(n1_rrc>1)
            {
              rrc_epzc_value += 0.5*y2a[n1_rrc-2];
            }
            else
            {
              rrc_epzc_value += 0.5*y2a[nptst-1];
            }
            if(n2_rrc<nptst)
            {
              rrc_epzc_value += 0.5*y2a[n2_rrc];
            }
            else
            {
              rrc_epzc_value += 0.5*y2a[0];
            }
          }
          for(i=0;i<nptst;i++)
          { // i-loop
            xini[i]=0.0;
            if( (i < (n1_rrc-1)) || (i > (n2_rrc-1)) )
            {
              xinr[i] = y2a[i] - rrc_epzc_value;
            }
            else
            {
              xinr[i] = 0.0;
            }
          } // i-loop
        } // rrc_int_type==1
      } // rrc_src==2

// calculate forward FFT with normalization
      fft(0,&fft_size,&nstage,xinr,xini,fftr,ffti,cos_array,sin_array,
      &max_mag);

// apply de-compression filter (and optionally lpf):


      save_ratio = 0.0;
      if( (use_lpf_rrc>0) && (rrc_lpf_type==2) )
      { // (use_lpf_rrc>0) && (rrc_lpf_type==2)
        // minimum phase digital filter

        for(i=0;i<nptst;i++)
        { // i-loop
          if(i <= (nptst/2))
          {
            freq = i;
          }
          else
          {
            freq = i - nptst;
          }
          freq = freq * delf_minp;
          abs_freq = fabsl(freq);
          ratio = abs_freq / f0_lpf;
          ratio_n = 1.0;

          for( j = 1; j <= n_lpf; j++)
          {
            ratio_n = ratio_n * ratio;
          }

          if( (abs_freq <= fmax_rrc_decompress) || (enable_fmax_rrc_decompress==0) )
          {
            save_ratio = ratio_n;
            xinr[i] = (1.0 / (1.0 + ratio_n));
            xini[i] = 0.0;
          }
          else
          {
            xinr[i] = (1.0 / (1.0 + save_ratio));
            xini[i] = 0.0;
          }

        } // i-loop

          calc_minp(xinr,xini,lpfr,lpfi);

        // minimum phase digital filter
      } // (use_lpf_rrc>0) && (rrc_lpf_type==2)


      if( (use_lpf_rrc>0) && (rrc_lpf_type==1) )
      { // Butterworth lpf

        calculate_butterworth_lpf(n_lpf,f0_lpf,lpfr,lpfi);

      } // Butterworth lpf

      xinr[0] = 0.0;
      xini[0] = 0.0;
      for(i=1;i<nptst;i++)
      { // i-loop
        if(use_lpf_rrc>0)
        { // use_lpf_rrc>0

          if(rrc_lpf_type==0)
          { // rrc_lpf_type==0
            if(i <= (nptst/2))
            {
              freq = i;
            }
            else
            {
              freq = i - nptst;
            }
            freq = freq * delf_minp;
            abs_freq = fabsl(freq);
            ratio = abs_freq / f0_lpf;
            ratio_n = 1.0;

            for( j = 1; j <= n_lpf; j++)
            {
              ratio_n = ratio_n * ratio;
            }

            if( (abs_freq <= fmax_rrc_decompress) || (enable_fmax_rrc_decompress==0) )

            {
              save_ratio = ratio_n;
              lpf_valr = (1.0 / (1.0 + ratio_n));
              lpf_vali = 0.0;
            }
            else
            {
              lpf_valr = (1.0 / (1.0 + save_ratio));
              lpf_vali = 0.0;
            }
          } // rrc_lpf_type==0
          else if( (rrc_lpf_type==1) || (rrc_lpf_type==2) )
          {
            lpf_valr = lpfr[i];
            lpf_vali = lpfi[i];
          }
        } // use_lpf_rrc>0
        else
        {
          lpf_valr = 1.0;
          lpf_vali = 0.0;
        };
        denom_sq = (Re_rrc_filt[i]*Re_rrc_filt[i]) + (Im_rrc_filt[i]*Im_rrc_filt[i]);
        xinr[i] = ( (fftr[i]*Re_rrc_filt[i]) + (ffti[i]*Im_rrc_filt[i]) ) / denom_sq;
        xini[i] = ( (ffti[i]*Re_rrc_filt[i]) - (fftr[i]*Im_rrc_filt[i]) ) / denom_sq;
        denom_sq = (lpf_valr*lpf_valr) + (lpf_vali*lpf_vali);
        prodr = xinr[i];
        xinr[i] = ( (prodr*lpf_valr) + (xini[i]*lpf_vali) ) / denom_sq;
        xini[i] = ( (xini[i]*lpf_valr) - (prodr*lpf_vali) ) / denom_sq;
      } // i-loop

// calculate reverse FFT to obtain de-compressed waveform:
      fft(1,&fft_size,&nstage,xinr,xini,fftr,ffti,cos_array,sin_array,
      &max_mag);

// Check for imaginary part
      imag_err=0;
      for(i=0;i<nptst;i++)
      { // i-loop
        if(rrc_dest==1)
        {
          y1a[i] = fftr[i];
        }
        else
        {
          y2a[i] = fftr[i];
        }
        if(fabsl(ffti[i]) > SMALL_NUMBER_RRC)
        {
          imag_err=1;
        }
      } // i-loop
      if(imag_err>0)
      {
        printf("%s%d%s","Warning - imaginary part in de-compressed waveform ",rrc_dest,"\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      }
      else
      {
        printf("%s%d%s%d%s","Waveform ",rrc_src," was de-compressed to waveform ",rrc_dest,"\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      }

    } // 'D'

    if(my_toupper(rrc_ascii) == 'G')
    { // 'G'
      rrc_error = 0;
      printf("Enter waveform number to generate filter (1 or 2):\n");
      do
      {
        get_integer(&rrc_filt);
        if((rrc_filt<0) || (rrc_filt>2))
        {
          printf("Error - enter again:\n");
        }
      }
      while((rrc_filt<0) || (rrc_filt>2));

      rn2 = nptst / 2;
      fft_size=nptst;
      delf = nptst;
      delf = 1.0 / ( delf * delt);
      rnp = nptst;

      j=1;
      nstage=0;
      do
      {
        j = j*2;
        nstage++;
      }
      while(j < nptst);

      if(j>nptst)
      {
        printf("Error - number of points in time waveform is not a power of 2;\n");
        printf("Can't proceed with compression filter generation\n");
        printf("Press any A/N key to continue:\n");
        wait_for_key_pressed();
        rrc_error=1;
      }

      if(rrc_error==0)
      { // rrc_error==0

// set up sin_array[],cos_array[] for FFT calculation
        for(i=0;i<= (nptst / 2) - 1;i++)
        { /* setup trig arrays for FFT */
          cos_array[i] = cosl(i * pi / rn2);
          sin_array[i] = -sinl(i * pi / rn2);
        }; /* end setup trig arrays for FFT procedure */

// set up input arrays for FFT

        if(rrc_filt==1)
        {
          for(i=0;i<nptst;i++)
          {
            xini[i]=0.0;
            xinr[i]=y1a[i];
          }
        }
        else
        {
          for(i=0;i<nptst;i++)
          {
            xini[i]=0.0;
            xinr[i]=y2a[i];
          }
        }

// calculate forward FFT with normalization
        fft(0,&fft_size,&nstage,xinr,xini,Re_rrc_filt,Im_rrc_filt,cos_array,sin_array,
        &max_mag);
// calculate the compression filter:
        i_trans_fmax_compress = 0;
        for(i=0;i<nptst;i++)
        { // i-loop
          if(i <= (nptst/2))
          {
            freq = i;
          }
          else
          {
            freq = i - nptst;
          }
          freq = freq * delf;
          abs_freq = fabsl(freq);
          denom_sq = (Re_rrc_filt[i]*Re_rrc_filt[i]) + (Im_rrc_filt[i]*Im_rrc_filt[i]);
          Re_rrc_filt[i] = Re_rrc_filt[i]/denom_sq/rnp;
          Im_rrc_filt[i] = -Im_rrc_filt[i]/denom_sq/rnp;
          if( (enable_fmax_rrc_compress>0) && (abs_freq>fmax_rrc_compress) )
          {

            if(i_trans_fmax_compress==0)
            { // i_trans_fmax_compress==0
             i_trans_fmax_compress = 1;
             save_mag_fmax_compress = sqrtl( (Re_rrc_filt[i-1]*Re_rrc_filt[i-1]) + (Im_rrc_filt[i-1]*Im_rrc_filt[i-1]) );
             if(i_constant_phase_slope>0)
             { // i_constant_phase_slope>0
               if((i-1) >= n_del_om_fmax_compress)
               {
                 del_om_fmax_compress = 0.0;
                 for(j=i-n_del_om_fmax_compress-1;j<(i-1);j++)
                 { // j-loop
                   r1_fc = Re_rrc_filt[j];
                   i1_fc = Im_rrc_filt[j];
                   om1_fmax_compress = atanl(i1_fc/r1_fc);
                   if(r1_fc<0.0) om1_fmax_compress += pi;
                   r2_fc = Re_rrc_filt[j+1];
                   i2_fc = Im_rrc_filt[j+1];
                   om2_fmax_compress = atanl(i2_fc/r2_fc);
                   if(r2_fc<0.0) om2_fmax_compress += pi;
                   om21_fmax_compress = om2_fmax_compress - om1_fmax_compress;
// handle case where phase wraps around negatively:
                   if(om21_fmax_compress<pi) om21_fmax_compress += 2.0*pi;
// handle case where phase wraps around positively:
                   if(om21_fmax_compress>pi) om21_fmax_compress -= 2.0*pi;
                   del_om_fmax_compress += om21_fmax_compress;
                 } // j-loop
                 del_om_fmax_compress /= n_del_om_fmax_compress;
                 i_save_fmax_rrc_compress = i-1;
                 om_save_fmax_rrc_compress = atanl(Im_rrc_filt[i-1]/Re_rrc_filt[i-1]);
                 if(Re_rrc_filt[i-1] < 0.0) om_save_fmax_rrc_compress += pi;
// calculate total phase at folding frequency and adjust del_om_fmax_compress so
// the phase there is an integer multiple of pi:
                 om_tot_fmax_rrc_compress = ((nptst/2)-i+1);
                 om_tot_fmax_rrc_compress = (om_tot_fmax_rrc_compress*del_om_fmax_compress) +
                   om_save_fmax_rrc_compress;
                 n_tot_fmax_rrc_compress = Round_long(om_tot_fmax_rrc_compress/pi);
                 if( (n_tot_fmax_rrc_compress/2)*2 == n_tot_fmax_rrc_compress)
                 {
                   sign_om_tot_fmax_rrc_compress = 1;
                 }
                 else
                 {
                   sign_om_tot_fmax_rrc_compress = -1;
                 }
                 rn_tot_fmax_rrc_compress = n_tot_fmax_rrc_compress;
                 del_om_fmax_compress *= pi/om_tot_fmax_rrc_compress*rn_tot_fmax_rrc_compress;
               }
             } // i_constant_phase_slope>0
            } // i_trans_fmax_compress==0

            if(i < (nptst/2))
            {
              if(i_constant_phase_slope>0)
              {
                arg_fmax_rrc_compress = (i - i_save_fmax_rrc_compress)*del_om_fmax_compress;
                arg_fmax_rrc_compress = arg_fmax_rrc_compress +  om_save_fmax_rrc_compress;
                Re_rrc_filt[i] = save_mag_fmax_compress*cosl(arg_fmax_rrc_compress);
                Im_rrc_filt[i] = save_mag_fmax_compress*sinl(arg_fmax_rrc_compress);
              }
              else
              {
                mag_fmax_compress = sqrtl((Re_rrc_filt[i]*Re_rrc_filt[i]) + (Im_rrc_filt[i]*Im_rrc_filt[i]) );
                Re_rrc_filt[i] *= save_mag_fmax_compress/mag_fmax_compress;
                Im_rrc_filt[i] *= save_mag_fmax_compress/mag_fmax_compress;
              }
            }
            else if(i == (nptst/2))
            { // i == nptst/2
              if(i_constant_phase_slope>0)
              { // i_constant_phase_slope>0
                if(sign_om_tot_fmax_rrc_compress==1)
                {
                  Re_rrc_filt[i] = save_mag_fmax_compress;
                }
                else
                {
                  Re_rrc_filt[i] = -save_mag_fmax_compress;
                }
                Im_rrc_filt[i] = 0.0;
              } // i_constant_phase_slope>0
              else
              {
                mag_fmax_compress = sqrtl((Re_rrc_filt[i]*Re_rrc_filt[i]) + (Im_rrc_filt[i]*Im_rrc_filt[i]) );
                Re_rrc_filt[i] *= save_mag_fmax_compress/mag_fmax_compress;
                Im_rrc_filt[i] *= save_mag_fmax_compress/mag_fmax_compress;
              }
            } // i == nptst/2
            else if(i > (nptst/2))
            {
              Re_rrc_filt[i] = Re_rrc_filt[nptst - i];
              Im_rrc_filt[i] = -Im_rrc_filt[nptst - i];
            }
          }
        } // i-loop
        if(minp_option == 1)
        { // minp_option == 1
          calc_minp(Re_rrc_filt,Im_rrc_filt,fftr,ffti);
          for(i=0;i<nptst;i++)
          {
            Re_rrc_filt[i] = fftr[i];
            Im_rrc_filt[i] = ffti[i];
          }
        } // minp_option == 1

        printf("Compression filter has been generated\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      } // rrc_error==0
      else
      {
        printf("Error -- compression filter was not generated\n");
        printf("Press any A/N key to continue\n");
        wait_for_key_pressed();
      }
    } // 'G'

 if(my_toupper(rrc_ascii) == 'R')
    { // 'R'
      rrc_error = 0;
      read_rrc_filt(&rrc_filt_filename[0],&Re_rrc_filt[0],&Im_rrc_filt[0],
        &delf_read_rrc,&num_read_rrc);
      if(rrc_error>0)
      {
        printf("Error reading compression filter file, operation not completed\n");
      }
      else
      {
        printf("File was successfully read\n");
        rrc_filt = 3; // denotes rrc_filter read from file
      }
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();

    } // 'R'
    
    if((my_toupper(rrc_ascii) == 'S') && (rrc_filt>0))
    { // 'S'
      rrc_error = 0;
      delf = nptst;
      delf = 1.0 / ( delf * delt);
      save_rrc_filter(&rrc_filt_save_filename[0],&Re_rrc_filt[0],&Im_rrc_filt[0],delf,nptst);

      if(rrc_error>0)
      {
        printf("Error saving compression filter to a file, operation not completed\n");
      }
      else
      {
        printf("Filter was successfully saved\n");
      }
      printf("Press any A/N key to continue\n");
      wait_for_key_pressed();

    } // 'S'

    if(my_toupper(rrc_ascii) == 'E')
    { // 'E'
      if(enable_fmax_rrc_compress==1)
      {
        enable_fmax_rrc_compress=0;
      }
      else if(enable_fmax_rrc_compress==0)
      {
        enable_fmax_rrc_compress=1;
      }
      if(fmax_rrc_compress==0.0)
      {
          printf("Enter fmax for compression file generation:\n");
          check_n_del_om = sampling_rate / nptst;
          check_n_del_om *= n_del_om_fmax_compress;
          do
          {
            get_long_double(&fmax_rrc_compress);
            if(fmax_rrc_compress<=0.0)
            {
              printf("Error - enter again:\n");
            }
            else if(check_n_del_om > fmax_rrc_compress)
            {
              printf("Value too small for number of phase average points - enter again:\n");
            }
          }
//          while(fmax_rrc_compress<=0.0);
          while( (fmax_rrc_compress<=0.0) || (check_n_del_om > fmax_rrc_compress) );
      }
    } // 'E'


    if( (my_toupper(rrc_ascii) == 'F') && (rrc_filt>0) )
    { // 'F'
      if(enable_fmax_rrc_decompress==1)
      {
        enable_fmax_rrc_decompress=0;
      }
      else if(enable_fmax_rrc_decompress==0)
      {
        enable_fmax_rrc_decompress=1;
      }
      if( (enable_fmax_rrc_decompress==1) && (use_lpf_rrc>0) && (rrc_lpf_type==1) )
      {
        enable_fmax_rrc_decompress=0;
        printf("Error -- fmax for de-compression is not implemented for Butterworth filters\n");
        printf("Press any A/N key to continue:\n");
        wait_for_key_pressed();
      }
//      if(fmax_rrc_decompress==0.0)
      if( (fmax_rrc_decompress==0.0) && (enable_fmax_rrc_decompress>0) )
      {
          printf("Enter fmax for de-compression:\n");
            get_long_double(&fmax_rrc_decompress);
      }
    } // 'F'

    if(my_toupper(rrc_ascii) == 'N')
    { // 'N'
          check_n_del_om = sampling_rate / nptst;
          check_n_del_om *= n_del_om_fmax_compress;
          printf("Enter fmax for compression filter generation:\n");
          do
          {
            get_long_double(&fmax_rrc_compress);
            if(fmax_rrc_compress<=0.0)
            {
              printf("Error - enter again:\n");
            }
            else if(check_n_del_om > fmax_rrc_compress)
            {
              printf("fmax too small for number of phase average points - enter again:\n");
            }
          }
//          while(fmax_rrc_compress<=0.0);
          while( (fmax_rrc_compress<=0.0) || (check_n_del_om > fmax_rrc_compress) );
    } // 'N'

    if( (my_toupper(rrc_ascii) == 'X') && (rrc_filt>0) && (enable_fmax_rrc_decompress==1) )
    { // 'X'
          printf("Enter fmax for de-compression:\n");
            get_long_double(&fmax_rrc_decompress);
    } // 'X'

    if( (my_toupper(rrc_ascii) == 'Y') && (use_lpf_rrc==1) )
    { // 'Y'
      if( (rrc_lpf_type==0) && (enable_fmax_rrc_decompress>0) )
      {
        printf("Error - fmax in de-compression not implemented for Butterworth filters\n");
        printf("Press any A/N key to continue:\n");
        wait_for_key_pressed();
      }
//      if(rrc_lpf_type==0)
      else if(rrc_lpf_type==0)
      {
        if(n_lpf<=MAX_BUTTERWORTH_ORDER)
        {
          rrc_lpf_type=1;
        }
        else
        {
          max_butterworth_order_print = MAX_BUTTERWORTH_ORDER;
          printf("%s%d%s","Error - Butterworth filters only available for orders up to ",
          max_butterworth_order_print,"\n");
          printf("Press any A/N key to continue:\n");
          wait_for_key_pressed();
        }
      }
      else
      {
        rrc_lpf_type++;
        if(rrc_lpf_type>2) rrc_lpf_type=0;
      }
    } // 'Y'

    if( (my_toupper(rrc_ascii) == 'P') && (use_lpf_rrc==1) )
    { // 'P'
          printf("Enter order of lpf (positive integer):\n");
          do
          {
            get_long_int(&n_lpf_read);
            if(n_lpf_read<0)
            {
              printf("Error - enter again:\n");
            }
          }
          while(n_lpf_read<0);

          if( (rrc_lpf_type==1) && (n_lpf_read>MAX_BUTTERWORTH_ORDER) )
          {
            max_butterworth_order_print = MAX_BUTTERWORTH_ORDER;
            printf("%s%d%s","Error - Butterworth filters only available for orders up to ",
            max_butterworth_order_print,"\n");

            printf("Press any A/N key to continue:\n");
            wait_for_key_pressed();
            n_lpf = 10;
          }
          else
          {
            n_lpf = n_lpf_read;
          }

          printf("Enter cutoff frequency f0:\n");
          do
          {
            get_long_double(&f0_lpf);
            if(f0_lpf<=0.0)
            {
              printf("Error - enter again:\n");
            }
          }
          while(f0_lpf<=0.0);
    } // 'P'

    if( (my_toupper(rrc_ascii) == 'L') )
    { // 'L'
      rrc_error = 0;
      if(use_lpf_rrc==0)
      { // use_lpf_rrc==0
        if( (n_lpf<=0) || (f0_lpf<=0.0) )
        {
          printf("Enter order of lpf (positive integer):\n");
          do
          {
            get_long_int(&n_lpf_read);
            if(n_lpf_read<0)
            {
              printf("Error - enter again:\n");
            }
          }
          while(n_lpf_read<0);

          if( (rrc_lpf_type==1) && (n_lpf_read>MAX_BUTTERWORTH_ORDER) )
          {
            max_butterworth_order_print = MAX_BUTTERWORTH_ORDER;
            printf("%s%d%s","Error - Butterworth filters only available for orders up to ",
            max_butterworth_order_print,"\n");

            printf("Press any A/N key to continue:\n");
            wait_for_key_pressed();
            n_lpf = 10;
          }
          else
          {
            n_lpf = n_lpf_read;
          }

          printf("Enter cutoff frequency f0:\n");
          do
          {
            get_long_double(&f0_lpf);
            if(f0_lpf<=0.0)
            {
              printf("Error - enter again:\n");
            }
          }
          while(f0_lpf<=0.0);
        }
        use_lpf_rrc=1;
      } // use_lpf_rrc==0
      else
      {
        use_lpf_rrc=0;
      }

    } // 'L'

    if( (my_toupper(rrc_ascii) == 'T') && (rrc_filt>0) )
    { // 'T'
      if(rrc_int_type==0)
      {
        rrc_int_type=1;
      }
      else
      {
        rrc_int_type=0;
      }
    } // 'T'


    if( (my_toupper(rrc_ascii) == 'I') && (rrc_filt>0) )
    { // 'I'
      rrc_error = 0;
      printf("Enter first point of interval (starting at 1):\n");
      do
      {
        get_long_int(&n1_rrc);
        if( (n1_rrc<1) || (n1_rrc>nptst) )
        {
          printf("Error - enter again:\n");
        }
      }
      while( (n1_rrc<1) || (n1_rrc>nptst) );

      printf("Enter last point of interval (starting at 1):\n");
      do
      {
        get_long_int(&n2_rrc);
        if( (n2_rrc<1) || (n2_rrc>nptst) || (n2_rrc<=n1_rrc) )
        {
          printf("Error - enter again:\n");
        }
      }
      while( (n2_rrc<1) || (n2_rrc>nptst) || (n2_rrc<=n1_rrc) );

    } // 'I'

  }  // my_toupper(rrc_ascii) != 'Q'
} // do-while loop
while(!quit_rrc);

};  /* end of procedure rrc_menu */
/* ---------------------------------------------------------------------- */








/* ------------------------------------------------------------------------------ */
void window_menu(void)
{


int quit_window;
char window_ascii;
long int indx_window;
long double arg1_window,arg2_window,arg3_window,arg4_window;

  quit_window = 0;

do
{
  system("cls"); // clear the console screen
  if(window_type==0)
  {
    printf("No window currently set up\n");
  }
  else if(window_type==1)
  {
    printf("%s%ld%s%ld%s"," Bartlett(linear) (",i_window_1+1,",",i_window_2+1,") set up\n");
  }
  else if(window_type==2)
  {
    printf("%s%ld%s%ld%s"," Hanning(cosine) (",i_window_1+1,",",i_window_2+1,") set up\n");
  }
  else if(window_type==3)
  {
    printf("%s%ld%s%ld%s"," Hamming(cosine-residual) (",i_window_1+1,",",i_window_2+1,") set up\n");
  }
  else if(window_type==4)
  {
    printf("%s%ld%s%ld%s"," Blackman(double cosine) (",i_window_1+1,",",i_window_2+1,") set up\n");
  }
  else if(window_type==5)
  {
    printf("%s%ld%s%ld%s"," Parzen(cubic) (",i_window_1+1,",",i_window_2+1,") set up\n");
  }
  printf("A to set up Bartlett(linear) window\n");
  printf("N to set up Hanning(cosine) window\n");
  printf("M to set up Hamming(cosine-residual) window\n");
  printf("L to set up Blackman(double cosine) window\n");
  printf("P to set up Parzen(cubic) window\n");
  if(window_type>0)printf("R to release window\n");
  printf("Q to return to time waveforms menu\n");
  printf("Enter Command :\n");

  window_ascii = getch();

  if(my_toupper(window_ascii) == 'Q') quit_window = 1;

  if(my_toupper(window_ascii) != 'Q')
  {

    if(my_toupper(window_ascii) == 'R')
    { // 'R'
      window_type=0;
    } // 'R'

    if(my_toupper(window_ascii) == 'A')
    { // 'A' (Bartlett - linear)
      printf("Enter first point, where window = 1 (integer index starting at 1):\n");
      get_long_int(&i_window_1);
      printf("Enter last point, where window reaches minimum (integer index starting at 1):\n");
      get_long_int(&i_window_2);
      i_window_1 -= 1; // to start at 0
      i_window_2 -= 1; // to start at 0
      if( (i_window_2-i_window_1+1)>MAX_WINDOW_SIZE)
      {
        printf("Error - window size is bigger than array dimension\n");
        printf("Press any A/N key to continue\n");
        window_type=0;
        ascii_code_continue = getch();
      }
      else if( (i_window_1<0) || (i_window_2<0))
      {
        printf("Error - window indices out of range\n");
        printf("Press any A/N key to continue\n");
        window_type=0;
        ascii_code_continue = getch();
      }
      else
      { // set up window
        window_type=1;
        for(indx_window=0;indx_window<(i_window_2-i_window_1+1);indx_window++)
        {
          arg1_window = indx_window;
          arg2_window = i_window_2-i_window_1;
          window_func[indx_window] = 1.0 - (arg1_window/arg2_window);
        }
      } // set up window
    } // 'A'

    if(my_toupper(window_ascii) == 'N')
    { // 'N' (Hanning - cosine)
      printf("Enter first point, where window = 1 (integer index):\n");
      get_long_int(&i_window_1);
      printf("Enter last point, where window reaches minimum (integer index):\n");
      get_long_int(&i_window_2);
      i_window_1 -= 1; // to start at 0
      i_window_2 -= 1; // to start at 0
      if( (i_window_2-i_window_1+1)>MAX_WINDOW_SIZE)
      {
        printf("Error - window size is bigger than array dimension\n");
        printf("Press any A/N key to continue\n");
        ascii_code_continue = getch();
      }
      else if( (i_window_1<0) || (i_window_2<0))
      {
        printf("Error - window indices out of range\n");
        printf("Press any A/N key to continue\n");
        window_type=0;
        ascii_code_continue = getch();
      }
      else
      { // set up window
        window_type=2;
        for(indx_window=0;indx_window<(i_window_2-i_window_1+1);indx_window++)
        {
          arg1_window = indx_window;
          arg2_window = i_window_2 - i_window_1;
          window_func[indx_window] = 0.5 + (0.5*cosl(arg1_window*pi/arg2_window));
        }
      } // set up window
    } // 'N'

    if(my_toupper(window_ascii) == 'M')
    { // 'M' (Hamming - cosine residual)
      printf("Enter first point, where window = 1 (integer index):\n");
      get_long_int(&i_window_1);
      printf("Enter last point, where window reaches minimum (integer index):\n");
      get_long_int(&i_window_2);
      i_window_1 -= 1; // to start at 0
      i_window_2 -= 1; // to start at 0
      if( (i_window_2-i_window_1+1)>MAX_WINDOW_SIZE)
      {
        printf("Error - window size is bigger than array dimension\n");
        printf("Press any A/N key to continue\n");
        window_type=0;
        ascii_code_continue = getch();
      }
      else if( (i_window_1<0) || (i_window_2<0))
      {
        printf("Error - window indices out of range\n");
        printf("Press any A/N key to continue\n");
        window_type=0;
        ascii_code_continue = getch();
      }
      else
      { // set up window
        window_type=3;
        for(indx_window=0;indx_window<(i_window_2-i_window_1+1);indx_window++)
        {
          arg1_window = indx_window;
          arg2_window = i_window_2 - i_window_1;
          window_func[indx_window] = 0.54 + (0.46*cosl(arg1_window*pi/arg2_window));
        }
      } // set up window
    } // 'M'

    if(my_toupper(window_ascii) == 'L')
    { // 'L' (Blackman - double cosine)
      printf("Enter first point, where window = 1 (integer index):\n");
      get_long_int(&i_window_1);
      printf("Enter last point, where window reaches minimum (integer index):\n");
      get_long_int(&i_window_2);
      i_window_1 -= 1; // to start at 0
      i_window_2 -= 1; // to start at 0
      if( (i_window_2-i_window_1+1)>MAX_WINDOW_SIZE)
      {
        printf("Error - window size is bigger than array dimension\n");
        printf("Press any A/N key to continue\n");
        window_type=0;
        ascii_code_continue = getch();
      }
      else if( (i_window_1<0) || (i_window_2<0))
      {
        printf("Error - window indices out of range\n");
        printf("Press any A/N key to continue\n");
        window_type=0;
        ascii_code_continue = getch();
      }
      else
      { // set up window
        window_type=4;
        for(indx_window=0;indx_window<(i_window_2-i_window_1+1);indx_window++)
        {
          arg1_window = indx_window;
          arg2_window = i_window_2 - i_window_1;
          window_func[indx_window] = 0.42 + (0.5*cosl(arg1_window*pi/arg2_window)) +
            (0.08*cosl(arg1_window*2.0*pi/arg2_window));
        }
      } // set up window
    } // 'L'

    if(my_toupper(window_ascii) == 'P')
    { // 'P' (Parzen - cubic)
      printf("Enter first point, where window = 1 (integer index):\n");
      get_long_int(&i_window_1);
      printf("Enter last point, where window reaches minimum (integer index):\n");
      get_long_int(&i_window_2);
      i_window_1 -= 1; // to start at 0
      i_window_2 -= 1; // to start at 0
      if( (i_window_2-i_window_1+1)>MAX_WINDOW_SIZE)
      {
        printf("Error - window size is bigger than array dimension\n");
        printf("Press any A/N key to continue\n");
        window_type=0;
        ascii_code_continue = getch();
      }
      else if( (i_window_1<0) || (i_window_2<0))
      {
        printf("Error - window indices out of range\n");
        printf("Press any A/N key to continue\n");
        window_type=0;
        ascii_code_continue = getch();
      }
      else
      { // set up window
        window_type=5;
        for(indx_window=0;indx_window<(i_window_2-i_window_1+1);indx_window++)
        {
          arg1_window = indx_window;
          arg2_window = i_window_2 - i_window_1;
          arg3_window = arg2_window/2.0;
          arg4_window = arg1_window/arg2_window;
          if(arg1_window<=arg3_window)
          {
            window_func[indx_window] = 1.0 - (6.0*arg4_window*arg4_window) +
              (6.0*arg4_window*arg4_window*arg4_window);
          }
          else
          {
            arg1_window = 1.0 - arg4_window;
            window_func[indx_window] = 2.0*arg1_window*arg1_window*arg1_window;
          }
        }
      } // set up window
    } // 'P'

  };  /* end of window_ascii != 'Q' */
}
while(!quit_window);

};  /* end of procedure window_menu */
/* ---------------------------------------------------------------------- */






/* -------------------------------------------------------------------- */
void read_string(FILE *input_file,char *char_str)
{

char read_ascii_code;
int i_read_string;

  if(fgets(char_str,255,input_file)==NULL) /* read string */
  {
    printf("Error in input file format\n");
    printf("Program will be terminated.\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
  };
  for(i_read_string=0;i_read_string<255;i_read_string++)
  {
    if(char_str[i_read_string]=='\n')
    {
      char_str[i_read_string]='\0';
    }
  }
  
};
/* ------------------------------------------------------------------- */





/* -------------------------------------------------------------------- */
void read_long_int(FILE *input_file,long int *longint_number)
{

char input_line[100];
char read_ascii_code;

  if(fgets(&input_line[0],100,input_file)==NULL) /* read number */
  {
    printf("Error in input file format\n");
    printf("Program will be terminated.\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
  };

  if(sscanf(&input_line[0],"%li",longint_number)<1)
  {
    printf("Error in input file format\n");
    printf("Program will be terminated.\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
  };

};
/* ------------------------------------------------------------------- */






/* -------------------------------------------------------------------- */
void read_int(FILE *input_file,int *int_number)
{

char input_line[256];
char read_ascii_code;

  if(fgets(input_line,255,input_file)==NULL) /* read number */
  {
    printf("Error in input file format\n");
    printf("Program will be terminated.\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
  };

  if(sscanf(&input_line[0],"%i",int_number)<1)
  {
    printf("Error in input file format\n");
    printf("Program will be terminated.\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
  };

};
/* ------------------------------------------------------------------- */





/* -------------------------------------------------------------------- */
void read_long_double(FILE *input_file,long double *long_double_number)
{

char input_line[100];
char read_ascii_char;

  if(fgets(&input_line[0],100,input_file)==NULL) /* read number */
  {
    printf("Error in input file format\n");
    printf("Program will be terminated.\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
  };

  if(sscanf(&input_line[0],"%Le",long_double_number)<1)
  {
    printf("Error in input file format\n");
    printf("Program will be terminated.\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
  };

};
/* -------------------------------------------------------------------- */






/* -------------------------------------------------------------------- */
void read_float(FILE *input_file,float *float_number)
{

char input_line[100];
char read_ascii_char;

  if(fgets(&input_line[0],100,input_file)==NULL) /* read number */
  {
    printf("Error in input file format\n");
    printf("Program will be terminated.\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
  };

  if(sscanf(&input_line[0],"%e",float_number)<1)
  {
    printf("Error in input file format\n");
    printf("Program will be terminated.\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
  };

};
/* -------------------------------------------------------------------- */





/* ------------------------------------------------------------- */
void terminate_program(void)
{

  if(window_handle != NULL)
  {
    CloseWindow(window_handle);
    DestroyWindow(window_handle);
  }
  if(memory_bitmap != NULL) DeleteObject(memory_bitmap);
  if(memory_bitmap_untouched != NULL) DeleteObject(memory_bitmap_untouched);
  if(memory_device_context != NULL) DeleteDC(memory_device_context);
  if(memory_device_context_untouched != NULL) DeleteDC(memory_device_context_untouched);
  if(memory_device_context_blank != NULL) DeleteDC(memory_device_context_blank);
  if(window_device_context != NULL) DeleteDC(window_device_context);

  exit(0);
}
/* ------------------------------------------------------------- */





/* ------------------------------------------------- */
int is_whitespace(char *test_char)
{
/*
  This procedure returns 1 if test_char is whitespace
  (space, tab, newline, carriage feed), or 0
  otherwise.
*/

if( (*test_char==' ') || (*test_char=='\t') ||
    (*test_char=='\r') ||
    (*test_char=='\n') || (*test_char=='\f') )
{
  return 1;
}
else
{
  return 0;
}

} // end is_whitespace
/* --------------------------------------------------- */




/* --------------------------------------------------------- */
void skip_comments(FILE *input_file,int max_length,
  char *input_line)
{
    do
    {
      if(fgets(input_line,max_length,input_file)==NULL)
      {
        report_file_format_error();
      }
    }
    while
    (
      *input_line=='#'
    );

} // end skip_comments
/* --------------------------------------------------------- */




/* --------------------------------------------------------- */
void report_file_format_error(void)
{
    printf("Error in input file format\n");
    printf("Program will be terminated.\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    terminate_program();
} // end report_file_format_error
/* ---------------------------------------------------------- */




// ------------------------------------------------------------------
LRESULT CALLBACK window_callback_function(
    HWND hwnd,        // handle to window
    UINT uMsg,        // message identifier
    WPARAM wParam,    // first message parameter
    LPARAM lParam)    // second message parameter
{

HRGN save_clip_rect,temp_clip_rect;
int int_ret;

    switch (uMsg)
    {

        case WM_PAINT:

// Temporarily expand clipping region to include all of client area
// This is so that all of plot will be transferred to window_device_context
          temp_clip_rect = CreateRectRgn(Client_Rect.left,Client_Rect.top,
            Client_Rect.right,Client_Rect.bottom);
          if(temp_clip_rect==NULL)
          {
            printf("Error in CreateRectRgn in window callback function\n");
            printf("Program will be terminated\n");
            printf("Press any A/N key to continue\n");
            wait_for_key_pressed();
//            exit(1);
            terminate_program();
          }

          int_ret = SelectClipRgn(memory_device_context,temp_clip_rect);
          if( (int_ret==NULLREGION) || (int_ret==ERROR) )
          {
            printf("Error with memory_device_context SelectClipRgn in WM_PAINT interrupt\n");
            printf("Program will be terminated\n");
            printf("Press any A/N key to continue\n");
            wait_for_key_pressed();
//            exit(1);
            terminate_program();
          }

          int_ret = SelectClipRgn(window_device_context,temp_clip_rect);
          if( (int_ret==NULLREGION) || (int_ret==ERROR) )
          {
            printf("Error with window_device_context SelectClipRgn in WM_PAINT interrupt\n");
            if(int_ret==NULLREGION)
            {
              printf("NULLREGION error\n");
            }
            if(int_ret==COMPLEXREGION)
            {
              printf("COMPLEXREGION error\n");
            }
            if(int_ret==ERROR)
            {
              printf("ERROR error\n");
            }
            printf("Program will be terminated\n");
            printf("Press any A/N key to continue\n");
            wait_for_key_pressed();
//            exit(1);
            terminate_program();
          }

          transfer_device_context(memory_device_context,
            window_device_context,Client_Rect.left,Client_Rect.top,
            width_dc,height_dc);
          // so that we don't keep getting WM_PAINT interrupts:
          ValidateRgn(hwnd,NULL);

// restore original clipping region:
//          int_ret = SelectClipRgn(memory_device_context,save_clip_rect);
//          if( (int_ret==NULLREGION) || (int_ret==COMPLEXREGION) || (int_ret==ERROR) )
//          {
//            printf("Error with SelectClipRgn in WM_PAINT interrupt\n");
//            exit(1);
//          }
          if(temp_clip_rect!=NULL) DeleteObject(temp_clip_rect);
          if(save_clip_rect!=NULL) DeleteObject(save_clip_rect);

          return DefWindowProc(hwnd, uMsg, wParam, lParam);

        case WM_ERASEBKGND:
          return DefWindowProc(hwnd, uMsg, wParam, lParam);

        case WM_KEYDOWN:

          event_type = KeyPressEvent;
          window_keycode = wParam;

          return DefWindowProc(hwnd, uMsg, wParam, lParam);


         case WM_LBUTTONDOWN:
           button = BUTTON1;
           event_type = ButtonPressEvent;
           return DefWindowProc(hwnd, uMsg, wParam, lParam);

         case WM_LBUTTONUP:
           button = 0;
           event_type = ButtonReleaseEvent;
           return DefWindowProc(hwnd, uMsg, wParam, lParam);

         case WM_RBUTTONDOWN:
//           button = BUTTON3;
//           event_type = ButtonPressEvent;
           return DefWindowProc(hwnd, uMsg, wParam, lParam);

         case WM_RBUTTONUP:
//           button = 0;
//           event_type = ButtonReleaseEvent;
           return DefWindowProc(hwnd, uMsg, wParam, lParam);

         case WM_MOUSEMOVE:
           mouse_x = LOWORD(lParam);
           mouse_y = HIWORD(lParam);
//           return 0;
           return DefWindowProc(hwnd, uMsg, wParam, lParam);



//        //
//        // Process other messages.
//        //

        default:
//          printf("Default interrupt\n");
          return DefWindowProc(hwnd, uMsg, wParam, lParam);
    }
//    return 0;
}
// ------------------------------------------------------------------







int main(int argc, char *argv[])
{

  pi=4.0*atanl(1.0);
  THD=0;
  iavg_wfms=1;
  iavg_cnt=0;
  graphics_window_created=0;
  init_plot=0;

  scale_wf1 = 1.0;
  scale_wf2 = 1.0;

  ln_10=log(10.0);
  graphics_window_end();

  Quit_str[0] = 'Q';
  Quit_str[1] = '\0';
  quit_str[0] = 'q';
  quit_str[1] = '\0';

  filename[0] = 't';
  filename[1] = 'f';
  filename[2] = '_';
  filename[3] = 'w';
  filename[4] = 'i';
  filename[5] = 'n';
  filename[6] = '.';
  filename[7] = 'i';
  filename[8] = 'n';
  filename[9] = '\0';

  if( (input_file=fopen(&filename[0],"r")) != NULL)
  { /* input file exists */

    skip_comments(input_file,MAX_LINE_LENGTH-1,input_line);
    if(sscanf(&input_line[0],"%Le",&sampling_rate)<0.0)
    {
      report_file_format_error();
    }
    delt = 1.0/sampling_rate;

    skip_comments(input_file,MAX_LINE_LENGTH-1,input_line);
    if(sscanf(&input_line[0],"%ld",&num_meas_points)<1)
    {
      report_file_format_error();
    }

    i=1;
    j=0;
    do
    {
      i *= 2;
      j++;
    }
    while(
      !(
         (i >= num_meas_points)
       )
    );
    if(i != num_meas_points)
    {
      printf("Error - num_meas_points is not a power of 2\n");
      end_program();
    }

    delf_minp = num_meas_points;
    delf_minp = 1.0 / (delf_minp * delt);

// color parameters:
    skip_comments(input_file,MAX_LINE_LENGTH-1,input_line);
    if(sscanf(&input_line[0],"%d%d%d",&foreground_color_components[0],
    &foreground_color_components[1],&foreground_color_components[2])<3)
    {
      report_file_format_error();
    }

    skip_comments(input_file,MAX_LINE_LENGTH-1,input_line);
    if(sscanf(&input_line[0],"%d%d%d",&background_color_components[0],
    &background_color_components[1],&background_color_components[2])<3)
    {
      report_file_format_error();
    }

// end color parameters

// plot view extents parameters
    skip_comments(input_file,MAX_LINE_LENGTH-1,input_line);
    if(sscanf(&input_line[0],"%d%d",&minx_div,&minx_mult)<2)
    {
      report_file_format_error();
    }

    skip_comments(input_file,MAX_LINE_LENGTH-1,input_line);
    if(sscanf(&input_line[0],"%d%d",&maxx_div,&maxx_mult)<2)
    {
      report_file_format_error();
    }

/* note: miny is at bottom of screen, it is actually larger than maxy: */
    skip_comments(input_file,MAX_LINE_LENGTH-1,input_line);
    if(sscanf(&input_line[0],"%d%d",&miny_div,&miny_mult)<2)
    {
      report_file_format_error();
    }

    skip_comments(input_file,MAX_LINE_LENGTH-1,input_line);
    if(sscanf(&input_line[0],"%d%d",&maxy_div,&maxy_mult)<2)
    {
      report_file_format_error();
    }
// end plot view extents parameters

  } /* input file exists */
  else
  { // input file not found
    printf("Error - input file not found\n");
    printf("Program will be terminated\n");
    printf("Press any A/N key to continue:\n");
    wait_for_key_pressed();
    exit(1);
  } // input file not found

  fclose(input_file);

  system("cls"); // clear the console screen

/* initialize plot parameters for plots vs. time: */
deltat=delt;
deltat1=delt;
deltat2=delt;
sampling_freq=1.0/delt;
interpolatet = 0; /* initilize to no interpolation */
int_divt = 1; /* time step divisor for interpolation (resampling) */
extend_ticst = 0;
ymaxt = 1.0;
ymint = -1.0;
xmint = 0.0;
xmaxt = (num_meas_points-1) * deltat;
nptst = num_meas_points;
num_ptst1=num_meas_points;
num_ptst2=num_meas_points;
num_ptst1=num_meas_points;
num_ptst2=num_meas_points;
num_ptsa1=num_meas_points;
num_ptsa2=num_meas_points;
n=num_meas_points;
freq_cutoff_avg = 1.0/(2.0*delt);
npts_cutoff_avg = nptst/2;
i_mint = 1;
i_maxt = nptst;
i_truncatet1 = nptst;
i_truncatet2 = nptst;
strt_valt = 0.0;

/* initialize plot parameters for FFT magnitude: */
deltaf = nptst;
deltaf = 1.0 / ( deltaf * deltat);
interpolatea = 0; /* no interpolation for FFT */
int_diva = 1; /* time step divisor for no interpolation */
extend_ticsa = 0;
ymaxa = 10.0;
ymina = -30.0;
xmina = 0.0;
nptsa = nptst;
xmaxa = ((nptsa / 2) - 1) * deltaf;
i_mina = 1; /* dc frequency */
i_maxa = (nptsa / 2) + 1; /* folding frequency */
i_truncatea = i_maxa;
strt_vala = 0.0; /* start at dc */

tic_offset = 2; /* half of tic mark length in pixels */
ln_2 = logl(2.0);

/* initialize plot parameters for FFT phase: */
interpolatep = 0; /* no interpolation for FFT */
int_divp = 1; /* time step divisor for no interpolation */
extend_ticsp = 0;
ymaxp = 200.0;
yminp = -200.0;
xminp = 0.0;
xmaxp = ((num_meas_points / 2) - 1) * deltaf;
nptsp = nptst;
i_minp = 1; /* dc frequency */
i_maxp = (num_meas_points / 2) + 1; /* folding frequency */
i_truncatep = i_maxp;

  ascii_main_menu='0';
  do
  {  // main_menu loop

    system("cls"); // clear the console screen

    printf("T for time waveforms menu\n");
    printf("F for FFT menu\n");

    printf("B to toggle binary/ascii rw option");
    if(i_rw_bin_ascii==1)
    {
      printf(" (binary-ri selected)\n");
    }
    else if(i_rw_bin_ascii==2)
    {
      printf(" (ascii-magph selected)\n");
    }
    else
    {
      printf(" (Error - not properly assigned)\n");
    }

    printf("Q to quit program\n");

    ascii_main_menu=wait_for_char_no_echo();
    if(ascii_main_menu==0)
    { // extended scan code
      ascii_main_menu=read_any_an_key(&keypressed);
    } // extended scan code




/* --------------------------------------- */
    if(toupper(ascii_main_menu)=='B')
    {
      i_rw_bin_ascii++;
      if(i_rw_bin_ascii>2) i_rw_bin_ascii=1;
    }
/* --------------------------------------- */




/* ------------------------------------------------------------- */
    if(my_toupper(ascii_main_menu)=='T')
    { // byte_in = 'T'
      time_waveforms_menu();
    } // byte_in = 'T'
/* ------------------------------------------------------------- */




/* ------------------------------------------------------------- */
    if(my_toupper(ascii_main_menu)=='F')
    { // byte_in = 'F'
      fft_menu();
    } // byte_in = 'F'
/* ------------------------------------------------------------- */



/* -------------------------------------------------------------- */
    if(my_toupper(ascii_main_menu)=='Q')
    { // byte_in = 'Q'

      terminate_program();

    } // byte_in = 'Q'
/* ------------------------------------------------------------- */

  } // main_menu loop
  while
  (
    my_toupper(ascii_main_menu) != 'Q'
  );

  terminate_program();

  return 0;

}

